# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

import os
from stat import ST_MTIME

def help():
    print 'All fns have a file open for writing as first parameter'
    print 'pack(f, fullname, name): pack fullname as name'
    print 'packsome(f, directory, namelist): selected files from directory'
    print 'packall(f, directory): pack all files from directory'
    print 'packnotolder(f, directory, name): pack all files from directory'
    print '                        that are not older than a file there'
    print 'packtree(f, directory): pack entire directory tree'


def pack(outfp, file, name):
    fp = open(file, 'r')
    outfp.write('echo ' + name + '\n')
    outfp.write('sed "s/^X//" >"' + name + '" <<"!"\n')
    while None:
        line = fp.readline()
        if not line:
            break
        
        if line[-1:] != '\n':
            line = line + '\n'
        
    outfp.write('!\n')
    fp.close()


def packsome(outfp, dirname, names):
    for name in names:
        print name
        file = os.path.join(dirname, name)
        pack(outfp, file, name)
    


def packall(outfp, dirname):
    names = os.listdir(dirname)
    
    try:
        names.remove('.')
    except:
        pass

    
    try:
        names.remove('..')
    except:
        pass

    names.sort()
    packsome(outfp, dirname, names)


def packnotolder(outfp, dirname, oldest):
    names = os.listdir(dirname)
    
    try:
        names.remove('.')
    except:
        pass

    
    try:
        names.remove('..')
    except:
        pass

    oldest = os.path.join(dirname, oldest)
    st = os.stat(oldest)
    mtime = st[ST_MTIME]
    todo = []
    for name in names:
        print name, '...',
        st = os.stat(os.path.join(dirname, name))
        if st[ST_MTIME] >= mtime:
            print 'Yes.'
            todo.append(name)
            continue
        print 'No.'
    
    todo.sort()
    packsome(outfp, dirname, todo)


def packtree(outfp, dirname):
    print 'packtree', dirname
    outfp.write('mkdir ' + unixfix(dirname) + '\n')
    names = os.listdir(dirname)
    
    try:
        names.remove('.')
    except:
        pass

    
    try:
        names.remove('..')
    except:
        pass

    subdirs = []
    for name in names:
        fullname = os.path.join(dirname, name)
        if os.path.isdir(fullname):
            subdirs.append(fullname)
            continue
        print 'pack', fullname
        pack(outfp, fullname, unixfix(fullname))
    
    for subdirname in subdirs:
        packtree(outfp, subdirname)
    


def unixfix(name):
    comps = name.split(os.sep)
    res = ''
    for comp in comps:
        if comp:
            if res:
                res = res + '/'
            
            res = res + comp
            continue
    
    return res

