# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

from random import randrange, shuffle, choice

class PiecePicker:
    
    def __init__(self, numpieces, rarest_first_cutoff = 1):
        self.rarest_first_cutoff = rarest_first_cutoff
        self.numpieces = numpieces
        self.interests = [
            range(numpieces)]
        self.pos_in_interests = range(numpieces)
        self.numinterests = [
            0] * numpieces
        self.started = []
        self.seedstarted = []
        self.numgot = 0
        self.scrambled = range(numpieces)
        shuffle(self.scrambled)

    
    def got_have(self, piece):
        if self.numinterests[piece] is None:
            return None
        
        numint = self.numinterests[piece]
        if numint == len(self.interests) - 1:
            self.interests.append([])
        
        self.numinterests[piece] += 1
        self._shift_over(piece, self.interests[numint], self.interests[numint + 1])

    
    def lost_have(self, piece):
        if self.numinterests[piece] is None:
            return None
        
        numint = self.numinterests[piece]
        self.numinterests[piece] -= 1
        self._shift_over(piece, self.interests[numint], self.interests[numint - 1])

    
    def _shift_over(self, piece, l1, l2):
        p = self.pos_in_interests[piece]
        l1[p] = l1[-1]
        self.pos_in_interests[l1[-1]] = p
        del l1[-1]
        newp = randrange(len(l2) + 1)
        if newp == len(l2):
            self.pos_in_interests[piece] = len(l2)
            l2.append(piece)
        else:
            old = l2[newp]
            self.pos_in_interests[old] = len(l2)
            l2.append(old)
            l2[newp] = piece
            self.pos_in_interests[piece] = newp

    
    def requested(self, piece, seed = False):
        if piece not in self.started:
            self.started.append(piece)
        
        if seed and piece not in self.seedstarted:
            self.seedstarted.append(piece)
        

    
    def complete(self, piece):
        if not self.numinterests[piece] is not None:
            raise AssertionError
        self.numgot += 1
        l = self.interests[self.numinterests[piece]]
        p = self.pos_in_interests[piece]
        l[p] = l[-1]
        self.pos_in_interests[l[-1]] = p
        del l[-1]
        self.numinterests[piece] = None
        
        try:
            self.started.remove(piece)
            self.seedstarted.remove(piece)
        except ValueError:
            self
            self
        except:
            self


    
    def next(self, havefunc, seed = False):
        bests = None
        bestnum = 2 ** 30
        if seed:
            s = self.seedstarted
        else:
            s = self.started
        for i in s:
            if havefunc(i):
                if self.numinterests[i] < bestnum:
                    bests = [
                        i]
                    bestnum = self.numinterests[i]
                elif self.numinterests[i] == bestnum:
                    bests.append(i)
                
            self.numinterests[i] < bestnum
        
        if bests:
            return choice(bests)
        
        if self.numgot < self.rarest_first_cutoff:
            for i in self.scrambled:
                if havefunc(i):
                    return i
                    continue
            
            return None
        
        for i in xrange(1, min(bestnum, len(self.interests))):
            for j in self.interests[i]:
                if havefunc(j):
                    return j
                    continue
            
        

    
    def am_I_complete(self):
        return self.numgot == self.numpieces

    
    def bump(self, piece):
        l = self.interests[self.numinterests[piece]]
        pos = self.pos_in_interests[piece]
        del l[pos]
        l.append(piece)
        for i in range(pos, len(l)):
            self.pos_in_interests[l[i]] = i
        



def test_requested():
    p = PiecePicker(9)
    p.complete(8)
    p.got_have(0)
    p.got_have(2)
    p.got_have(4)
    p.got_have(6)
    p.requested(1)
    p.requested(1)
    p.requested(3)
    p.requested(0)
    p.requested(6)
    v = _pull(p)
    if not v[:2] == [
        1,
        3] and v[:2] == [
        3,
        1]:
        raise AssertionError
    if not v[2:4] == [
        0,
        6] and v[2:4] == [
        6,
        0]:
        raise AssertionError
    if not v[4:] == [
        2,
        4] and v[4:] == [
        4,
        2]:
        raise AssertionError


def test_change_interest():
    p = PiecePicker(9)
    p.complete(8)
    p.got_have(0)
    p.got_have(2)
    p.got_have(4)
    p.got_have(6)
    p.lost_have(2)
    p.lost_have(6)
    v = _pull(p)
    if not v == [
        0,
        4] and v == [
        4,
        0]:
        raise AssertionError


def test_change_interest2():
    p = PiecePicker(9)
    p.complete(8)
    p.got_have(0)
    p.got_have(2)
    p.got_have(4)
    p.got_have(6)
    p.lost_have(2)
    p.lost_have(6)
    v = _pull(p)
    if not v == [
        0,
        4] and v == [
        4,
        0]:
        raise AssertionError


def test_complete():
    p = PiecePicker(1)
    p.got_have(0)
    p.complete(0)
    if not _pull(p) == []:
        raise AssertionError
    p.got_have(0)
    p.lost_have(0)


def test_rarer_in_started_takes_priority():
    p = PiecePicker(3)
    p.complete(2)
    p.requested(0)
    p.requested(1)
    p.got_have(1)
    p.got_have(0)
    p.got_have(0)
    if not _pull(p) == [
        1,
        0]:
        raise AssertionError


def test_zero():
    if not _pull(PiecePicker(0)) == []:
        raise AssertionError


def _pull(pp):
    r = []
    
    def want(p, r = r):
        return p not in r

    while True:
        n = pp.next(want)
        if n is None:
            break
        
        r.append(n)
    return r

