# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

from types import *
from cStringIO import StringIO

def formatDefinitions(options, COLS):
    s = StringIO()
    indent = ' ' * 10
    width = COLS - 11
    if width < 15:
        width = COLS - 2
        indent = ' '
    
    for longname, default, doc in options:
        s.write('--' + longname + ' <arg>\n')
        if default is not None:
            doc += ' (defaults to ' + repr(default) + ')'
        
        i = 0
        for word in doc.split():
            if i == 0:
                s.write(indent + word)
                i = len(word)
                continue
            if i + len(word) >= width:
                s.write('\n' + indent + word)
                i = len(word)
                continue
            s.write(' ' + word)
            i += len(word) + 1
        
        s.write('\n\n')
    
    return s.getvalue()


def usage(str):
    raise ValueError(str)


def parseargs(argv, options, minargs = None, maxargs = None):
    config = { }
    longkeyed = { }
    for option in options:
        (longname, default, doc) = option
        longkeyed[longname] = option
        config[longname] = default
    
    options = []
    args = []
    pos = 0
    while pos < len(argv):
        if argv[pos][:2] != '--':
            args.append(argv[pos])
            pos += 1
            continue
        if pos == len(argv) - 1:
            usage('parameter passed in at end with no value')
        
        key = argv[pos][2:]
        value = argv[pos + 1]
        pos += 2
        if not longkeyed.has_key(key):
            usage('unknown key --' + key)
        
        (longname, default, doc) = longkeyed[key]
        
        try:
            t = type(config[longname])
            if t is NoneType or t is StringType:
                config[longname] = value
            elif t in (IntType, LongType):
                config[longname] = long(value)
            elif t is FloatType:
                config[longname] = float(value)
            elif not 0:
                raise AssertionError
        continue
        except ValueError:
            e = None
            usage('wrong format of --%s - %s' % (key, str(e)))
            continue
        

        None<EXCEPTION MATCH>ValueError
    for key, value in config.items():
        if value is None:
            usage('Option --%s is required.' % key)
            continue
    
    if minargs is not None and len(args) < minargs:
        usage('Must supply at least %d args.' % minargs)
    
    if maxargs is not None and len(args) > maxargs:
        usage('Too many args - %d max.' % maxargs)
    
    return (config, args)


def test_parseargs():
    if not parseargs(('d', '--a', 'pq', 'e', '--b', '3', '--c', '4.5', 'f'), (('a', 'x', ''), ('b', 1, ''), ('c', 2.2999999999999998, ''))) == ({
        'a': 'pq',
        'b': 3,
        'c': 4.5 }, [
        'd',
        'e',
        'f']):
        raise AssertionError
    if not parseargs([], [
        ('a', 'x', '')]) == ({
        'a': 'x' }, []):
        raise AssertionError
    if not parseargs([
        '--a',
        'x',
        '--a',
        'y'], [
        ('a', '', '')]) == ({
        'a': 'y' }, []):
        raise AssertionError
    
    try:
        parseargs([], [
            ('a', 'x', '')])
    except ValueError:
        pass

    
    try:
        parseargs([
            '--a',
            'x'], [])
    except ValueError:
        pass

    
    try:
        parseargs([
            '--a'], [
            ('a', 'x', '')])
    except ValueError:
        pass

    
    try:
        parseargs([], [], 1, 2)
    except ValueError:
        pass

    if not parseargs([
        'x'], [], 1, 2) == ({ }, [
        'x']):
        raise AssertionError
    if not parseargs([
        'x',
        'y'], [], 1, 2) == ({ }, [
        'x',
        'y']):
        raise AssertionError
    
    try:
        parseargs([
            'x',
            'y',
            'z'], [], 1, 2)
    except ValueError:
        pass

    
    try:
        parseargs([
            '--a',
            '2.0'], [
            ('a', 3, '')])
    except ValueError:
        pass

    
    try:
        parseargs([
            '--a',
            'z'], [
            ('a', 2.1000000000000001, '')])
    except ValueError:
        pass


