# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

import thread
import urllib2
import os
import string
import apt_pkg
import time
import sys
import rfc822
from subprocess import Popen, PIPE

class Dist(object):
    
    def __init__(self, name, version, date, supported):
        self.name = name
        self.version = version
        self.date = date
        self.supported = supported
        self.releaseNotesURI = None
        self.upgradeTool = None
        self.upgradeToolSig = None



class MetaReleaseCore(object):
    METARELEASE_URI = 'http://changelogs.ubuntu.com/meta-release'
    METARELEASE_URI_UNSTABLE = 'http://changelogs.ubuntu.com/meta-release-development'
    METARELEASE_URI_PROPOSED = 'http://changelogs.ubuntu.com/meta-release-proposed'
    METARELEASE_FILE = '/var/lib/update-manager/meta-release'
    
    def __init__(self, useDevelopmentRelease = False, useProposed = False):
        if useDevelopmentRelease:
            self.METARELEASE_URI = self.METARELEASE_URI_UNSTABLE
        elif useProposed:
            self.METARELEASE_URI = self.METARELEASE_URI_PROPOSED
        
        
        try:
            open(self.METARELEASE_FILE, 'a')
        except IOError:
            e = None
            path = os.path.expanduser('~/.update-manager-core/')
            if not os.path.exists(path):
                os.mkdir(path)
            
            self.METARELEASE_FILE = os.path.join(path, 'meta-release')

        self.metarelease_information = None
        self.downloading = True
        self.new_dist = None
        self.no_longer_supported = None
        t = thread.start_new_thread(self.download, ())

    
    def dist_no_longer_supported(self, dist):
        ''' virtual function that is called when the distro is no longer
            supported
        '''
        self.no_longer_supported = dist

    
    def new_dist_available(self, dist):
        ''' virtual function that is called when a new distro release
            is available
        '''
        self.new_dist = dist

    
    def get_dist(self):
        ''' return the codename of the current runing distro '''
        p = Popen([
            'lsb_release',
            '-c',
            '-s'], stdout = PIPE)
        res = p.wait()
        if res != 0:
            sys.stderr.write('lsb_release returned exitcode: %i\n' % res)
            return 'unknown distribution'
        
        dist = string.strip(p.stdout.readline())
        return dist

    
    def parse(self):
        current_dist_name = self.get_dist()
        current_dist = None
        dists = []
        index_tag = apt_pkg.ParseTagFile(self.metarelease_information)
        step_result = index_tag.Step()
        while step_result:
            if index_tag.Section.has_key('Dist'):
                name = index_tag.Section['Dist']
                rawdate = index_tag.Section['Date']
                date = time.mktime(rfc822.parsedate(rawdate))
                supported = bool(index_tag.Section['Supported'])
                version = index_tag.Section['Version']
                dist = Dist(name, version, date, supported)
                if index_tag.Section.has_key('ReleaseNotes'):
                    dist.releaseNotesURI = index_tag.Section['ReleaseNotes']
                
                if index_tag.Section.has_key('UpgradeTool'):
                    dist.upgradeTool = index_tag.Section['UpgradeTool']
                
                if index_tag.Section.has_key('UpgradeToolSignature'):
                    dist.upgradeToolSig = index_tag.Section['UpgradeToolSignature']
                
                dists.append(dist)
                if name == current_dist_name:
                    current_dist = dist
                
            
            step_result = index_tag.Step()
        if current_dist == None:
            print 'current dist not found in meta-release file'
            return False
        
        upgradable_to = ''
        for dist in dists:
            if dist.date > current_dist.date and dist.supported == True:
                upgradable_to = dist
                break
                continue
        
        if upgradable_to != '' and not (current_dist.supported):
            self.dist_no_longer_supported(upgradabl_to)
        elif upgradable_to != '':
            self.new_dist_available(upgradable_to)
        
        return True

    
    def download(self):
        lastmodified = 0
        req = urllib2.Request(self.METARELEASE_URI)
        req.add_header('Cache-Control', 'No-Cache')
        req.add_header('Pragma', 'no-cache')
        if os.access(self.METARELEASE_FILE, os.W_OK):
            lastmodified = os.stat(self.METARELEASE_FILE).st_mtime
        
        if lastmodified > 0:
            req.add_header('If-Modified-Since', time.asctime(time.gmtime(lastmodified)))
        
        
        try:
            uri = urllib2.urlopen(req)
            if os.path.exists(self.METARELEASE_FILE) and not os.access(self.METARELEASE_FILE, os.W_OK):
                
                try:
                    os.unlink(self.METARELEASE_FILE)
                except OSError:
                    e = None
                    print "Can't unlink '%s' (%s)" % (self.METARELEASE_FILE, e)
                except:
                    None<EXCEPTION MATCH>OSError
                

            None<EXCEPTION MATCH>OSError
            f = open(self.METARELEASE_FILE, 'w+')
            for line in uri.readlines():
                f.write(line)
            
            f.flush()
            f.seek(0, 0)
            self.metarelease_information = f
            uri.close()
        except urllib2.URLError:
            if os.path.exists(self.METARELEASE_FILE):
                self.metarelease_information = open(self.METARELEASE_FILE, 'r')
            
        except:
            os.path.exists(self.METARELEASE_FILE)

        if self.metarelease_information != None:
            self.parse()
        
        self.downloading = False


