# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

import string
import Printer
from xml.dom import XHTML_NAMESPACE
from xml.dom.html import HTML_FORBIDDEN_END

class HtmlDocType:
    name = 'HTML'
    publicId = '-//W3C//DTD HTML 4.0//EN'
    systemId = 'http://www.w3.org/TR/REC-html40/strict.dtd'
    entities = notations = []


class HtmlAttr:
    
    def __init__(self, node):
        self.namespaceURI = None
        if not node.localName:
            pass
        self.name = string.upper(node.nodeName)
        self.value = node.value



class HtmlElement:
    
    def __init__(self, node):
        if not node.localName:
            pass
        self.tagName = string.upper(node.nodeName)
        self.childNodes = node.childNodes
        self.attributes = node.attributes



class XHtml2HtmlPrintVisitor(Printer.PrintVisitor):
    
    def __init__(self, stream, encoding, indent = '', plainElements = None):
        Printer.PrintVisitor.__init__(self, stream, encoding, indent, plainElements)
        self._html = 1

    
    def visitDocument(self, doc):
        self.visitDocumentType(HtmlDocType)
        self.visitNodeList(doc.childNodes, exclude = doc.doctype)

    
    def visitAttr(self, node):
        if node.namespaceURI and node.namespaceURI != XHTML_NAMESPACE:
            return None
        
        Printer.PrintVisitor.visitAttr(self, HtmlAttr(node))

    
    def visitElement(self, node):
        if node.namespaceURI and node.namespaceURI != XHTML_NAMESPACE:
            return None
        
        htmlElement = HtmlElement(node)
        if htmlElement.tagName == 'XHTML':
            htmlElement.tagName = 'HTML'
        
        Printer.PrintVisitor.visitElement(self, htmlElement)


