# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

import string
import Printer
from xml.dom import XHTML_NAMESPACE

class XHtmlDocType:
    
    def __init__(self, doctype):
        self.name = 'html'
        self.publicId = '-//W3C//DTD XHTML 1.0 Strict//EN'
        self.systemId = 'DTD/xhtml1-strict.dtd'
        if not doctype or doctype.entities:
            pass
        self.entities = []
        if not doctype or doctype.notation:
            pass
        self.notations = []



class XHtmlAttr:
    
    def __init__(self, node):
        self.namespaceURI = XHTML_NAMESPACE
        self.name = string.lower(node.name)
        self.node = node

    
    def __getattr__(self, key):
        return getattr(self.node, key)



class XHtmlElement:
    
    def __init__(self, node):
        self.tagName = string.lower(node.tagName)
        self.node = node

    
    def __getattr__(self, key):
        return getattr(self.node, key)



class XHtmlPrintVisitor(Printer.PrintVisitor):
    
    def __init__(self, stream, encoding, indent):
        xhtml = {
            None: 'http://www.w3.org/1999/xhtml' }
        Printer.PrintVisitor.__init__(self, stream, encoding, indent, nsHints = xhtml)
        self._html = 0

    
    def visitDocument(self, node):
        self.visitProlog()
        self._tryIndent()
        self.visitDocumentType(XHtmlDocType(node.doctype))
        self.visitNodeList(node.childNodes, exclude = node.doctype)

    
    def visitAttr(self, node):
        Printer.PrintVisitor.visitAttr(self, XHtmlAttr(node))

    
    def visitElement(self, node):
        Printer.PrintVisitor.visitElement(self, XHtmlElement(node))


