# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

'''
Components for reading HTML files using htmllib.py.
WWW: http://4suite.com/4DOM         e-mail: support@4suite.com

Copyright (c) 2000 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
'''
import os
import urllib
from xml.dom.ext import reader
from xml.dom import Node
import Sgmlop

class Reader(reader.Reader):
    
    def __init__(self):
        self.parser = Sgmlop.HtmlParser()

    
    def fromStream(self, stream, ownerDoc = None, charset = ''):
        self.parser.initParser()
        self.parser.initState(ownerDoc, charset)
        self.parser.parse(stream)
        frag = self.parser.rootNode
        if ownerDoc is None:
            doc = frag.ownerDocument
            for child in frag.childNodes:
                if child.nodeType == Node.ELEMENT_NODE and child.tagName == 'HTML':
                    while doc.documentElement.firstChild:
                        c = doc.documentElement.removeChild(doc.documentElement.firstChild)
                        self.releaseNode(c)
                    while child.firstChild:
                        doc.documentElement.appendChild(child.firstChild)
                    self.releaseNode(frag)
                    return doc
                    continue
            
            body = doc.documentElement.lastChild
            body.appendChild(frag)
            self.releaseNode(frag)
            return doc
        else:
            return frag

    
    def fromUri(self, uri, ownerDoc = None, charset = ''):
        stream = reader.BASIC_RESOLVER.resolve(uri)
        
        try:
            return self.fromStream(stream, ownerDoc, charset)
        finally:
            stream.close()


    
    def fromString(self, str, ownerDoc = None, charset = ''):
        stream = reader.StrStream(str)
        
        try:
            return self.fromStream(stream, ownerDoc, charset)
        finally:
            stream.close()




def FromHtmlStream(fp, ownerDoc = None, charset = ''):
    return Reader().fromStream(fp, ownerDoc, charset)


def FromHtmlFile(fileName, ownerDoc = None, charset = ''):
    return Reader().fromUri(fileName, ownerDoc, charset)


def FromHtmlUrl(url, ownerDoc = None, charset = ''):
    return Reader().fromUri(url, ownerDoc, charset)


def FromHtml(text, ownerDoc = None, charset = ''):
    return Reader().fromString(text, ownerDoc, charset)

