# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

'''
Components for reading XML files from PyExpat (Python 1.6, 2.0 or from PyXML).
WWW: http://4suite.com/4DOM         e-mail: support@4suite.com

Copyright (c) 2000-2001 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
'''
import os
import sys
import string
import cStringIO
from xml.dom import Entity, DocumentType, Document
from xml.dom import Node
from xml.dom import implementation
from xml.dom.ext import SplitQName, ReleaseNode
from xml.dom import XML_NAMESPACE, XMLNS_NAMESPACE
from xml.dom import Element
from xml.dom import Attr
from xml.dom.ext import reader
from xml.parsers import expat

class Reader(reader.Reader):
    
    def __init__(self):
        pass

    
    def initState(self, ownerDoc = None):
        self._ownerDoc = None
        self._rootNode = None
        self._nodeStack = []
        if ownerDoc:
            self._ownerDoc = ownerDoc
            self._rootNode = self._ownerDoc.createDocumentFragment()
            self._nodeStack.append(self._rootNode)
        
        self._dt = None
        self._xmlDecl = None
        self._orphanedNodes = []
        self._namespaces = {
            'xml': XML_NAMESPACE }
        self._namespaceStack = []
        self._currText = ''

    
    def initParser(self):
        self.parser = expat.ParserCreate()
        self.parser.buffer_text = 1
        self.parser.StartElementHandler = self.startElement
        self.parser.EndElementHandler = self.endElement
        self.parser.CharacterDataHandler = self.characters
        self.parser.ProcessingInstructionHandler = self.processingInstruction
        self.parser.CommentHandler = self.comment
        self.parser.StartCdataSectionHandler = self.startCDATA
        self.parser.EndCdataSectionHandler = self.endCDATA
        self.parser.NotationDeclHandler = self.notationDecl
        self.parser.UnparsedEntityDeclHandler = self.unparsedEntityDecl

    
    def fromStream(self, stream, ownerDoc = None):
        self.initParser()
        self.initState(ownerDoc)
        success = self.parser.ParseFile(stream)
        if not success:
            FtDomException = FtDomException
            import xml.dom.ext
            XML_PARSE_ERR = XML_PARSE_ERR
            import xml.dom
            if self._rootNode:
                ReleaseNode(self._rootNode)
            
            if self._ownerDoc:
                ReleaseNode(self._ownerDoc)
            
            raise FtDomException(XML_PARSE_ERR, (self.parser.ErrorLineNumber, self.parser.ErrorColumnNumber, expat.ErrorString(self.parser.ErrorCode)))
        
        self._completeTextNode()
        if not self._rootNode:
            pass
        return self._ownerDoc

    
    def _initRootNode(self, docElementUri, docElementName):
        if not self._dt:
            self._dt = implementation.createDocumentType(docElementName, '', '')
        
        self._ownerDoc = implementation.createDocument(docElementUri, docElementName, self._dt)
        before_doctype = 1
        for o_node in self._orphanedNodes:
            if o_node[0] == 'pi':
                pi = self._ownerDoc.createProcessingInstruction(o_node[1], o_node[2])
                if before_doctype:
                    self._ownerDoc.insertBefore(pi, self._dt)
                else:
                    self._ownerDoc.appendChild(pi)
            before_doctype
            if o_node[0] == 'comment':
                comment = self._ownerDoc.createComment(o_node[1])
                if before_doctype:
                    self._ownerDoc.insertBefore(comment, self._dt)
                else:
                    self._ownerDoc.appendChild(comment)
            before_doctype
            if o_node[0] == 'doctype':
                before_doctype = 0
                continue
        
        self._rootNode = self._ownerDoc
        self._nodeStack.append(self._rootNode)

    
    def _completeTextNode(self):
        if self._currText and len(self._nodeStack) and self._nodeStack[-1].nodeType != Node.DOCUMENT_NODE:
            new_text = self._ownerDoc.createTextNode(self._currText)
            self._nodeStack[-1].appendChild(new_text)
        
        self._currText = ''

    
    def processingInstruction(self, target, data):
        if self._rootNode:
            self._completeTextNode()
            pi = self._ownerDoc.createProcessingInstruction(target, data)
            self._nodeStack[-1].appendChild(pi)
        else:
            self._orphanedNodes.append(('pi', target, data))

    
    def startElement(self, name, attribs):
        self._completeTextNode()
        old_nss = { }
        del_nss = []
        for curr_attrib_key, value in attribs.items():
            (prefix, local) = SplitQName(curr_attrib_key)
            if local == 'xmlns':
                if self._namespaces.has_key(prefix):
                    old_nss[prefix] = self._namespaces[prefix]
                    if value:
                        self._namespaces[prefix] = attribs[curr_attrib_key]
                    else:
                        del self._namespaces[prefix]
                elif value:
                    self._namespaces[prefix] = attribs[curr_attrib_key]
                    del_nss.append(prefix)
                
            self._namespaces.has_key(prefix)
        
        self._namespaceStack.append((old_nss, del_nss))
        (prefix, local) = SplitQName(name)
        nameSpace = self._namespaces.get(prefix, None)
        if self._ownerDoc:
            if not prefix or prefix + ':' + local:
                pass
            new_element = self._ownerDoc.createElementNS(nameSpace, local)
        else:
            self._initRootNode(nameSpace, name)
            new_element = self._ownerDoc.documentElement
        for curr_attrib_key, curr_attrib_value in attribs.items():
            (prefix, local) = SplitQName(curr_attrib_key)
            qname = local
            if local == 'xmlns':
                namespace = XMLNS_NAMESPACE
                if prefix:
                    qname = local + ':' + prefix
                
                attr = self._ownerDoc.createAttributeNS(namespace, qname)
            elif not prefix or self._namespaces.get(prefix, None):
                pass
            namespace = None
            if prefix:
                qname = prefix + ':' + local
            
            attr = self._ownerDoc.createAttributeNS(namespace, qname)
            attr.value = curr_attrib_value
            new_element.setAttributeNodeNS(attr)
        
        self._nodeStack.append(new_element)

    
    def endElement(self, name):
        self._completeTextNode()
        new_element = self._nodeStack[-1]
        del self._nodeStack[-1]
        (old_nss, del_nss) = self._namespaceStack[-1]
        del self._namespaceStack[-1]
        self._namespaces.update(old_nss)
        for prefix in del_nss:
            del self._namespaces[prefix]
        
        if new_element != self._ownerDoc.documentElement:
            self._nodeStack[-1].appendChild(new_element)
        

    
    def characters(self, data):
        self._currText = self._currText + data

    
    def startDTD(self, doctype, publicID, systemID):
        if not self._rootNode:
            self._dt = implementation.createDocumentType(doctype, publicID, systemID)
            self._orphanedNodes.append('doctype')
        else:
            raise 'Illegal DocType declaration'

    
    def comment(self, text):
        if self._rootNode:
            self._completeTextNode()
            new_comment = self._ownerDoc.createComment(text)
            self._nodeStack[-1].appendChild(new_comment)
        else:
            self._orphanedNodes.append(('comment', text))

    
    def startCDATA(self):
        self._completeTextNode()

    
    def endCDATA(self):
        if self._currText:
            new_text = self._ownerDoc.createCDATASection(self._currText)
            self._nodeStack[-1].appendChild(new_text)
            self._currText = ''
        

    
    def notationDecl(self, name, base, publicId, systemId):
        new_notation = self._ownerDoc.getFactory().createNotation(self._ownerDoc, publicId, systemId, name)
        self._ownerDoc.getDocumentType().getNotations().setNamedItem(new_notation)

    
    def unparsedEntityDecl(self, name, base, publicId, systemId, notationName):
        new_notation = self._ownerDoc.getFactory().createEntity(self._ownerDoc, publicId, systemId, notationName)
        self._ownerDoc.getDocumentType().getEntities().setNamedItem(new_notation)


