# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

from types import *
import string
from xml.sax import saxlib, saxexts

def version_independent_cmp(a, b):
    ta = type(a)
    tb = type(b)
    if ta is not tb:
        return cmp(ta.__name__, tb.__name__)
    
    return cmp(a, b)


class Marshaller(saxlib.HandlerBase):
    PROLOGUE = '<?xml version="1.0"?>'
    DTD = ''
    tag_root = 'marshal'
    tag_int = 'int'
    tag_float = 'float'
    tag_long = 'long'
    tag_string = 'string'
    tag_tuple = 'tuple'
    tag_list = 'list'
    tag_dictionary = 'dictionary'
    tag_complex = 'complex'
    tag_reference = 'reference'
    tag_code = 'code'
    tag_none = 'none'
    tag_instance = 'object'
    
    def dump(self, value, file):
        '''Write the value on the open file'''
        dict = {
            'id': 1 }
        L = [
            self.PROLOGUE + self.DTD] + self.m_root(value, dict)
        file.write(string.join(L, ''))

    
    def dumps(self, value):
        '''Marshal value, returning the resulting string'''
        dict = {
            'id': 1 }
        L = [
            self.PROLOGUE + self.DTD] + self.m_root(value, dict)
        return string.join(L, '')

    
    def _marshal(self, value, dict):
        t = type(value)
        i = str(id(value))
        if dict.has_key(i):
            return self.m_reference(value, dict)
        elif type(value) is LongType:
            meth = 'm_long'
        else:
            meth = 'm_' + type(value).__name__
        return getattr(self, meth)(value, dict)

    
    def m_unimplemented(self, value, dict):
        raise ValueError, 'Marshalling of object ' + repr(value) + ' unimplemented or not supported in this DTD'

    
    def m_root(self, value, dict):
        name = self.tag_root
        L = [
            '<%s>' % name] + self._marshal(value, dict) + [
            '</%s>' % name]
        return L

    
    def m_reference(self, value, dict):
        i = dict[str(id(value))]
        return [
            '<' + self.tag_reference + ' id="i%s"/>' % (i,)]

    
    def m_string(self, value, dict):
        name = self.tag_string
        L = [
            '<' + name + '>']
        s = str(value)
        if '&' in s and '>' in s or '<' in s:
            s = string.replace(s, '&', '&amp;')
            s = string.replace(s, '<', '&lt;')
            s = string.replace(s, '>', '&gt;')
        
        L.append(s)
        L.append('</' + name + '>')
        return L

    
    def m_str(self, value, dict):
        return self.m_string(value, dict)

    
    def m_int(self, value, dict):
        name = self.tag_int
        return [
            '<' + name + '>' + str(value) + '</' + name + '>']

    
    def m_float(self, value, dict):
        name = self.tag_float
        return [
            '<' + name + '>' + str(value) + '</' + name + '>']

    
    def m_long(self, value, dict):
        name = self.tag_long
        value = str(value)
        if value[-1] == 'L':
            value = value[:-1]
        
        return [
            '<' + name + '>' + str(value) + '</' + name + '>']

    
    def m_tuple(self, value, dict):
        name = self.tag_tuple
        L = []
        L.append('<' + name + '>')
        for elem in value:
            L = L + self._marshal(elem, dict)
        
        L.append('</' + name + '>')
        return L

    
    def m_list(self, value, dict):
        name = self.tag_list
        L = []
        dict['id'] = dict['id'] + 1
        i = str(dict['id'])
        dict[str(id(value))] = i
        dict[i] = value
        L.append('<' + name + ' id="i%s">' % i)
        for elem in value:
            L = L + self._marshal(elem, dict)
        
        L.append('</' + name + '>')
        return L

    
    def m_dictionary(self, value, dict):
        name = self.tag_dictionary
        L = []
        dict['id'] = dict['id'] + 1
        i = str(dict['id'])
        dict[str(id(value))] = i
        dict[i] = value
        L.append('<' + name + ' id="i%s">' % (i,))
        items = value.items()
        items.sort(version_independent_cmp)
        for key, v in items:
            L = L + self._marshal(key, dict) + self._marshal(v, dict)
        
        L.append('</' + name + '>')
        return L

    
    def m_dict(self, value, dict):
        return self.m_dictionary(value, dict)

    
    def m_None(self, value, dict):
        return [
            '<' + self.tag_none + '/>']

    
    def m_NoneType(self, value, dict):
        return self.m_None(value, dict)

    
    def m_complex(self, value, dict):
        name = self.tag_complex
        return [
            '<' + name + '>' + str(value.real) + ' ' + str(value.imag) + '</' + name + '>']

    
    def m_code(self, value, dict):
        name = self.tag_code
        L = []
        import marshal
        import base64
        L.append('<code>')
        s = marshal.dumps(value)
        s = base64.encodestring(s)
        L.append(s)
        L.append('</code>')
        return L

    
    def m_instance(self, value, dict):
        name = self.tag_instance
        L = []
        dict['id'] = dict['id'] + 1
        i = str(dict['id'])
        dict[str(id(value))] = i
        dict[i] = value
        cls = value.__class__
        L.append('<%s id="i%s" module="%s" class="%s">' % (name, i, cls.__module__, cls.__name__))
        if hasattr(value, '__getinitargs__'):
            args = value.__getinitargs__()
            len(args)
        else:
            args = ()
        L = L + self._marshal(args, dict)
        
        try:
            getstate = value.__getstate__
        except AttributeError:
            stuff = value.__dict__

        stuff = getstate()
        L = L + self._marshal(stuff, dict)
        L.append('</%s>' % name)
        return L


TUPLE = { }
LIST = { }
DICT = { }

class Unmarshaller(saxlib.HandlerBase):
    unmarshal_meth = {
        'marshal': ('um_start_root', None),
        'int': ('um_start_int', 'um_end_int'),
        'float': ('um_start_float', 'um_end_float'),
        'long': ('um_start_long', 'um_end_long'),
        'string': ('um_start_string', 'um_end_string'),
        'tuple': ('um_start_tuple', 'um_end_tuple'),
        'list': ('um_start_list', 'um_end_list'),
        'dictionary': ('um_start_dictionary', 'um_end_dictionary'),
        'complex': ('um_start_complex', 'um_end_complex'),
        'reference': ('um_start_reference', None),
        'code': ('um_start_code', 'um_end_code'),
        'none': ('um_start_none', 'um_end_none'),
        'object': ('um_start_instance', 'um_end_instance') }
    
    def __init__(self):
        d = { }
        for sm, em in self.unmarshal_meth.items():
            if sm is not None:
                sm = getattr(self, sm)
            
            if em is not None:
                em = getattr(self, em)
            
            d[key] = (sm, em)
        
        self.unmarshal_meth = d
        self._clear()

    
    def _clear(self):
        '''
        Protected method to (re)initialize the object into
        a steady state. Performed by __init__ and _load.
        '''
        self.data_stack = []
        self.dict = { }
        self.accumulating_chars = 0

    
    def load(self, file):
        '''Unmarshal one value, reading it from a file-like object'''
        m = self.__class__()
        return m._load(file)

    
    def loads(self, string):
        '''Unmarshal one value from a string'''
        m = self.__class__()
        import StringIO
        file = StringIO.StringIO(string)
        return m._load(file)

    
    def _load(self, file):
        '''Read one value from the open file'''
        p = saxexts.make_parser()
        p.setDocumentHandler(self)
        p.parseFile(file)
        if not len(self.data_stack) == 1:
            raise AssertionError
        result = self.data_stack[0]
        self._clear()
        return result

    
    def find_class(self, module, name):
        env = { }
        
        try:
            exec 'from %s import %s' % (module, name) in env
        except ImportError:
            raise SystemError, 'Failed to import class %s from module %s' % (name, module)

        return env[name]

    
    def startElement(self, name, attrs):
        (sm, em) = self.unmarshal_meth[name]
        if sm is not None:
            return sm(name, attrs)
        

    
    def characters(self, ch, start, length):
        if self.accumulating_chars:
            self.data_stack[-1].append(ch[start:start + length])
        

    
    def endElement(self, name):
        (sm, em) = self.unmarshal_meth[name]
        if em is not None:
            em(name)
        

    
    def um_start_root(self, name, attrs):
        if self.dict or self.data_stack:
            raise ValueError, 'root element %s found elsewhere than root' % repr(name)
        

    
    def um_start_reference(self, name, attrs):
        if not attrs.has_key('id'):
            raise AssertionError
        id = attrs['id']
        if not self.dict.has_key(id):
            raise AssertionError
        self.data_stack.append(self.dict[id])

    
    def um_start_generic(self, name, attrs):
        self.data_stack.append([])
        self.accumulating_chars = 1

    um_start_float = um_start_long = um_start_string = um_start_generic
    um_start_complex = um_start_code = um_start_none = um_start_generic
    um_start_int = um_start_generic
    
    def um_end_string(self, name):
        ds = self.data_stack
        ds[-1] = str(string.join(ds[-1], ''))
        self.accumulating_chars = 0

    
    def um_end_int(self, name):
        ds = self.data_stack
        ds[-1] = string.join(ds[-1], '')
        ds[-1] = int(ds[-1])
        self.accumulating_chars = 0

    
    def um_end_long(self, name):
        ds = self.data_stack
        ds[-1] = string.join(ds[-1], '')
        ds[-1] = long(ds[-1])
        self.accumulating_chars = 0

    
    def um_end_float(self, name):
        ds = self.data_stack
        ds[-1] = string.join(ds[-1], '')
        ds[-1] = float(ds[-1])
        self.accumulating_chars = 0

    
    def um_end_none(self, name):
        ds = self.data_stack
        ds[-1] = None
        self.accumulating_chars = 0

    
    def um_end_complex(self, name):
        ds = self.data_stack
        c = string.join(ds[-1], '')
        c = string.split(c)
        c = float(c[0]) + float(c[1]) * (0.0+1.0j)
        ds[-1:] = [
            c]
        self.accumulating_chars = 0

    
    def um_end_code(self, name):
        import marshal
        import base64
        ds = self.data_stack
        s = string.join(ds[-1], '')
        s = base64.decodestring(s)
        ds[-1] = marshal.loads(s)
        self.accumulating_chars = 0

    
    def um_start_list(self, name, attrs):
        self.data_stack.append(LIST)
        L = []
        if attrs.has_key('id'):
            id = attrs['id']
            self.dict[id] = L
        
        self.data_stack.append(L)

    
    def um_end_list(self, name):
        ds = self.data_stack
        for index in range(len(ds) - 1, -1, -1):
            if ds[index] is LIST:
                break
                continue
        
        if not index != -1:
            raise AssertionError
        L = ds[index + 1]
        L[:] = ds[index + 2:len(ds)]
        ds[index:] = [
            L]

    
    def um_start_tuple(self, name, attrs):
        self.data_stack.append(TUPLE)

    
    def um_end_tuple(self, name):
        ds = self.data_stack
        for index in range(len(ds) - 1, -1, -1):
            if ds[index] is TUPLE:
                break
                continue
        
        if not index != -1:
            raise AssertionError
        t = tuple(ds[index + 1:len(ds)])
        ds[index:] = [
            t]

    
    def um_start_dictionary(self, name, attrs):
        self.data_stack.append(DICT)
        d = { }
        if attrs.has_key('id'):
            id = attrs['id']
            self.dict[id] = d
        
        self.data_stack.append(d)

    
    def um_end_dictionary(self, name):
        ds = self.data_stack
        for index in range(len(ds) - 1, -1, -1):
            if ds[index] is DICT:
                break
                continue
        
        if not index != -1:
            raise AssertionError
        d = ds[index + 1]
        for i in range(index + 2, len(ds), 2):
            key = ds[i]
            value = ds[i + 1]
            d[key] = value
        
        ds[index:] = [
            d]

    
    def um_start_instance(self, name, attrs):
        module = attrs['module']
        classname = attrs['class']
        value = _EmptyClass()
        if attrs.has_key('id'):
            id = attrs['id']
            self.dict[id] = value
        
        self.data_stack.append(value)
        self.data_stack.append(module)
        self.data_stack.append(classname)

    
    def um_end_instance(self, name):
        (value, module, classname, initargs, dict) = self.data_stack[-5:]
        klass = self.find_class(module, classname)
        instantiated = 0
        if not initargs and type(klass) is ClassType and not hasattr(klass, '__getinitargs__'):
            value.__class__ = klass
            instantiated = 1
        
        if not instantiated:
            
            try:
                v2 = apply(klass, initargs)
            except TypeError:
                err = None
                raise TypeError, 'in constructor for %s: %s' % (klass.__name__, str(err)), sys.exc_info()[2]

            for k, v in v2.__dict__.items():
                setattr(value, k, v)
            
        
        for k, v in dict.items():
            setattr(value, k, v)
        
        self.data_stack[-5:] = [
            value]



class _EmptyClass:
    pass

_m = Marshaller()
dump = _m.dump
dumps = _m.dumps
_um = Unmarshaller()
load = _um.load
loads = _um.loads
del _m
del _um

def test(load, loads, dump, dumps, test_values, do_assert = 1):
    import StringIO
    for item in test_values:
        s = dumps(item)
        print s
        output = loads(s)
        file = StringIO.StringIO()
        dump(item, file)
        file.seek(0)
        output2 = load(file)
        if do_assert:
            if not item == output and item == output2 or output == output2:
                raise AssertionError
            continue
    


class _A:
    
    def __repr__(self):
        return '<A instance>'



class _B:
    
    def __repr__(self):
        return '<B instance>'



def runtests():
    print 'Testing XML marshalling...'
    L = [
        None,
        1,
        pow(2, 0x7BL),
        19.719999999999999,
        1 + (0.0+5.0j),
        'here is a string & a <fake tag>',
        (1, 2, 3),
        [
            'alpha',
            'beta',
            'gamma'],
        {
            'key': 'value',
            1: 2 }]
    test(load, loads, dump, dumps, L)
    instance = _A()
    instance.subobject = _B()
    instance.subobject.list = [
        None,
        1,
        pow(2, 0x7BL),
        19.719999999999999,
        1 + (0.0+5.0j),
        'here is a string & a <fake tag>']
    instance.self = instance
    L = [
        instance]
    test(load, loads, dump, dumps, L, do_assert = 0)
    recursive_list = [
        None,
        1,
        pow(3, 0x41L),
        {
            1: 'spam',
            2: 'eggs' },
        '<fake tag>',
        1 + (0.0+5.0j)]
    recursive_list.append(recursive_list)
    test(load, loads, dump, dumps, [
        recursive_list], do_assert = 0)
    output = loads('<?xml version="1.0"?>\n<marshal>\n  <tuple>\n    <float> 1.0 </float>\n    <string>abc</string>\n    <list id="i2" />\n  </tuple>\n</marshal>')
    if not output == (1.0, 'abc', []):
        raise AssertionError

if __name__ == '__main__':
    runtests()

