# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

import gtk
import gobject
import gconf
import deskbar
import deskbar.keybinder as deskbar

class Keybinder(gobject.GObject):
    __gsignals__ = {
        'activated': (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, [
            gobject.TYPE_ULONG]),
        'changed': (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, [
            gobject.TYPE_BOOLEAN]) }
    
    def __init__(self):
        gobject.GObject.__init__(self)
        self.bound = False
        self.prevbinding = None
        self.keybinding = deskbar.GCONF_CLIENT.get_string(deskbar.GCONF_KEYBINDING)
        if self.keybinding == None:
            self.keybinding = '<Alt>F3'
        
        deskbar.GCONF_CLIENT.notify_add(deskbar.GCONF_KEYBINDING, (lambda x, y, z, a: self.on_config_keybinding(z.value)))
        self.bind()

    
    def on_config_keybinding(self, value = None):
        if value != None and value.type == gconf.VALUE_STRING:
            self.prevbinding = self.keybinding
            self.keybinding = value.get_string()
            self.bind()
        

    
    def on_keyboard_shortcut(self):
        self.emit('activated', deskbar.keybinder.tomboy_keybinder_get_current_event_time())

    
    def bind(self):
        if self.bound:
            self.unbind()
        
        
        try:
            print 'Binding Global shortcut %s to focus the deskbar' % self.keybinding
            deskbar.keybinder.tomboy_keybinder_bind(self.keybinding, self.on_keyboard_shortcut)
            self.bound = True
        except KeyError:
            self.bound = False

        self.emit('changed', self.bound)

    
    def unbind(self):
        
        try:
            deskbar.keybinder.tomboy_keybinder_unbind(self.prevbinding)
            self.bound = False
        except KeyError:
            pass



if gtk.pygtk_version < (2, 8, 0):
    gobject.type_register(Keybinder)

keybinder = Keybinder()

def get_deskbar_keybinder():
    return keybinder

