# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

import gtk
import gobject

class ModuleList(gtk.ListStore):
    """Mostly generic implementation of a dynamic module handler.
\tUse a ModuleListView object to display the contents of a ModuleList. 
\tYou can iterate over the list with
\t
\t\tfor modctx in modlist:
\t\t\tdo_something (modctx)
\t
\tFrom this perspective the ModuleList stores ModuleContexts (it actually doesnt),
\tso to utilize the modules you'll have to acces modctx.module.
\t
\tNote that the gtk.ListView extends the following classes:
\t\tgobject.GObject, gtk.TreeModel, gtk.TreeDragSource, gtk.TreeDragDest,
\t\tgtk.TreeSortable
\tMore documentation:
\t\thttp://www.pygtk.org/pygtk2reference/class-gtkliststore.html
\tNote that
\t"""
    ENABLED_COL = 0
    ICON_COL = 1
    MODULE_CTX_COL = 2
    
    def __init__(self):
        gtk.ListStore.__init__(self, bool, gtk.gdk.Pixbuf, gobject.TYPE_PYOBJECT)

    
    def __iter__(self):
        return ModuleListIter(self)

    
    def get_position_from_context(self, attr, value = None):
        '''Returns a tuple (iter, index)
\t\t
\t\titer is a gtk.TreeIter pointing to the row containing the given module context.
\t\tindex is the index of the module in the list.
\t\t
\t\tIf the module context is not found return (None, None).
\t\t'''
        i = 0
        iter = self.get_iter_first()
        while iter is not None:
            if value == None:
                if self[iter][self.MODULE_CTX_COL] == attr:
                    return (iter, i)
                
            elif getattr(self[iter][self.MODULE_CTX_COL], attr) == value:
                return (iter, i)
            
            iter = self.iter_next(iter)
            i = i + 1
        return (None, 0)

    
    def reorder_with_priority(self, enabled_modules):
        new_order = []
        for classname in enabled_modules:
            new_order.append(self.get_position_from_context('handler', classname)[1])
        
        disabled_modules = _[1]
        disabled_modules.sort((lambda x, y: cmp(x.infos['name'], y.infos['name'])))
        for dm in disabled_modules:
            new_order.append(self.get_position_from_context('handler', dm.handler)[1])
        
        self.reorder(new_order)

    
    def add(self, context, iter = None):
        """If iter is set this method updates the row pointed to by iter with the 
\t\tvalues of context. 
\t\t
\t\tIf iter is not set it will try to obtain an iter pointing
\t\tto the row containg the context. If there's no such row, it will append it.
\t\t"""
        for modctx in self:
            if modctx.handler == context.handler:
                return None
                continue
        
        if iter is None:
            (res, index) = self.get_position_from_context(context)
        
        if res is None or res[0] is None:
            iter = self.append()
        
        self.set_value(iter, self.ICON_COL, context.icon)
        self.set_value(iter, self.ENABLED_COL, context.enabled)
        self.set_value(iter, self.MODULE_CTX_COL, context)

    
    def remove_module(self, context):
        (iter, index) = self.get_position_from_context(context)
        if iter != None:
            print 'Removing from modulelist:', context.handler
            self.remove(iter)
        

    
    def module_changed(self, context):
        (iter, index) = self.get_position_from_context(context)
        if iter != None:
            self.emit('row-changed', self.get_path(iter), iter)
        

    
    def update_row_cb(self, sender, context, iter = None):
        '''
\t\tCallback for updating the row containing context.
\t\tIf iter is set the row to which it points to will be
\t\tupdated with the context.
\t\t'''
        self.add(context, iter)

    
    def module_toggled_cb(self, sender, context):
        '''
\t\tCallback to toggle the enabled state of the context.
\t\t'''
        self[self.get_position_from_context(context)[0]][self.ENABLED_COL] = context.enabled


gobject.type_register(ModuleList)

class WebModuleList(gtk.ListStore):
    MODULE_CTX_COL = 0
    
    def __init__(self):
        gtk.ListStore.__init__(self, gobject.TYPE_PYOBJECT)

    
    def __iter__(self):
        return ModuleListIter(self)

    
    def get_position_from_context(self, attr, value = None):
        '''Returns a tuple (iter, index)
\t\t
\t\titer is a gtk.TreeIter pointing to the row containing the given module context.
\t\tindex is the index of the module in the list.
\t\t
\t\tIf the module context is not found return (None, None).
\t\t'''
        i = 0
        iter = self.get_iter_first()
        while iter is not None:
            if value == None:
                if self[iter][self.MODULE_CTX_COL] == attr:
                    return (iter, i)
                
            elif getattr(self[iter][self.MODULE_CTX_COL], attr) == value:
                return (iter, i)
            
            iter = self.iter_next(iter)
            i = i + 1
        return (None, 0)

    
    def add(self, context, iter = None):
        """If iter is set this method updates the row pointed to by iter with the 
\t\tvalues of context. 
\t\t
\t\tIf iter is not set it will try to obtain an iter pointing
\t\tto the row containg the context. If there's no such row, it will append it.
\t\t"""
        for modctx in self:
            if modctx.id == context.id:
                return None
                continue
        
        if iter is None:
            res = self.get_position_from_context(context)
        
        if res is None or res[0] is None:
            iter = self.append()
        
        self.set_value(iter, self.MODULE_CTX_COL, context)

    
    def module_changed(self, context):
        (iter, index) = self.get_position_from_context(context)
        if iter != None:
            self.emit('row-changed', self.get_path(iter), iter)
        

    
    def update_row_cb(self, sender, context, iter = None):
        '''
\t\tCallback for updating the row containing context.
\t\tIf iter is set the row to which it points to will be
\t\tupdated with the context.
\t\t'''
        self.add(context, iter)


gobject.type_register(WebModuleList)

class ModuleListIter:
    '''An iter type to iterate over the of *enabled* module contexts in a ModuleList object.
\tThis object is (typically) not used directly. See the documentation for ModuleList.
\t\t\t
\tFor documentation on iters see: http://docs.python.org/lib/typeiter.html
\t'''
    
    def __init__(self, owner):
        '''Constructor for ModuleListIter.
\t\towner is the ModuleList which this iterator will iterate over.
\t\t'''
        self.owner = owner
        self.owner_iter = owner.get_iter_first()

    
    def __iter__(self):
        return self

    
    def next(self):
        '''Return the next *enabled* module in the ModuleList.'''
        
        try:
            mod = self.owner[self.owner_iter][self.owner.MODULE_CTX_COL]
            self.owner_iter = self.owner.iter_next(self.owner_iter)
        except TypeError:
            raise StopIteration

        return mod


