# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

import gtk
import gnomeapplet
import gobject

class CuemiacAlignedWindow(gtk.Window):
    '''
\tBorderless window aligning itself to a given widget.
\tUse CuemiacWindow.update_position() to align it.
\t'''
    
    def __init__(self, widgetToAlignWith, applet, window_type = gtk.WINDOW_TOPLEVEL):
        '''
\t\talignment should be one of
\t\t\tgnomeapplet.ORIENT_{DOWN,UP,LEFT,RIGHT}
\t\t
\t\tCall CuemiacWindow.update_position () to position the window.
\t\t'''
        gtk.Window.__init__(self, window_type)
        self.set_decorated(False)
        self.stick()
        self.set_keep_above(True)
        self.set_skip_pager_hint(True)
        self.set_skip_taskbar_hint(True)
        self.set_border_width(1)
        self.widgetToAlignWith = widgetToAlignWith
        self.applet = applet
        self.alignment = applet.get_orient()
        self.realize_status = None
        self.connect('realize', (lambda win: self._CuemiacAlignedWindow__register_realize()))
        self.connect('delete-event', self.on_delete_event)
        self.connect('size-allocate', self._CuemiacAlignedWindow__resize_event)

    
    def on_delete_event(self, window, event):
        self.hide()
        return True

    
    def __resize_event(self, widget, allocation):
        self.update_position()

    
    def update_position(self):
        '''
\t\tCalculates the position and moves the window to it.
\t\tIMPORATNT: widgetToAlignWith should be realized!
\t\t'''
        if self.realize_status == None:
            self.realize_status = False
            self.realize()
            return None
        
        if self.realize_status == False:
            return None
        
        if not self.widgetToAlignWith.flags() & gtk.REALIZED:
            print 'WARNING: CuemiacAlignedWindow.update_position() widgetToAlignWith is not realized.'
            return None
        
        (wx, wy) = self.window.get_origin()
        (ax, ay) = self.widgetToAlignWith.window.get_origin()
        (ww, wh) = self.window.get_size()
        (aw, ah) = self.widgetToAlignWith.window.get_size()
        screen = self.get_screen()
        monitor = screen.get_monitor_geometry(screen.get_monitor_at_window(self.applet.window))
        if self.alignment == gnomeapplet.ORIENT_LEFT:
            x = ax - ww
            y = ay
            if y + wh > monitor.y + monitor.height:
                y = monitor.y + monitor.height - wh
            
            if y < 0:
                y = 0
            
            if y + wh > monitor.height / 2:
                gravity = gtk.gdk.GRAVITY_SOUTH_WEST
            else:
                gravity = gtk.gdk.GRAVITY_NORTH_WEST
        elif self.alignment == gnomeapplet.ORIENT_RIGHT:
            x = ax + aw
            y = ay
            if y + wh > monitor.y + monitor.height:
                y = monitor.y + monitor.height - wh
            
            if y < 0:
                y = 0
            
            if y + wh > monitor.height / 2:
                gravity = gtk.gdk.GRAVITY_SOUTH_EAST
            else:
                gravity = gtk.gdk.GRAVITY_NORTH_EAST
        elif self.alignment == gnomeapplet.ORIENT_DOWN:
            x = ax
            y = ay + ah
            if x + ww > monitor.x + monitor.width:
                x = monitor.x + monitor.width - ww
            
            if x < 0:
                x = 0
            
            gravity = gtk.gdk.GRAVITY_NORTH_WEST
        elif self.alignment == gnomeapplet.ORIENT_UP:
            x = ax
            y = ay - wh
            if x + ww > monitor.x + monitor.width:
                x = monitor.x + monitor.width - ww
            
            if x < 0:
                x = 0
            
            gravity = gtk.gdk.GRAVITY_SOUTH_WEST
        
        self.move(x, y)
        self.set_gravity(gravity)

    
    def __register_realize(self):
        self.realize_status = True
        self.update_position()


gobject.type_register(CuemiacAlignedWindow)
