# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

import gtk
import gobject
import cgi
import deskbar
from deskbar.Categories import CATEGORIES
from deskbar.ui.cuemiac.CuemiacItems import CuemiacCategory
SORT_BY_CATEGORY = 1

class CuemiacModel(gtk.TreeStore):
    '''
\tA tree model to store hits sorted by categories. CuemiacCategory\'s are root nodes,
\twith each child representing a hit.
\tSchematically this looks like:
\t
\tCuemiacCategory->
\t\t-> deskbar.handler.Match
\t\t-> deskbar.handler.Match
\t\t...
\t\t-> deskbar.handler.Match
\tCuemiacCategory->
\t\t...
\t...
\t
\tSignal arguments:
\t\t"category-added" : CuemiacCategory, gtk.TreePath
\t'''
    MATCHES = 0
    ACTIONS = 1
    __gsignals__ = {
        'category-added': (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, [
            gobject.TYPE_PYOBJECT,
            gobject.TYPE_PYOBJECT]) }
    
    def __init__(self):
        gtk.TreeStore.__init__(self, gobject.TYPE_PYOBJECT, gobject.TYPE_STRING)
        self._CuemiacModel__categories = { }
        self.append_method = gtk.TreeStore.append
        self.set_sort_func(SORT_BY_CATEGORY, self._CuemiacModel__on_sort_categories)

    
    def set_sort_order(self, order):
        self.set_sort_column_id(SORT_BY_CATEGORY, order)

    
    def __on_sort_categories(self, treemodel, iter1, iter2):
        match1 = treemodel[iter1][self.MATCHES]
        match2 = treemodel[iter2][self.MATCHES]
        if match1.__class__ == CuemiacCategory:
            return match1.get_priority() - match2.get_priority()
        
        (text1, match1) = match1
        (text2, match2) = match2
        diff = match1.get_priority()[0] - match2.get_priority()[0]
        if diff != 0:
            return diff
        
        diff = match1.get_priority()[1] - match2.get_priority()[1]
        if diff != 0:
            return diff
        
        a = treemodel[iter1][self.ACTIONS]
        b = treemodel[iter2][self.ACTIONS]
        if a != None:
            a = a.strip().lower()
        
        if b != None:
            b = b.strip().lower()
        
        if a < b:
            return 1
        elif a > b:
            return -1
        else:
            return 0

    
    def append(self, match):
        '''
\t\tAutomagically append a match or list of matches 
\t\tto correct category(s), or create a new one(s) if needed.
\t\t'''
        if type(match) == list:
            for hit in match:
                self._CuemiacModel__append(hit)
            
        else:
            self._CuemiacModel__append(match)

    
    def __append(self, match):
        (qstring, match_obj) = match
        if self._CuemiacModel__categories.has_key(match_obj.get_category()):
            self._CuemiacModel__append_to_category(match)
        else:
            self._CuemiacModel__create_category_with_match(match)

    
    def __create_category_with_match(self, match):
        '''
\t\tAssumes that the category for the match does not exist.
\t\t'''
        (qstring, match_obj) = match
        cat = CuemiacCategory(match_obj.get_category(), self)
        cat.set_priority(match_obj)
        iter = self.append_method(self, None, [
            cat,
            None])
        cat.set_category_iter(iter)
        self._CuemiacModel__categories[match_obj.get_category()] = cat
        self._CuemiacModel__append_match_to_iter(iter, match)
        cat.inc_count()
        self.emit('category-added', cat, cat.get_category_row_path())

    
    def __append_to_category(self, match):
        (qstring, match_obj) = match
        cat = self._CuemiacModel__categories[match_obj.get_category()]
        cat.set_priority(match_obj)
        row_iter = None
        cat.inc_count()
        self._CuemiacModel__append_match_to_iter(cat.get_category_iter(), match)
        self.row_changed(cat.get_category_row_path(), cat.get_category_iter())

    
    def __append_match_to_iter(self, iter, match):
        (qstring, match_obj) = match
        verbs = {
            'text': qstring }
        verbs.update(match_obj.get_name(qstring))
        verbs['text'] = cgi.escape(verbs['text'])
        self.append_method(self, iter, [
            match,
            match_obj.get_verb() % verbs])

    
    def clear(self):
        '''Clears this model of data.'''
        gtk.TreeStore.clear(self)
        self._CuemiacModel__categories = { }

    
    def paths_equal(self, path1, path2):
        '''Returns true if the two paths point to the same cell.'''
        if path1 == None or path2 == None:
            return False
        
        return self.get_string_from_iter(self.get_iter(path1)) == self.get_string_from_iter(self.get_iter(path2))


if gtk.pygtk_version < (2, 8, 0):
    gobject.type_register(CuemiacModel)

