# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

import gtk
import gobject

class LingeringSelectionWindow(gtk.Window):
    '''
\tLeave an imprint on the screen of the selected row in a treeview
\twhen it is activated.
\tThis is mainly used when the window containing the treeview is
\thidden on the same activation.
\t'''
    
    def __init__(self, view):
        '''
\t\tJust create the LingeringSelectionWindow passing the treeview
\t\tto manage in the constructor and everything will be taken care of.
\t\t'''
        gtk.Window.__init__(self, gtk.WINDOW_POPUP)
        self.linger_time = 1000
        self.set_focus_on_map(False)
        view.connect('row-activated', self._on_view_activated)

    
    def _on_view_activated(self, view, path, column):
        model = view.get_model()
        if model.iter_has_child(model.get_iter(path)):
            return None
        
        pixmap = view.create_row_drag_icon(path)
        if pixmap == None:
            self.hide()
            return None
        
        image = gtk.Image()
        image.set_from_pixmap(pixmap, None)
        if self.get_child():
            self.remove(self.get_child())
        
        self.add(image)
        self._update_position(view, path, column)
        self._linger()

    
    def _update_position(self, view, path, column):
        '''
\t\tMove the window to the activated paths position
\t\t'''
        (ox, oy) = view.window.get_origin()
        area = view.get_background_area(path, column)
        (x, y) = view.tree_to_widget_coords(area.x, area.y)
        self.move(x + ox, y + oy)
        self.resize(area.width, area.height)

    
    def _linger(self):
        '''
\t\tDisplay for a short while
\t\t'''
        self.show_all()
        gobject.timeout_add(self.linger_time, self.hide)


