# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

'''Custom script for Gecko toolkit.  NOT WORKING WELL AT THE MOMENT.
Please refer to the following URL for more information on the AT-SPI
implementation in Gecko:
http://developer.mozilla.org/en/docs/Accessibility/ATSPI_Support
'''
__id__ = '$Id: Gecko.py 2090 2007-03-04 23:08:20Z wwalker $'
__version__ = '$Revision: 2090 $'
__date__ = '$Date: 2007-03-04 18:08:20 -0500 (Sun, 04 Mar 2007) $'
__copyright__ = 'Copyright (c) 2005-2007 Sun Microsystems Inc.'
__license__ = 'LGPL'
import atspi
import braille
import braillegenerator
import debug
import default
import input_event
import keybindings
import mag
import orca
import orca_state
import rolenames
import settings
import speech
import speechgenerator
import util
from orca_i18n import _
controlCaretNavigation = False
arrowToLineBeginning = True
NEWLINE_ROLES = [
    rolenames.ROLE_PARAGRAPH,
    rolenames.ROLE_SEPARATOR,
    rolenames.ROLE_LIST_ITEM,
    rolenames.ROLE_HEADING]
OBJECT_ROLES = [
    rolenames.ROLE_CHECK_BOX,
    rolenames.ROLE_COLUMN_HEADER,
    rolenames.ROLE_COMBO_BOX,
    rolenames.ROLE_DIAL,
    rolenames.ROLE_ENTRY,
    rolenames.ROLE_HEADING,
    rolenames.ROLE_ICON,
    rolenames.ROLE_IMAGE,
    rolenames.ROLE_LABEL,
    rolenames.ROLE_LIST_ITEM,
    rolenames.ROLE_MENU,
    rolenames.ROLE_MENU_ITEM,
    rolenames.ROLE_PAGE_TAB,
    rolenames.ROLE_PARAGRAPH,
    rolenames.ROLE_PASSWORD_TEXT,
    rolenames.ROLE_PROGRESS_BAR,
    rolenames.ROLE_PUSH_BUTTON,
    rolenames.ROLE_RADIO_BUTTON,
    rolenames.ROLE_RADIO_MENU_ITEM,
    rolenames.ROLE_RADIO_MENU,
    rolenames.ROLE_ROW_HEADER,
    rolenames.ROLE_SLIDER,
    rolenames.ROLE_SPIN_BUTTON,
    rolenames.ROLE_STATUSBAR,
    rolenames.ROLE_TABLE_COLUMN_HEADER,
    rolenames.ROLE_TABLE_ROW_HEADER,
    rolenames.ROLE_TEAR_OFF_MENU_ITEM,
    rolenames.ROLE_TERMINAL,
    rolenames.ROLE_TEXT,
    rolenames.ROLE_TOGGLE_BUTTON,
    rolenames.ROLE_AUTOCOMPLETE]

class BrailleGenerator(braillegenerator.BrailleGenerator):
    '''Provides a braille generator specific to Gecko.
    '''
    
    def __init__(self, script):
        braillegenerator.BrailleGenerator.__init__(self, script)
        self.brailleGenerators[rolenames.ROLE_AUTOCOMPLETE] = self._getBrailleRegionsForAutocomplete
        self.brailleGenerators[rolenames.ROLE_ENTRY] = self._getBrailleRegionsForText
        self.brailleGenerators[rolenames.ROLE_LINK] = self._getBrailleRegionsForLink

    
    def _getBrailleRegionsForAutocomplete(self, obj):
        '''Gets the braille for an autocomplete box.  We let the
        handlers for the children do the rest.

        Arguments:
        - obj: an Accessible

        Returns a list where the first element is a list of Regions to
        display and the second element is the Region which should get
        focus.
        '''
        self._debugGenerator('Gecko._getBrailleRegionsForAutocomplete', obj)
        regions = []
        if settings.brailleVerbosityLevel == settings.VERBOSITY_LEVEL_VERBOSE:
            regions.append(braille.Region(rolenames.getBrailleForRoleName(obj)))
        else:
            regions.append(braille.Region(''))
        return (regions, regions[0])

    
    def _getBrailleRegionsForCheckBox(self, obj):
        '''Get the braille for a check box.  If the check box already had
        focus, then only the state is displayed.

        Arguments:
        - obj: the check box

        Returns a list where the first element is a list of Regions to display
        and the second element is the Region which should get focus.
        '''
        self._debugGenerator('_getBrailleRegionsForCheckBox', obj)
        text = ''
        if not self._script.inDocumentContent():
            text = util.appendString(text, util.getDisplayedLabel(obj))
            text = util.appendString(text, util.getDisplayedText(obj))
        else:
            isLabelled = False
            relations = obj.relations
            if relations:
                for relation in relations:
                    if relation.getRelationType() == atspi.Accessibility.RELATION_LABELLED_BY:
                        isLabelled = True
                        break
                        continue
                
            
            if not isLabelled and obj.name and len(obj.name):
                text = util.appendString(text, obj.name)
            
        if obj.state.count(atspi.Accessibility.STATE_CHECKED):
            text = util.appendString(text, '<x>')
        else:
            text = util.appendString(text, '< >')
        text = util.appendString(text, self._getTextForRole(obj))
        regions = []
        componentRegion = braille.Component(obj, text)
        regions.append(componentRegion)
        return [
            regions,
            componentRegion]

    
    def _getBrailleRegionsForText(self, obj):
        '''Gets text to be displayed for the entry of an autocomplete box.

        Arguments:
        - obj: an Accessible

        Returns a list where the first element is a list of Regions to
        display and the second element is the Region which should get
        focus.
        '''
        self._debugGenerator('Gecko._getBrailleRegionsForText', obj)
        parent = obj.parent
        if parent.role != rolenames.ROLE_AUTOCOMPLETE:
            return braillegenerator.BrailleGenerator._getBrailleRegionsForText(self, obj)
        
        regions = []
        label = util.getDisplayedLabel(parent)
        if not label or not len(label):
            label = parent.name
        
        textRegion = braille.Text(obj, label)
        regions.append(textRegion)
        eol = braille.Region(' $l')
        regions.append(eol)
        return [
            regions,
            textRegion]

    
    def _getBrailleRegionsForComboBox(self, obj):
        '''Get the braille for a combo box.  If the combo box already has
        focus, then only the selection is displayed.

        Arguments:
        - obj: the combo box

        Returns a list where the first element is a list of Regions to display
        and the second element is the Region which should get focus.
        '''
        self._debugGenerator('Gecko._getBrailleRegionsForComboBox', obj)
        regions = []
        label = util.getDisplayedLabel(obj)
        if not label:
            label = obj.name
        
        focusedRegionIndex = 0
        if label and len(label):
            regions.append(braille.Region(label + ' '))
            focusedRegionIndex = 1
        
        menu = None
        for i in range(0, obj.childCount):
            child = obj.child(i)
            if child.role == rolenames.ROLE_MENU:
                menu = child
                break
                continue
        
        if menu:
            selection = menu.selection
            if selection:
                
                try:
                    item = selection.getSelectedChild(0)
                    regions.append(braille.Region(item.name))
                regions.append(braille.Region(menu.name))

            elif menu.name:
                regions.append(braille.Region(menu.name))
            
        
        if settings.brailleVerbosityLevel == settings.VERBOSITY_LEVEL_VERBOSE:
            regions.append(braille.Region(' ' + rolenames.getBrailleForRoleName(obj)))
        
        if focusedRegionIndex >= len(regions):
            focusedRegionIndex = 0
        
        return [
            regions,
            regions[focusedRegionIndex]]

    
    def _getBrailleRegionsForImage(self, obj):
        '''Get the braille regions for an image.

        Arguments:
        - obj: an Accessible

        Returns a list where the first element is a list of Regions to
        display and the second element is the Region which should get
        focus.
        '''
        self._debugGenerator('Gecko._getBrailleRegionsForImage', obj)
        regions = []
        text = ''
        text = util.appendString(text, util.getDisplayedLabel(obj))
        text = util.appendString(text, util.getDisplayedText(obj))
        link = self._script.getContainingLink(obj)
        if len(text) == 0:
            if link:
                (linkRegions, focusedRegion) = self._getBrailleRegionsForLink(link)
                for region in linkRegions:
                    text += region.string
                
            
        elif link:
            text = util.appendString(text, self._getTextForRole(link))
        
        text = util.appendString(text, self._getTextForValue(obj))
        text = util.appendString(text, self._getTextForRole(obj))
        regions = []
        componentRegion = braille.Component(obj, text)
        regions.append(componentRegion)
        return [
            regions,
            componentRegion]

    
    def _getBrailleRegionsForLink(self, obj):
        '''Gets text to be displayed for a link.

        Arguments:
        - obj: an Accessible

        Returns a list where the first element is a list of Regions to
        display and the second element is the Region which should get
        focus.
        '''
        self._debugGenerator('Gecko._getBrailleRegionsForLink', obj)
        regions = []
        text = ''
        text = util.appendString(text, util.getDisplayedLabel(obj))
        text = util.appendString(text, util.getDisplayedText(obj))
        if len(text) == 0:
            basename = self._script.getLinkBasename(obj)
            if basename:
                text = basename
            
        
        text = util.appendString(text, self._getTextForValue(obj))
        text = util.appendString(text, self._getTextForRole(obj))
        regions = []
        componentRegion = braille.Component(obj, text)
        regions.append(componentRegion)
        return [
            regions,
            componentRegion]



class SpeechGenerator(speechgenerator.SpeechGenerator):
    '''Provides a speech generator specific to Gecko.
    '''
    
    def __init__(self, script):
        speechgenerator.SpeechGenerator.__init__(self, script)
        self.speechGenerators[rolenames.ROLE_DOCUMENT_FRAME] = self._getSpeechForDocumentFrame
        self.speechGenerators[rolenames.ROLE_ENTRY] = self._getSpeechForText
        self.speechGenerators[rolenames.ROLE_LINK] = self._getSpeechForLink

    
    def _getSpeechForObjectRole(self, obj):
        '''Prevents some roles from being spoken.'''
        if obj.role in [
            rolenames.ROLE_PARAGRAPH,
            rolenames.ROLE_SECTION,
            rolenames.ROLE_LABEL,
            rolenames.ROLE_UNKNOWN]:
            return []
        else:
            return [
                rolenames.getSpeechForRoleName(obj)]

    
    def _getSpeechForDocumentFrame(self, obj, already_focused):
        '''Gets the speech for a document frame.

        Arguments:
        - obj: an Accessible
        - already_focused: False if object just received focus

        Returns a list of utterances to be spoken for the object.
        '''
        utterances = []
        name = obj.name
        if name and len(name):
            utterances.append(name)
        
        utterances.extend(self._getSpeechForObjectRole(obj))
        self._debugGenerator('Gecko._getSpeechForDocumentFrame', obj, already_focused, utterances)
        return utterances

    
    def _getSpeechForText(self, obj, already_focused):
        '''Gets the speech for an autocomplete box.

        Arguments:
        - obj: an Accessible
        - already_focused: False if object just received focus

        Returns a list of utterances to be spoken for the object.
        '''
        parent = obj.parent
        if parent.role != rolenames.ROLE_AUTOCOMPLETE:
            return speechgenerator.SpeechGenerator._getSpeechForText(self, obj, already_focused)
        
        utterances = []
        label = util.getDisplayedLabel(parent)
        if not label or not len(label):
            label = parent.name
        
        utterances.append(label)
        utterances.extend(self._getSpeechForObjectRole(obj))
        (text, caretOffset, startOffset) = util.getTextLineAtCaret(obj)
        utterances.append(text)
        self._debugGenerator('Gecko._getSpeechForText', obj, already_focused, utterances)
        return utterances

    
    def _getSpeechForComboBox(self, obj, already_focused):
        '''Get the speech for a combo box.  If the combo box already has focus,
        then only the selection is spoken.

        Arguments:
        - obj: the combo box
        - already_focused: False if object just received focus

        Returns a list of utterances to be spoken for the object.
        '''
        utterances = []
        label = util.getDisplayedLabel(obj)
        if not label:
            label = obj.name
        
        if not already_focused and label:
            utterances.append(label)
        
        if not already_focused:
            utterances.extend(self._getSpeechForObjectRole(obj))
        
        menu = None
        for i in range(0, obj.childCount):
            child = obj.child(i)
            if child.role == rolenames.ROLE_MENU:
                menu = child
                break
                continue
        
        if menu:
            selection = menu.selection
            if selection:
                
                try:
                    item = selection.getSelectedChild(0)
                    utterances.append(item.name)
                utterances.append(menu.name)

            elif menu.name:
                utterances.append(menu.name)
            
        
        utterances.extend(self._getSpeechForObjectAvailability(obj))
        self._debugGenerator('Gecko._getSpeechForComboBox', obj, already_focused, utterances)
        return utterances

    
    def _getSpeechForImage(self, obj, already_focused):
        '''Gets a list of utterances to be spoken for an image.

        The default speech will be of the following form:

        label name role availability

        Arguments:
        - obj: an Accessible
        - already_focused: False if object just received focus

        Returns a list of utterances to be spoken for the object.
        '''
        utterances = []
        if not already_focused:
            label = self._getSpeechForObjectLabel(obj)
            utterances.extend(label)
            name = self._getSpeechForObjectName(obj)
            if name != label:
                utterances.extend(name)
            
            link = self._script.getContainingLink(obj)
            if not len(utterances):
                if link:
                    utterances.extend(self._getSpeechForLink(link, already_focused))
                
            elif link:
                utterances.extend(self._getSpeechForObjectRole(link))
            
            utterances.extend(self._getSpeechForObjectRole(obj))
        
        utterances.extend(self._getSpeechForObjectAvailability(obj))
        self._debugGenerator('Gecko._getSpeechForImage', obj, already_focused, utterances)
        return utterances

    
    def _getSpeechForLink(self, obj, already_focused):
        '''Gets a list of utterances to be spoken for a link.

        Arguments:
        - obj: an Accessible
        - already_focused: False if object just received focus

        Returns a list of utterances to be spoken for the object.
        '''
        utterances = []
        if not already_focused:
            label = self._getSpeechForObjectLabel(obj)
            utterances.extend(label)
            name = self._getSpeechForObjectName(obj)
            if name != label:
                utterances.extend(name)
            
            if not len(utterances):
                basename = self._script.getLinkBasename(obj)
                if basename:
                    utterances.append(basename)
                
            
            utterances.extend(self._getSpeechForObjectRole(obj))
        
        utterances.extend(self._getSpeechForObjectAvailability(obj))
        self._debugGenerator('Gecko._getSpeechForLink', obj, already_focused, utterances)
        return utterances

    
    def getSpeechContext(self, obj, stopAncestor = None):
        '''Get the speech that describes the names and role of
        the container hierarchy of the object, stopping at and
        not including the stopAncestor.

        Arguments:
        - obj: the object
        - stopAncestor: the ancestor to stop at and not include (None
          means include all ancestors)

        Returns a list of utterances to be spoken.
        '''
        utterances = []
        if not obj:
            return utterances
        
        if obj is stopAncestor:
            return utterances
        
        parent = obj.parent
        while parent and parent.parent != parent:
            if parent == stopAncestor:
                break
            
            if parent.role == rolenames.ROLE_FILLER and parent.role == rolenames.ROLE_FORM and parent.role == rolenames.ROLE_LINK and parent.role == rolenames.ROLE_LIST_ITEM and parent.role == rolenames.ROLE_LIST and parent.role == rolenames.ROLE_PARAGRAPH and parent.role == rolenames.ROLE_SECTION and parent.role == rolenames.ROLE_LAYERED_PANE and parent.role == rolenames.ROLE_SPLIT_PANE and parent.role == rolenames.ROLE_SCROLL_PANE and parent.role == rolenames.ROLE_UNKNOWN or self._script.isLayoutOnly(parent):
                parent = parent.parent
                continue
            
            if parent.role == rolenames.ROLE_MENU and not parent.state.count(atspi.Accessibility.STATE_FOCUSABLE):
                parent = parent.parent
                continue
            
            if parent.role != rolenames.ROLE_TABLE_CELL:
                utterances.append(rolenames.getSpeechForRoleName(parent))
            
            if parent.role == rolenames.ROLE_AUTOCOMPLETE:
                parent = parent.parent
                continue
            
            if parent.text:
                displayedText = parent.text.getText(0, -1)
                unicodeText = displayedText.decode('UTF-8')
                if unicodeText and len(unicodeText) == 1 and unicodeText[0] == util.EMBEDDED_OBJECT_CHARACTER:
                    parent = parent.parent
                    continue
                
            
            text = util.getDisplayedText(parent)
            label = util.getDisplayedLabel(parent)
            if text and text != label and len(text):
                utterances.append(text)
            
            if label and len(label):
                utterances.append(label)
            
            parent = parent.parent
        utterances.reverse()
        return utterances



class Script(default.Script):
    '''The script for Firefox.

    NOTE: THIS IS UNDER DEVELOPMENT AND DOES NOT PROVIDE ANY COMPELLING
    ACCESS TO FIREFOX AT THIS POINT.
    '''
    
    def __init__(self, app):
        default.Script.__init__(self, app)
        self._caretNavigationFunctions = [
            Script.goNextCharacter,
            Script.goPreviousCharacter,
            Script.goNextWord,
            Script.goPreviousWord,
            Script.goNextLine,
            Script.goPreviousLine]
        self._structuralNavigationFunctions = [
            Script.goNextHeading,
            Script.goPreviousHeading,
            Script.goNextChunk,
            Script.goPreviousChunk]
        if controlCaretNavigation:
            debug.println(debug.LEVEL_CONFIGURATION, 'Orca is controlling the caret.')
        else:
            debug.println(debug.LEVEL_CONFIGURATION, 'Gecko is controlling the caret.')
        self._loadingDocumentContent = False
        self._documentFrameCaretContext = { }

    
    def getBrailleGenerator(self):
        '''Returns the braille generator for this script.
        '''
        return BrailleGenerator(self)

    
    def getSpeechGenerator(self):
        '''Returns the speech generator for this script.
        '''
        return SpeechGenerator(self)

    
    def setupInputEventHandlers(self):
        '''Defines InputEventHandler fields for this script that can be
        called by the key and braille bindings.
        '''
        default.Script.setupInputEventHandlers(self)
        self.inputEventHandlers['dumpContentsHandler'] = input_event.InputEventHandler(Script.dumpContents, 'Dumps document content to stdout.')
        self.inputEventHandlers['goNextCharacterHandler'] = input_event.InputEventHandler(Script.goNextCharacter, 'Goes to next character.')
        self.inputEventHandlers['goPreviousCharacterHandler'] = input_event.InputEventHandler(Script.goPreviousCharacter, 'Goes to previous character.')
        self.inputEventHandlers['goNextWordHandler'] = input_event.InputEventHandler(Script.goNextWord, 'Goes to next word.')
        self.inputEventHandlers['goPreviousWordHandler'] = input_event.InputEventHandler(Script.goPreviousWord, 'Goes to previous word.')
        self.inputEventHandlers['goNextLineHandler'] = input_event.InputEventHandler(Script.goNextLine, 'Goes to next line.')
        self.inputEventHandlers['goPreviousLineHandler'] = input_event.InputEventHandler(Script.goPreviousLine, 'Goes to previous line.')
        self.inputEventHandlers['goPreviousHeadingHandler'] = input_event.InputEventHandler(Script.goPreviousHeading, 'Goes to previous heading.')
        self.inputEventHandlers['goNextHeadingHandler'] = input_event.InputEventHandler(Script.goNextHeading, 'Goes to next heading.')
        self.inputEventHandlers['goPreviousChunkHandler'] = input_event.InputEventHandler(Script.goPreviousChunk, 'Goes to previous chunk.')
        self.inputEventHandlers['goNextChunkHandler'] = input_event.InputEventHandler(Script.goNextChunk, 'Goes to next chunk.')
        self.inputEventHandlers['toggleCaretNavigationHandler'] = input_event.InputEventHandler(Script.toggleCaretNavigation, 'Switches between Firefox native and Orca caret navigation.')

    
    def getListeners(self):
        '''Sets up the AT-SPI event listeners for this script.
        '''
        listeners = default.Script.getListeners(self)
        listeners['document:reload'] = self.onDocumentReload
        listeners['document:load-complete'] = self.onDocumentLoadComplete
        listeners['document:load-stopped'] = self.onDocumentLoadStopped
        listeners['object:visible-data-changed'] = self.onVisibleDataChanged
        listeners['object:property-change:accessible_value'] = self.onValueChanged
        return listeners

    
    def __getArrowBindings(self):
        '''Returns an instance of keybindings.KeyBindings that use the
        arrow keys for navigating HTML content.
        '''
        keyBindings = keybindings.KeyBindings()
        keyBindings.add(keybindings.KeyBinding('Right', 1 << atspi.Accessibility.MODIFIER_CONTROL, 0, self.inputEventHandlers['goNextCharacterHandler']))
        keyBindings.add(keybindings.KeyBinding('Left', 1 << atspi.Accessibility.MODIFIER_CONTROL, 0, self.inputEventHandlers['goPreviousCharacterHandler']))
        keyBindings.add(keybindings.KeyBinding('Right', 1 << atspi.Accessibility.MODIFIER_CONTROL, 1 << atspi.Accessibility.MODIFIER_CONTROL, self.inputEventHandlers['goNextWordHandler']))
        keyBindings.add(keybindings.KeyBinding('Left', 1 << atspi.Accessibility.MODIFIER_CONTROL, 1 << atspi.Accessibility.MODIFIER_CONTROL, self.inputEventHandlers['goPreviousWordHandler']))
        keyBindings.add(keybindings.KeyBinding('Up', 0, 0, self.inputEventHandlers['goPreviousLineHandler']))
        keyBindings.add(keybindings.KeyBinding('Down', 0, 0, self.inputEventHandlers['goNextLineHandler']))
        return keyBindings

    
    def getKeyBindings(self):
        '''Defines the key bindings for this script.

        Returns an instance of keybindings.KeyBindings.
        '''
        keyBindings = default.Script.getKeyBindings(self)
        keyBindings.add(keybindings.KeyBinding('h', 1 << atspi.Accessibility.MODIFIER_SHIFT | 1 << atspi.Accessibility.MODIFIER_ALT, 1 << atspi.Accessibility.MODIFIER_SHIFT, self.inputEventHandlers['goPreviousHeadingHandler']))
        keyBindings.add(keybindings.KeyBinding('h', 1 << atspi.Accessibility.MODIFIER_SHIFT | 1 << atspi.Accessibility.MODIFIER_ALT, 0, self.inputEventHandlers['goNextHeadingHandler']))
        keyBindings.add(keybindings.KeyBinding('o', 1 << atspi.Accessibility.MODIFIER_SHIFT | 1 << atspi.Accessibility.MODIFIER_ALT, 1 << atspi.Accessibility.MODIFIER_SHIFT, self.inputEventHandlers['goPreviousChunkHandler']))
        keyBindings.add(keybindings.KeyBinding('o', 1 << atspi.Accessibility.MODIFIER_SHIFT | 1 << atspi.Accessibility.MODIFIER_ALT, 0, self.inputEventHandlers['goNextChunkHandler']))
        keyBindings.add(keybindings.KeyBinding('F12', 1 << settings.MODIFIER_ORCA, 1 << settings.MODIFIER_ORCA, self.inputEventHandlers['toggleCaretNavigationHandler']))
        if controlCaretNavigation:
            for keyBinding in self._Script__getArrowBindings().keyBindings:
                keyBindings.add(keyBinding)
            
        
        return keyBindings

    
    def consumesKeyboardEvent(self, keyboardEvent):
        '''Called when a key is pressed on the keyboard.

        Arguments:
        - keyboardEvent: an instance of input_event.KeyboardEvent

        Returns True if the event is of interest.
        '''
        user_bindings = None
        user_bindings_map = settings.keyBindingsMap
        if user_bindings_map.has_key(self.__module__):
            user_bindings = user_bindings_map[self.__module__]
        elif user_bindings_map.has_key('default'):
            user_bindings = user_bindings_map['default']
        
        consumes = False
        if user_bindings:
            handler = user_bindings.getInputHandler(keyboardEvent)
            if handler and handler._function in self._caretNavigationFunctions:
                return self.useCaretNavigationModel(keyboardEvent)
            elif handler and handler._function in self._structuralNavigationFunctions:
                return self.useStructuralNavigationModel()
            else:
                consumes = handler != None
        
        if not consumes:
            handler = self.keyBindings.getInputHandler(keyboardEvent)
            if handler and handler._function in self._caretNavigationFunctions:
                return self.useCaretNavigationModel(keyboardEvent)
            elif handler and handler._function in self._structuralNavigationFunctions:
                return self.useStructuralNavigationModel()
            else:
                consumes = handler != None
        
        return consumes

    
    def onCaretMoved(self, event):
        """Caret movement in Gecko is somewhat unreliable and
        unpredictable, but we need to handle it.  When we detect caret
        movement, we make sure we update our own notion of the caret
        position: our caretContext is an [obj, characterOffset] that
        points to our current item and character (if applicable) of
        interest.  If our current item doesn't implement the
        accessible text specialization, the characterOffset value
        is meaningless (and typically -1)."""
        orca.setLocusOfFocus(event, event.source, False)
        if not self.inDocumentContent():
            default.Script.onCaretMoved(self, event)
            return None
        
        self.caretContext = self.findFirstCaretContext(event.source, event.source.text.caretOffset)
        (obj, characterOffset) = self.caretContext
        documentFrame = self.getDocumentFrame()
        if documentFrame:
            self._documentFrameCaretContext[documentFrame] = self.caretContext
        
        if isinstance(orca_state.lastInputEvent, input_event.KeyboardEvent):
            string = orca_state.lastInputEvent.event_string
            mods = orca_state.lastInputEvent.modifiers
            if string == 'Left' or string == 'Right':
                (obj, characterOffset) = self.caretContext
                self.targetCharacterExtents = self.getExtents(obj, characterOffset, characterOffset + 1)
            
        
        default.Script.onCaretMoved(self, event)

    
    def onTextDeleted(self, event):
        '''Called whenever text is from an an object.

        Arguments:
        - event: the Event
        '''
        
        try:
            del event.source.unicodeText
        except:
            pass

        default.Script.onTextDeleted(self, event)

    
    def onTextInserted(self, event):
        '''Called whenever text is inserted into an object.

        Arguments:
        - event: the Event
        '''
        
        try:
            del event.source.unicodeText
        except:
            pass

        default.Script.onTextInserted(self, event)

    
    def onDocumentReload(self, event):
        '''Called when the reload button is hit for a web page.'''
        self._loadingDocumentContent = True
        self._loadingDocumentContent = True

    
    def onDocumentLoadComplete(self, event):
        '''Called when a web page load is completed.'''
        self._loadingDocumentContent = False

    
    def onDocumentLoadStopped(self, event):
        '''Called when a web page load is interrupted.'''
        self._loadingDocumentContent = False

    
    def onNameChanged(self, event):
        '''Called whenever a property on an object changes.

        Arguments:
        - event: the Event
        '''
        pass

    
    def onFocus(self, event):
        if event.source.role == rolenames.ROLE_FRAME or not len(event.source.role):
            return None
        
        if event.source.role == rolenames.ROLE_PANEL:
            documentFrame = self.getDocumentFrame()
            if documentFrame and documentFrame.parent == event.source:
                return None
            
        
        if event.source and event.source.role == rolenames.ROLE_DOCUMENT_FRAME:
            
            try:
                (obj, characterOffset) = self.caretContext
                orca.setLocusOfFocus(event, obj)
                return None

        
        if event.source.role == rolenames.ROLE_MENU_ITEM:
            parent = event.source.parent
            if parent and parent.role == rolenames.ROLE_COMBO_BOX:
                orca.setLocusOfFocus(event, parent)
                orca.visualAppearanceChanged(event, parent)
                return None
            elif parent and parent.role == rolenames.ROLE_MENU:
                parent = parent.parent
                if parent and parent.role == rolenames.ROLE_COMBO_BOX:
                    orca.setLocusOfFocus(event, parent, False)
                    orca.visualAppearanceChanged(event, parent)
                    return None
                
            
        
        if event.source.role == rolenames.ROLE_AUTOCOMPLETE:
            return None
        
        if event.source.role == rolenames.ROLE_LINK:
            containingLink = self.getContainingLink(orca_state.locusOfFocus)
            if containingLink == event.source:
                return None
            elif event.source.childCount == 1:
                child = event.source.child(0)
                orca.setLocusOfFocus(event, child)
                return None
            
        
        default.Script.onFocus(self, event)

    
    def onLinkSelected(self, event):
        text = event.source.text
        hypertext = event.source.hypertext
        linkIndex = util.getLinkIndex(event.source, text.caretOffset)
        if linkIndex >= 0:
            link = hypertext.getLink(linkIndex)
            linkText = self.getText(event.source, link.startIndex, link.endIndex)
            (string, startOffset, endOffset) = text.getTextAtOffset(text.caretOffset, atspi.Accessibility.TEXT_BOUNDARY_LINE_START)
            speech.speak(linkText, self.voices[settings.HYPERLINK_VOICE])
        elif text:
            linkText = self.getText(event.source, 0, -1)
            speech.speak(linkText, self.voices[settings.HYPERLINK_VOICE])
        else:
            speech.speak(_('link'), self.voices[settings.HYPERLINK_VOICE])
        self.updateBraille(event.source)

    
    def onStateChanged(self, event):
        """Called whenever an object's state changes.

        Arguments:
        - event: the Event
        """
        if event.type == 'object:state-changed:busy':
            if event.source and event.source.role == rolenames.ROLE_DOCUMENT_FRAME:
                if event.detail1:
                    self._loadingDocumentContent = True
                    message = _('Loading.  Please wait.')
                    braille.displayMessage(message)
                    speech.stop()
                    speech.speak(message)
                elif event.source.name:
                    self._loadingDocumentContent = False
                    message = _('Finished loading %s.') % event.source.name
                    braille.displayMessage(message)
                    speech.stop()
                    speech.speak(message)
                else:
                    self._loadingDocumentContent = False
                    message = _('Finished loading.')
                    braille.displayMessage(message)
                    speech.stop()
                    speech.speak(message)
            
            return None
        
        default.Script.onStateChanged(self, event)

    
    def onVisibleDataChanged(self, event):
        '''Called when the visible data of an object changes.
        We do this to detect when the user switches between
        the tabs holding different URL pages in the Firefox
        window.'''
        documentFrame = None
        if event.source.role == rolenames.ROLE_FRAME and event.source.state.count(atspi.Accessibility.STATE_ACTIVE):
            documentFrame = self.getDocumentFrame()
            
            try:
                self.caretContext = self._documentFrameCaretContext[documentFrame]
            except:
                self.caretContext = self.findNextCaretInOrder(documentFrame)
                self._documentFrameCaretContext[documentFrame] = self.caretContext

            braille.displayMessage(documentFrame.name)
            speech.stop()
            speech.speak('%s %s' % (documentFrame.name, rolenames.rolenames[rolenames.ROLE_PAGE_TAB].speech))
        

    
    def visualAppearanceChanged(self, event, obj):
        """Called when the visual appearance of an object changes.  This
        method should not be called for objects whose visual appearance
        changes solely because of focus -- setLocusOfFocus is used for that.
        Instead, it is intended mostly for objects whose notional 'value' has
        changed, such as a checkbox changing state, a progress bar advancing,
        a slider moving, text inserted, caret moved, etc.

        Arguments:
        - event: if not None, the Event that caused this to happen
        - obj: the Accessible whose visual appearance changed.
        """
        if False and obj.role == rolenames.ROLE_PROGRESS_BAR:
            if self._loadingDocumentContent:
                (regions, focusedRegion) = self.brailleGenerator.getBrailleRegions(event.source)
                braille.clear()
                line = braille.Line()
                braille.addLine(line)
                braille.setFocus(focusedRegion)
                braille.refresh(True)
                if not speech.isSpeaking():
                    speech.speakUtterances(self.speechGenerator.getSpeech(event.source, True))
                
                return None
            
        
        if obj.role == rolenames.ROLE_CHECK_BOX and obj.state.count(atspi.Accessibility.STATE_FOCUSED):
            orca.setLocusOfFocus(event, obj, False)
        
        default.Script.visualAppearanceChanged(self, event, obj)

    
    def locusOfFocusChanged(self, event, oldLocusOfFocus, newLocusOfFocus):
        '''Called when the visual object with focus changes.

        Arguments:
        - event: if not None, the Event that caused the change
        - oldLocusOfFocus: Accessible that is the old locus of focus
        - newLocusOfFocus: Accessible that is the new locus of focus
        '''
        if newLocusOfFocus and self.inDocumentContent(newLocusOfFocus):
            if event.source.text:
                caretOffset = event.source.text.caretOffset
            else:
                caretOffset = 0
            self.caretContext = self.findFirstCaretContext(event.source, caretOffset)
        
        if newLocusOfFocus and newLocusOfFocus.role == rolenames.ROLE_HTML_CONTAINER:
            if self.flatReviewContext:
                self.toggleFlatReviewMode()
            
            self.updateBraille(newLocusOfFocus)
            speech.speak(rolenames.getSpeechForRoleName(newLocusOfFocus))
            return None
        
        default.Script.locusOfFocusChanged(self, event, oldLocusOfFocus, newLocusOfFocus)

    
    def updateBraille(self, obj, extraRegion = None):
        '''Updates the braille display to show the give object.

        Arguments:
        - obj: the Accessible
        - extra: extra Region to add to the end
        '''
        if not self.inDocumentContent():
            default.Script.updateBraille(self, obj, extraRegion)
            return None
        
        if not obj:
            return None
        
        braille.clear()
        line = braille.Line()
        braille.addLine(line)
        (focusedObj, focusedCharacterOffset) = self.getCaretContext()
        lineContentsOffset = focusedCharacterOffset
        if focusedObj.text:
            char = self.getText(focusedObj, focusedCharacterOffset, focusedCharacterOffset + 1)
            if char == '\n':
                lineContentsOffset = max(0, focusedCharacterOffset - 1)
            
        
        contents = self.getLineContentsAtOffset(focusedObj, max(0, lineContentsOffset))
        if not len(contents):
            return None
        
        focusedRegion = None
        for content in contents:
            (obj, startOffset, endOffset) = content
            if not obj:
                continue
            
            if not obj == focusedObj:
                if not obj.role == focusedObj.role and obj.name == focusedObj.name or obj.parent == focusedObj.parent:
                    pass
            isFocusedObj = obj.state.count(atspi.Accessibility.STATE_FOCUSED)
            if isFocusedObj:
                if obj.text:
                    if not focusedObj.text:
                        isFocusedObj = False
                    else:
                        string1 = self.getText(obj, startOffset, endOffset)
                        string2 = self.getText(focusedObj, startOffset, endOffset)
                        isFocusedObj = string1 == string2
                else:
                    isFocusedObj = not (focusedObj.text)
            
            if (obj.role in [
                rolenames.ROLE_ENTRY,
                rolenames.ROLE_PASSWORD_TEXT] or obj.role == rolenames.ROLE_DOCUMENT_FRAME) and obj.state.count(atspi.Accessibility.STATE_EDITABLE):
                label = util.getDisplayedLabel(obj)
                regions = [
                    braille.Text(obj, label)]
                eol = braille.Region(' $l')
                regions.append(eol)
                if isFocusedObj:
                    focusedRegion = regions[0]
                
            elif obj.text:
                string = self.getText(obj, startOffset, endOffset)
                regions = [
                    braille.Region(string, focusedCharacterOffset - startOffset)]
                if obj.role == rolenames.ROLE_LINK:
                    link = obj
                else:
                    link = self.getContainingLink(obj)
                if link:
                    regions.append(braille.Region(' ' + rolenames.getBrailleForRoleName(link)))
                
                if isFocusedObj and focusedCharacterOffset >= startOffset and focusedCharacterOffset < endOffset:
                    focusedRegion = regions[0]
                
            elif self.isLayoutOnly(obj):
                continue
            else:
                (regions, fRegion) = self.brailleGenerator.getBrailleRegions(obj)
                if isFocusedObj:
                    focusedRegion = fRegion
                
            if len(line.regions):
                line.addRegion(braille.Region(' '))
            
            line.addRegions(regions)
        
        if extraRegion:
            line.addRegion(extraRegion)
        
        braille.setFocus(focusedRegion)
        braille.refresh(True)

    
    def sayCharacter(self, obj):
        '''Speaks the character at the current caret position.'''
        if not self.inDocumentContent():
            default.Script.sayCharacter(self, obj)
            return None
        
        (obj, characterOffset) = self.getCaretContext()
        if obj.text:
            foo = self.getText(obj, 0, -1)
            if characterOffset >= len(foo):
                print 'YIKES in Gecko.sayCharacter!'
                characterOffset -= 1
            
        
        self.speakCharacterAtOffset(obj, characterOffset)

    
    def sayWord(self, obj):
        '''Speaks the word at the current caret position.'''
        if not self.inDocumentContent():
            default.Script.sayWord(self, obj)
            return None
        
        (obj, characterOffset) = self.getCaretContext()
        if obj.text:
            foo = self.getText(obj, 0, -1)
            if characterOffset >= len(foo):
                print 'YIKES in Gecko.sayWord!'
                characterOffset -= 1
            
        
        self.speakContents(self.getWordContentsAtOffset(obj, characterOffset))

    
    def sayLine(self, obj):
        '''Speaks the line at the current caret position.'''
        if not self.inDocumentContent():
            default.Script.sayLine(self, obj)
            return None
        
        (obj, characterOffset) = self.getCaretContext()
        if obj.text:
            foo = self.getText(obj, 0, -1)
            if characterOffset >= len(foo):
                print 'YIKES in Gecko.sayLine!'
                characterOffset -= 1
            
        
        self.speakContents(self.getLineContentsAtOffset(obj, characterOffset))

    
    def outlineExtents(self, obj, startOffset, endOffset):
        '''Draws an outline around the given text for the object or the entire
        object if it has no text.  This is for debug purposes only.

        Arguments:
        -obj: the object
        -startOffset: character offset to start at
        -endOffset: character offset just after last character to end at
        '''
        (x, y, width, height) = self.getExtents(obj, startOffset, endOffset)
        util.drawOutline(x, y, width, height)

    
    def dumpInfo(self, obj):
        '''Dumps the parental hierachy info of obj to stdout.'''
        if obj.parent:
            self.dumpInfo(obj.parent)
        
        print '---'
        if obj.role != rolenames.ROLE_DOCUMENT_FRAME and obj.text:
            string = self.getText(obj, 0, -1)
        else:
            string = ''
        print obj, obj.name, obj.role, obj.accessible.getIndexInParent(), string
        offset = self.getCharacterOffsetInParent(obj)
        if offset >= 0:
            print '  offset =', offset
        

    
    def getDocumentContents(self):
        '''Returns an ordered list where each element is composed of
        an [obj, startOffset, endOffset] tuple.  The list is created
        via an in-order traversal of the document contents starting at
        the current caret context (or the beginning of the document if
        there is no caret context).

        WARNING: THIS TRAVERSES A LARGE PART OF THE DOCUMENT AND IS
        INTENDED PRIMARILY FOR DEBUGGING PURPOSES ONLY.'''
        contents = []
        lastObj = None
        lastExtents = None
        del self.caretContext
        (obj, characterOffset) = self.getCaretContext()
        while obj:
            if True or obj.state.count(atspi.Accessibility.STATE_SHOWING):
                if obj.text:
                    characterExtents = self.getExtents(obj, characterOffset, characterOffset + 1)
                    if characterExtents != (0, 0, 0, 0):
                        if lastExtents and not self.onSameLine(lastExtents, characterExtents):
                            contents.append([
                                None,
                                -1,
                                -1])
                            lastExtents = characterExtents
                        
                    
                    if len(contents) == 0 or obj != lastObj:
                        contents.append([
                            obj,
                            characterOffset,
                            characterOffset + 1])
                    else:
                        (currentObj, startOffset, endOffset) = contents[-1]
                        if characterOffset == endOffset:
                            contents[-1] = [
                                currentObj,
                                startOffset,
                                endOffset + 1]
                        else:
                            contents.append([
                                obj,
                                characterOffset,
                                characterOffset + 1])
                else:
                    contents.append([
                        obj,
                        -1,
                        -1])
                lastObj = obj
            
            (obj, characterOffset) = self.findNextCaretInOrder(obj, characterOffset)
        return contents

    
    def getDocumentString(self):
        '''Trivial debug utility to stringify the document contents
        showing on the screen.'''
        contents = ''
        lastObj = None
        lastCharacterExtents = None
        (obj, characterOffset) = self.getCaretContext()
        while obj:
            if obj and obj.state.count(atspi.Accessibility.STATE_SHOWING):
                characterExtents = self.getExtents(obj, characterOffset, characterOffset + 1)
                if lastObj and lastObj != obj:
                    if obj.role == rolenames.ROLE_LIST_ITEM:
                        contents += '\n'
                    
                    if lastObj.role == rolenames.ROLE_LINK:
                        contents += '>'
                    elif lastCharacterExtents[1] < characterExtents[1]:
                        contents += '\n'
                    elif obj.role == rolenames.ROLE_TABLE_CELL:
                        parent = obj.parent
                        if parent.table.getColumnAtIndex(obj.index) != 0:
                            contents += ' '
                        
                    elif obj.role == rolenames.ROLE_LINK:
                        contents += '<'
                    
                
                contents += self.getCharacterAtOffset(obj, characterOffset)
                lastObj = obj
                lastCharacterOffset = characterOffset
                lastCharacterExtents = characterExtents
            
            (obj, characterOffset) = self.findNextCaretInOrder(obj, characterOffset)
        if lastObj and lastObj.role == rolenames.ROLE_LINK:
            contents += '>'
        
        return contents

    
    def dumpContents(self, inputEvent, contents = None):
        '''Dumps the document frame content to stdout.

        Arguments:
        -inputEvent: the input event that caused this to be called
        -contents: an ordered list of [obj, startOffset, endOffset] tuples
        '''
        if not contents:
            contents = self.getDocumentContents()
        
        string = ''
        extents = None
        for content in contents:
            (obj, startOffset, endOffset) = content
            if obj:
                extents = self.getBoundary(self.getExtents(obj, startOffset, endOffset), extents)
                if obj.text:
                    string += "[%s] text='%s' " % (obj.role, self.getText(obj, startOffset, endOffset))
                else:
                    string += "[%s] name='%s' " % (obj.role, obj.name)
            obj.text
            string += '\nNEWLINE\n'
        
        print '==========================='
        print string
        util.drawOutline(extents[0], extents[1], extents[2], extents[3])

    
    def inDocumentContent(self, obj = None):
        '''Returns True if the given object (defaults to the current
        locus of focus is in the document content).
        '''
        if not obj:
            obj = orca_state.locusOfFocus
        
        while obj:
            if obj.role == rolenames.ROLE_DOCUMENT_FRAME:
                return True
                continue
            obj = obj.parent
        return False

    
    def getDocumentFrame(self):
        '''Returns the document frame that holds the content being shown.'''
        documentFrame = None
        for i in range(0, self.app.childCount):
            child = self.app.child(i)
            if child.role == rolenames.ROLE_FRAME:
                relations = child.relations
                for relation in relations:
                    if relation.getRelationType() == atspi.Accessibility.RELATION_EMBEDS:
                        documentFrame = atspi.Accessible.makeAccessible(relation.getTarget(0))
                        if documentFrame.state.count(atspi.Accessibility.STATE_SHOWING):
                            break
                        else:
                            documentFrame = None
                    documentFrame.state.count(atspi.Accessibility.STATE_SHOWING)
                
        
        return documentFrame

    
    def getUnicodeText(self, obj):
        """Returns the unicode text for an object or None if the object
        doesn't implement the accessible text specialization.
        """
        
        try:
            return obj.unicodeText
        except:
            if obj.text:
                obj.unicodeText = self.getText(obj, 0, -1).decode('UTF-8')
            else:
                obj.unicodeText = None

        return obj.unicodeText

    
    def useCaretNavigationModel(self, keyboardEvent):
        '''Returns True if we should do our own caret navigation.
        '''
        if not controlCaretNavigation:
            return False
        
        if not self.inDocumentContent():
            return False
        
        weHandleIt = True
        obj = orca_state.locusOfFocus
        if obj and obj.role == rolenames.ROLE_ENTRY:
            text = obj.text
            length = text.characterCount
            caretOffset = text.caretOffset
            singleLine = obj.state.count(atspi.Accessibility.STATE_SINGLE_LINE)
            if length == 0:
                weHandleIt = True
            elif caretOffset <= 0:
                weHandleIt = keyboardEvent.event_string in [
                    'Up',
                    'Left']
            elif caretOffset >= length - 1:
                weHandleIt = keyboardEvent.event_string in [
                    'Down',
                    'Right']
            else:
                weHandleIt = False
            if singleLine and not weHandleIt:
                weHandleIt = keyboardEvent.event_string in [
                    'Up',
                    'Down']
            
        elif keyboardEvent.modifiers & 1 << atspi.Accessibility.MODIFIER_ALT:
            weHandleIt = False
        elif obj and obj.role == rolenames.ROLE_COMBO_BOX:
            weHandleIt = keyboardEvent.event_string in [
                'Left',
                'Right']
        elif obj and obj.role == rolenames.ROLE_MENU_ITEM:
            parent = obj.parent
            if parent:
                parent = parent.parent
                if parent and parent.role == rolenames.ROLE_COMBO_BOX:
                    weHandleIt = keyboardEvent.event_string in [
                        'Left',
                        'Right']
                
            
        
        return weHandleIt

    
    def useStructuralNavigationModel(self):
        """Returns True if we should do our own structural navigation.
        [[[TODO: WDW - this should return False if we're in something
        like an entry area or a list because we want their keyboard
        navigation stuff to work.]]]
        """
        letThemDoItRoles = [
            rolenames.ROLE_ENTRY,
            rolenames.ROLE_TEXT,
            rolenames.ROLE_PASSWORD_TEXT]
        obj = orca_state.locusOfFocus
        while obj:
            if obj.role == rolenames.ROLE_DOCUMENT_FRAME:
                return not obj.state.count(atspi.Accessibility.STATE_EDITABLE)
                continue
            if obj.role in letThemDoItRoles:
                return not obj.state.count(atspi.Accessibility.STATE_EDITABLE)
                continue
            obj = obj.parent
        return False

    
    def getCharacterOffsetInParent(self, obj):
        """Returns the character offset of the embedded object
        character for this object in its parent's accessible text.

        Arguments:
        - obj: an Accessible that should implement the accessible hyperlink
               specialization.

        Returns an integer representing the character offset of the
        embedded object character for this hyperlink in its parent's
        accessible text, or -1 something was amuck.
        """
        
        try:
            return obj.characterOffsetInParent
        except:
            if obj.hyperlink:
                index = 0
                text = self.getUnicodeText(obj.parent)
                if text:
                    for offset in range(0, len(text)):
                        if text[offset] == util.EMBEDDED_OBJECT_CHARACTER:
                            if index == obj.index:
                                obj.characterOffsetInParent = offset
                                break
                            else:
                                index += 1
                        index == obj.index
                    
                else:
                    obj.characterOffsetInParent = -1
            else:
                obj.characterOffsetInParent = -1

        
        try:
            return obj.characterOffsetInParent
        except:
            debug.printException(debug.LEVEL_SEVERE)
            return -1


    
    def getChildIndex(self, obj, characterOffset):
        """Given an object that implements accessible text, determine
        the index of the child that is represented by an
        EMBEDDED_OBJECT_CHARACTER at characterOffset in the object's
        accessible text."""
        
        try:
            indices = obj.childrenIndices
        except:
            obj.childrenIndices = { }

        
        try:
            return obj.childrenIndices[characterOffset]
        except:
            obj.childrenIndices[characterOffset] = -1
            unicodeText = self.getUnicodeText(obj)
            if unicodeText and unicodeText[characterOffset] == util.EMBEDDED_OBJECT_CHARACTER:
                index = -1
                for character in range(0, characterOffset + 1):
                    if unicodeText[character] == util.EMBEDDED_OBJECT_CHARACTER:
                        index += 1
                        continue
                
                obj.childrenIndices[characterOffset] = index
            

        return obj.childrenIndices[characterOffset]

    
    def getExtents(self, obj, startOffset, endOffset):
        """Returns [x, y, width, height] of the text at the given offsets
        if the object implements accessible text, or just the extents of
        the object if it doesn't implement accessible text.
        """
        if not obj:
            return [
                0,
                0,
                0,
                0]
        
        if obj.text:
            extents = obj.text.getRangeExtents(startOffset, endOffset, 0)
        else:
            ext = obj.extents
            extents = [
                ext.x,
                ext.y,
                ext.width,
                ext.height]
        return extents

    
    def getBoundary(self, a, b):
        '''Returns the smallest [x, y, width, height] that encompasses
        both extents a and b.

        Arguments:
        -a: [x, y, width, height]
        -b: [x, y, width, height]
        '''
        if not a:
            return b
        
        if not b:
            return a
        
        smallestX1 = min(a[0], b[0])
        smallestY1 = min(a[1], b[1])
        largestX2 = max(a[0] + a[2], b[0] + b[2])
        largestY2 = max(a[1] + a[3], b[1] + b[3])
        return [
            smallestX1,
            smallestY1,
            largestX2 - smallestX1,
            largestY2 - smallestY1]

    
    def onSameLine(self, a, b, pixelDelta = 5):
        '''Determine if extents a and b are on the same line.

        Arguments:
        -a: [x, y, width, height]
        -b: [x, y, width, height]

        Returns True if a and b are on the same line.
        '''
        if abs(a[1] - b[1]) > 11:
            return False
        
        highestBottom = min(a[1] + a[3], b[1] + b[3])
        lowestTop = max(a[1], b[1])
        if lowestTop >= highestBottom - 1:
            return False
        
        return True
        if lowestTop < highestBottom:
            overlapAmount = highestBottom - lowestTop
            shortestHeight = min(a[3], b[3])
            return 1.0 * overlapAmount / shortestHeight > 0.25
        else:
            return False

    
    def isLabellingContents(self, obj, contents):
        '''Given and obj and a list of [obj, startOffset, endOffset] tuples,
        determine if obj is labelling anything in the tuples.'''
        if obj.role != rolenames.ROLE_LABEL:
            return False
        
        relations = obj.relations
        if not relations:
            return False
        
        for relation in relations:
            if relation.getRelationType() == atspi.Accessibility.RELATION_LABEL_FOR:
                for i in range(0, relation.getNTargets()):
                    target = atspi.Accessible.makeAccessible(relation.getTarget(i))
                    for content in contents:
                        if content[0] == target:
                            return True
                            continue
                    
                
        
        return False

    
    def getAutocompleteEntry(self, obj):
        '''Returns the ROLE_ENTRY object of a ROLE_AUTOCOMPLETE object or
        None if the entry cannot be found.
        '''
        for i in range(0, obj.childCount):
            child = obj.child(i)
            if child and child.role == rolenames.ROLE_ENTRY:
                return child
                continue
        

    
    def getCellCoordinates(self, obj):
        '''Returns the [row, col] of a ROLE_TABLE_CELL or [0, 0] if this
        if the coordinates cannot be found.
        '''
        parent = obj.parent
        if parent and parent.table:
            row = obj.index / parent.table.nColumns
            col = obj.index % parent.table.nColumns
            return [
                row,
                col]
        
        return [
            0,
            0]

    
    def getCellHeaders(self, obj):
        '''Returns the [rowHeader, colHeader] of a ROLE_TABLE_CELL or
        [None, None] if the headers cannot be found.
        '''
        parent = obj.parent
        if parent and parent.table:
            (row, col) = self.getCellCoordinates(obj)
            rowHeader = parent.table.getRowDescription(row)
            colHeader = parent.table.getColumnDescription(col)
            return [
                rowHeader,
                colHeader]
        
        return [
            None,
            None]

    
    def getTableCaption(self, obj):
        '''Returns the ROLE_CAPTION object of a ROLE_TABLE object or None
        if the caption cannot be found.
        '''
        for i in range(0, obj.childCount):
            child = obj.child(i)
            if child and child.role == rolenames.ROLE_CAPTION:
                return child
                continue
        

    
    def getLinkBasename(self, obj):
        '''Returns the relevant information from the URI.  The idea is
        to attempt to strip off all prefix and suffix, much like the
        basename command in a shell.'''
        basename = None
        if obj and obj.hyperlink:
            uri = obj.hyperlink.getURI(0)
            if uri and len(uri):
                if uri[-1] == '/':
                    basename = uri[0:-1]
                    basename = basename.split('/')[-1]
                else:
                    basename = uri.split('/')[-1]
                    basename = basename.split('.')[0]
                    basename = basename.split('?')[0]
                    basename = basename.split('#')[0]
            
        
        return basename

    
    def getContainingLink(self, obj):
        '''Returns the link containing the given object, or None if the
        given object is not in a link.'''
        if not obj:
            return None
        
        linkObj = None
        obj = obj.parent
        while obj and obj != obj.parent:
            if obj.role == rolenames.ROLE_LINK:
                linkObj = obj
                break
                continue
            if obj.role == rolenames.ROLE_DOCUMENT_FRAME:
                break
                continue
            obj = obj.parent
        return linkObj

    
    def isUselessObject(self, obj):
        """Returns true if the given object is an obj that doesn't
        have any meaning associated with it and it is not inside a
        link."""
        if not obj:
            return True
        
        useless = False
        if obj.role in [
            rolenames.ROLE_IMAGE,
            rolenames.ROLE_TABLE_CELL]:
            text = util.getDisplayedText(obj)
            if not text or len(text) == 0:
                text = util.getDisplayedLabel(obj)
                if not text or len(text) == 0:
                    useless = True
                
            
        
        if useless:
            link = self.getContainingLink(obj)
            if link:
                useless = False
            
        
        return useless

    
    def isLayoutOnly(self, obj):
        '''Returns True if the given object is a table and is for layout
        purposes only.'''
        if self.isUselessObject(obj):
            debug.println(debug.LEVEL_FINEST, 'Object deemed to be useless: ' + obj.toString('', True))
            return True
        else:
            return default.Script.isLayoutOnly(self, obj)

    
    def pursueForFlatReview(self, obj):
        '''Determines if we should look any further at the object
        for flat review.'''
        pursue = default.Script.pursueForFlatReview(self, obj)
        if pursue and obj.role == rolenames.ROLE_DOCUMENT_FRAME:
            documentFrame = self.getDocumentFrame()
            pursue = obj == documentFrame
        
        return pursue

    
    def findFirstCaretContext(self, obj, characterOffset):
        """Given an object and a character offset, find the first
        [obj, characterOffset] that is actually presenting something
        on the display.  The reason we do this is that the
        [obj, characterOffset] passed in may actually be pointing
        to an embedded object character.  In those cases, we dig
        into the hierarchy to find the 'real' thing.

        Arguments:
        -obj: an accessible object
        -characterOffset: the offset of the character where to start
        looking for real rext

        Returns [obj, characterOffset] that points to real content.
        """
        if obj.text:
            unicodeText = self.getUnicodeText(obj)
            if characterOffset >= len(unicodeText):
                return [
                    obj,
                    -1]
            
            character = self.getText(obj, characterOffset, characterOffset + 1).decode('UTF-8')
            if character == util.EMBEDDED_OBJECT_CHARACTER:
                
                try:
                    childIndex = self.getChildIndex(obj, characterOffset)
                    return self.findFirstCaretContext(obj.child(childIndex), 0)
                return [
                    obj,
                    -1]

            else:
                extents = self.getExtents(obj, characterOffset, characterOffset + 1)
                if extents == (0, 0, 0, 0) and characterOffset + 1 < len(unicodeText):
                    return self.findFirstCaretContext(obj, characterOffset + 1)
                else:
                    return [
                        obj,
                        characterOffset]
        else:
            return [
                obj,
                -1]

    
    def findNextCaretInOrder(self, obj = None, startOffset = -1, includeNonText = True):
        '''Given an object at a character offset, return the next
        caret context following an in-order traversal rule.

        Arguments:
        - root: the Accessible to start at.  If None, starts at the
        document frame.
        - startOffset: character position in the object text field
        (if it exists) to start at.  Defaults to -1, which means
        start at the beginning - that is, the next character is the
        first character in the object.
        - includeNonText: If False, only land on objects that support the
        accessible text interface; otherwise, include logical leaf
        nodes like check boxes, combo boxes, etc.

        Returns [obj, characterOffset] or [None, -1]
        '''
        if not obj:
            obj = self.getDocumentFrame()
        
        if obj.text:
            unicodeText = self.getUnicodeText(obj)
            nextOffset = startOffset + 1
            if nextOffset < len(unicodeText):
                if unicodeText[nextOffset] != util.EMBEDDED_OBJECT_CHARACTER:
                    return [
                        obj,
                        nextOffset]
                elif obj.childCount:
                    child = obj.child(self.getChildIndex(obj, nextOffset))
                    if child:
                        return self.findNextCaretInOrder(child, -1, includeNonText)
                    
                
            
        elif obj.childCount and obj.child(0):
            
            try:
                return self.findNextCaretInOrder(obj.child(0), -1, includeNonText)
            debug.printException(debug.LEVEL_SEVERE)

        elif includeNonText and startOffset < 0 and not self.isLayoutOnly(obj):
            extents = obj.extents
            if extents.width != 0 and extents.height != 0:
                return [
                    obj,
                    0]
            
        
        if obj.role == rolenames.ROLE_DOCUMENT_FRAME:
            return [
                None,
                -1]
        
        while obj.parent and obj != obj.parent:
            characterOffsetInParent = self.getCharacterOffsetInParent(obj)
            if characterOffsetInParent >= 0:
                return self.findNextCaretInOrder(obj.parent, characterOffsetInParent, includeNonText)
            else:
                index = obj.index + 1
                if index < obj.parent.childCount:
                    
                    try:
                        return self.findNextCaretInOrder(obj.parent.child(index), -1, includeNonText)
                    debug.printException(debug.LEVEL_SEVERE)

                
            obj = obj.parent
        return [
            None,
            -1]

    
    def findPreviousCaretInOrder(self, obj = None, startOffset = -1, includeNonText = True):
        '''Given an object an a character offset, return the previous
        caret context following an in order traversal rule.

        Arguments:
        - root: the Accessible to start at.  If None, starts at the
        document frame.
        - startOffset: character position in the object text field
        (if it exists) to start at.  Defaults to -1, which means
        start at the end - that is, the previous character is the
        last character of the object.

        Returns [obj, characterOffset] or [None, -1]
        '''
        if not obj:
            obj = self.getDocumentFrame()
        
        if obj.text:
            unicodeText = self.getUnicodeText(obj)
            if startOffset == -1:
                startOffset = len(unicodeText)
            
            previousOffset = startOffset - 1
            if previousOffset >= 0:
                if unicodeText[previousOffset] != util.EMBEDDED_OBJECT_CHARACTER:
                    return [
                        obj,
                        previousOffset]
                else:
                    return self.findPreviousCaretInOrder(obj.child(self.getChildIndex(obj, previousOffset)), -1, includeNonText)
            
        elif obj.childCount and obj.child(obj.childCount - 1):
            
            try:
                return self.findPreviousCaretInOrder(obj.child(obj.childCount - 1), -1, includeNonText)
            debug.printException(debug.LEVEL_SEVERE)

        elif includeNonText and startOffset < 0 and not self.isLayoutOnly(obj):
            extents = obj.extents
            if extents.width != 0 and extents.height != 0:
                return [
                    obj,
                    0]
            
        
        if obj.role == rolenames.ROLE_DOCUMENT_FRAME:
            return [
                None,
                -1]
        
        while obj.parent and obj != obj.parent:
            characterOffsetInParent = self.getCharacterOffsetInParent(obj)
            if characterOffsetInParent >= 0:
                return self.findPreviousCaretInOrder(obj.parent, characterOffsetInParent, includeNonText)
            else:
                index = obj.index - 1
                if index >= 0:
                    
                    try:
                        return self.findPreviousCaretInOrder(obj.parent.child(index), -1, includeNonText)
                    debug.printException(debug.LEVEL_SEVERE)

                
            obj = obj.parent
        return [
            None,
            -1]

    
    def findPreviousObject(self, obj):
        """Finds the object prior to this one, where the tree we're
        dealing with is a DOM and 'prior' means the previous object
        in a linear presentation sense.

        Arguments:
        -obj: the object where to start.
        """
        previousObj = None
        index = obj.index - 1
        if index < 0 and obj.role != rolenames.ROLE_DOCUMENT_FRAME:
            previousObj = obj.parent
        else:
            while not isinstance(previousObj, atspi.Accessible) and index >= 0:
                previousObj = obj.parent.child(index)
                index -= 1
            if not previousObj:
                if obj.role != rolenames.ROLE_DOCUMENT_FRAME:
                    previousObj = obj.parent
                
            else:
                while previousObj.childCount:
                    index = previousObj.childCount - 1
                    while index >= 0:
                        child = previousObj.child(index)
                        if isinstance(child, atspi.Accessible):
                            previousObj = child
                            break
                            continue
                        index -= 1
                    if index < 0:
                        break
                        continue
        return previousObj

    
    def findNextObject(self, obj):
        """Finds the object after to this one, where the tree we're
        dealing with is a DOM and 'next' means the next object
        in a linear presentation sense.

        Arguments:
        -obj: the object where to start.
        """
        nextObj = None
        index = 0
        while index < obj.childCount:
            child = obj.child(index)
            if isinstance(child, atspi.Accessible):
                nextObj = child
                break
                continue
            index += 1
        if not nextObj:
            index = obj.index + 1
            while index < obj.parent.childCount:
                child = obj.parent.child(index)
                if isinstance(child, atspi.Accessible):
                    nextObj = child
                    break
                    continue
                index += 1
        
        candidate = obj
        while not nextObj:
            while candidate.index >= candidate.parent.childCount - 1 and candidate.role != rolenames.ROLE_DOCUMENT_FRAME:
                candidate = candidate.parent
            if candidate.role != rolenames.ROLE_DOCUMENT_FRAME:
                index = candidate.index + 1
                while index < candidate.parent.childCount:
                    child = candidate.parent.child(index)
                    if isinstance(child, atspi.Accessible):
                        nextObj = child
                        break
                        continue
                    index += 1
                candidate = candidate.parent
                continue
            break
        return nextObj

    
    def findPreviousRole(self, roles):
        '''Finds the caret offset at the beginning of the next object
        using the given roles list as a pattern to match.

        Arguments:
        -roles: a list of roles from rolenames.py
        '''
        (currentObj, characterOffset) = self.getCaretContext()
        ancestors = []
        obj = currentObj.parent
        while obj:
            ancestors.append(obj)
            obj = obj.parent
        obj = self.findPreviousObject(currentObj)
        while obj:
            if obj not in ancestors and obj.role in roles and not self.isLayoutOnly(obj):
                return self.findFirstCaretContext(obj, 0)
                continue
            obj = self.findPreviousObject(obj)
        return [
            None,
            -1]

    
    def findNextRole(self, roles):
        '''Finds the caret offset at the beginning of the next object
        using the given roles list as a pattern to match or not match.

        Arguments:
        -roles: a list of roles from rolenames.py
        -match: if True, the found object will have a role from roles;
                if False, the found object will not have a role from roles
        '''
        (currentObj, characterOffset) = self.getCaretContext()
        ancestors = []
        obj = currentObj.parent
        while obj:
            ancestors.append(obj)
            obj = obj.parent
        obj = self.findNextObject(currentObj)
        while obj:
            if obj not in ancestors and obj.role in roles and not self.isLayoutOnly(obj):
                return self.findFirstCaretContext(obj, 0)
                continue
            obj = self.findNextObject(obj)
        return [
            None,
            -1]

    
    def getCaretContext(self, includeNonText = True):
        '''Returns the current [obj, caretOffset] if defined.  If not,
        it returns the first [obj, caretOffset] found by an in order
        traversal from the beginning of the document.'''
        
        try:
            return self.caretContext
        except:
            self.caretContext = self.findNextCaretInOrder(None, -1, includeNonText)

        return self.caretContext

    
    def getCharacterAtOffset(self, obj, characterOffset):
        '''Returns the character at the given characterOffset in the
        given object or None if the object does not implement the
        accessible text specialization.
        '''
        if obj and obj.text:
            unicodeText = self.getUnicodeText(obj)
            return unicodeText[characterOffset].encode('UTF-8')
        else:
            return None

    
    def getWordContentsAtOffset(self, obj, characterOffset):
        '''Returns an ordered list where each element is composed of
        an [obj, startOffset, endOffset] tuple.  The list is created
        via an in-order traversal of the document contents starting at
        the given object and characterOffset.  The first element in
        the list represents the beginning of the word.  The last
        element in the list represents the character just before the
        beginning of the next word.

        Arguments:
        -obj: the object to start at
        -characterOffset: the characterOffset in the object
        '''
        if not obj:
            return []
        
        contents = []
        encounteredText = False
        lastObj = obj
        lastCharacterOffset = characterOffset
        while obj == lastObj:
            if not obj.text:
                break
            else:
                character = self.getCharacterAtOffset(obj, characterOffset)
                if util.isWordDelimiter(character):
                    if encounteredText:
                        break
                    
                else:
                    encounteredText = True
            lastObj = obj
            lastCharacterOffset = characterOffset
            (obj, characterOffset) = self.findPreviousCaretInOrder(obj, characterOffset)
        contents.append([
            lastObj,
            lastCharacterOffset,
            lastCharacterOffset + 1])
        encounteredText = False
        encounteredDelimiter = False
        obj = lastObj
        characterOffset = lastCharacterOffset
        while obj and obj == lastObj:
            if not obj.text:
                break
            else:
                character = self.getCharacterAtOffset(obj, characterOffset)
                if not util.isWordDelimiter(character):
                    if encounteredText and encounteredDelimiter:
                        break
                    
                    encounteredText = True
                else:
                    encounteredDelimiter = True
            lastObj = obj
            lastCharacterOffset = characterOffset
            (obj, characterOffset) = self.findNextCaretInOrder(obj, characterOffset)
            contents[-1][2] = lastCharacterOffset + 1
        return contents

    
    def getLineContentsAtOffset(self, obj, characterOffset):
        '''Returns an ordered list where each element is composed of
        an [obj, startOffset, endOffset] tuple.  The list is created
        via an in-order traversal of the document contents starting at
        the given object and characterOffset.  The first element in
        the list represents the beginning of the line.  The last
        element in the list represents the character just before the
        beginning of the next line.

        Arguments:
        -obj: the object to start at
        -characterOffset: the characterOffset in the object
        '''
        if not obj:
            return []
        
        contents = []
        lineExtents = self.getExtents(obj, characterOffset, characterOffset + 1)
        lastObj = obj
        lastCharacterOffset = characterOffset
        while obj:
            (obj, characterOffset) = self.findPreviousCaretInOrder(obj, characterOffset)
            extents = self.getExtents(obj, characterOffset, characterOffset + 1)
            if extents != (0, 0, 0, 0):
                if lineExtents == (0, 0, 0, 0):
                    lineExtents = extents
                elif not self.onSameLine(extents, lineExtents):
                    break
                else:
                    lineExtents = self.getBoundary(lineExtents, extents)
                    lastObj = obj
                    lastCharacterOffset = characterOffset
            lineExtents == (0, 0, 0, 0)
        obj = lastObj
        characterOffset = lastCharacterOffset
        while obj:
            extents = self.getExtents(obj, characterOffset, characterOffset + 1)
            if extents != (0, 0, 0, 0):
                if not self.onSameLine(extents, lineExtents):
                    break
                elif lastObj == obj and len(contents):
                    contents[-1][2] = characterOffset + 1
                else:
                    contents.append([
                        obj,
                        characterOffset,
                        characterOffset + 1])
                lineExtents = self.getBoundary(lineExtents, extents)
                lastObj = obj
                lastCharacterOffset = characterOffset
            
            (obj, characterOffset) = self.findNextCaretInOrder(obj, characterOffset)
        return contents

    
    def getObjectContentsAtOffset(self, obj, characterOffset):
        '''Returns an ordered list where each element is composed of
        an [obj, startOffset, endOffset] tuple.  The list is created
        via an in-order traversal of the document contents starting and
        stopping at the given object.
        '''
        if not obj.text:
            return [
                [
                    obj,
                    -1,
                    -1]]
        
        contents = []
        text = self.getUnicodeText(obj)
        for offset in range(characterOffset, len(text)):
            if text[offset] == util.EMBEDDED_OBJECT_CHARACTER:
                contents.extend(self.getObjectContentsAtOffset(obj.child(self.getChildIndex(obj, offset)), 0))
                continue
            if len(contents):
                (currentObj, startOffset, endOffset) = contents[-1]
                if obj == currentObj:
                    contents[-1] = [
                        obj,
                        startOffset,
                        offset + 1]
                else:
                    contents.append([
                        obj,
                        offset,
                        offset + 1])
            obj == currentObj
            contents.append([
                obj,
                offset,
                offset + 1])
        
        return contents

    
    def getACSS(self, obj, string):
        '''Returns the ACSS to speak anything for the given obj.'''
        if obj.role == rolenames.ROLE_LINK:
            acss = self.voices[settings.HYPERLINK_VOICE]
        elif string and string.isupper() and string.strip().isalpha():
            acss = self.voices[settings.UPPERCASE_VOICE]
        else:
            acss = self.voices[settings.DEFAULT_VOICE]
        return acss

    
    def getUtterancesFromContents(self, contents, speakRole = True):
        '''Returns a list of [text, acss] tuples based upon the
        list of [obj, startOffset, endOffset] tuples passed in.

        Arguments:
        -contents: a list of [obj, startOffset, endOffset] tuples
        -speakRole: if True, speak the roles of objects
        '''
        if not len(contents):
            return []
        
        utterances = []
        for content in contents:
            (obj, startOffset, endOffset) = content
            if not obj:
                continue
            
            if self.isLabellingContents(obj, contents):
                continue
            
            if obj.text:
                strings = [
                    self.getText(obj, startOffset, endOffset)]
                if obj.role not in [
                    rolenames.ROLE_DOCUMENT_FRAME,
                    rolenames.ROLE_TABLE_CELL]:
                    strings.extend(self.speechGenerator._getSpeechForObjectRole(obj))
                
            elif self.isLayoutOnly(obj):
                continue
            else:
                strings = self.speechGenerator.getSpeech(obj, False)
            for string in strings:
                utterances.append([
                    string,
                    self.getACSS(obj, string)])
            
        
        return utterances

    
    def speakContents(self, contents):
        utterances = self.getUtterancesFromContents(contents)
        clumped = []
        for string, acss in utterances:
            if len(clumped) == 0:
                clumped = [
                    [
                        string,
                        acss]]
                continue
            if acss == clumped[-1][1]:
                clumped[-1][0] += ' ' + string
                continue
            clumped.append([
                string,
                acss])
        
        if len(clumped) == 1 and clumped[0][0] == '\n':
            if settings.speakBlankLines:
                speech.speak(_('blank'), clumped[0][1], False)
            
        else:
            for string, acss in clumped:
                speech.speak(string, acss, False)
            

    
    def speakCharacterAtOffset(self, obj, characterOffset):
        '''Speaks the character at the given characterOffset in the
        given object.'''
        character = self.getCharacterAtOffset(obj, characterOffset)
        if obj:
            if character:
                speech.speak(character, self.getACSS(obj, character), False)
            else:
                utterances = self.speechGenerator.getSpeech(obj, False)
                speech.speakUtterances(utterances)
        

    
    def setCaretPosition(self, obj, characterOffset):
        '''Sets the caret position to the given character offset in the
        given object.
        '''
        caretContext = self.getCaretContext()
        documentFrame = self.getDocumentFrame()
        if documentFrame:
            self._documentFrameCaretContext[documentFrame] = caretContext
        
        if caretContext == [
            obj,
            characterOffset]:
            return None
        
        self.caretContext = [
            obj,
            characterOffset]
        if obj != orca_state.locusOfFocus:
            orca.setLocusOfFocus(None, obj, False)
            objectForFocus = obj
            while objectForFocus and obj:
                if objectForFocus.state.count(atspi.Accessibility.STATE_FOCUSABLE):
                    break
                    continue
                objectForFocus = objectForFocus.parent
            if objectForFocus:
                focusGrabbed = objectForFocus.component.grabFocus()
            
        
        character = self.getCharacterAtOffset(obj, characterOffset)
        if character:
            if obj.role != rolenames.ROLE_LIST_ITEM:
                caretSet = obj.text.setCaretOffset(characterOffset)
                mag.magnifyAccessible(None, obj, self.getExtents(obj, characterOffset, characterOffset + 1))
            
        

    
    def goNextCharacter(self, inputEvent):
        '''Positions the caret offset to the next character or object
        in the document window.
        '''
        (obj, characterOffset) = self.getCaretContext()
        while obj:
            (obj, characterOffset) = self.findNextCaretInOrder(obj, characterOffset)
            if obj and obj.state.count(atspi.Accessibility.STATE_SHOWING):
                break
                continue
        if obj:
            self.setCaretPosition(obj, characterOffset)
        else:
            del self.caretContext
        self.updateBraille(obj)
        self.speakCharacterAtOffset(obj, characterOffset)

    
    def goPreviousCharacter(self, inputEvent):
        '''Positions the caret offset to the previous character or object
        in the document window.
        '''
        (obj, characterOffset) = self.getCaretContext()
        while obj:
            (obj, characterOffset) = self.findPreviousCaretInOrder(obj, characterOffset)
            if obj and obj.state.count(atspi.Accessibility.STATE_SHOWING):
                break
                continue
        if obj:
            self.setCaretPosition(obj, characterOffset)
        else:
            del self.caretContext
        self.updateBraille(obj)
        self.speakCharacterAtOffset(obj, characterOffset)

    
    def goPreviousWord(self, inputEvent):
        '''Positions the caret offset to beginning of the previous
        word or object in the document window.
        '''
        (obj, characterOffset) = self.getCaretContext()
        contents = self.getWordContentsAtOffset(obj, characterOffset)
        (obj, startOffset, endOffset) = contents[0]
        (obj, characterOffset) = self.findPreviousCaretInOrder(obj, startOffset)
        contents = self.getWordContentsAtOffset(obj, characterOffset)
        if not len(contents):
            return None
        
        (obj, startOffset, endOffset) = contents[0]
        self.setCaretPosition(obj, startOffset)
        self.updateBraille(obj)
        self.speakContents(self.getWordContentsAtOffset(obj, startOffset))

    
    def goNextWord(self, inputEvent):
        '''Positions the caret offset to the end of next word or object
        in the document window.
        '''
        (obj, characterOffset) = self.getCaretContext()
        contents = self.getWordContentsAtOffset(obj, characterOffset)
        (obj, startOffset, endOffset) = contents[0]
        (obj, characterOffset) = self.findNextCaretInOrder(obj, endOffset - 1)
        contents = self.getWordContentsAtOffset(obj, characterOffset)
        if not len(contents):
            return None
        
        (obj, startOffset, endOffset) = contents[0]
        self.setCaretPosition(obj, startOffset)
        self.updateBraille(obj)
        self.speakContents(self.getWordContentsAtOffset(obj, startOffset))

    
    def goPreviousLine(self, inputEvent):
        '''Positions the caret offset at the previous line in the
        document window, attempting to preserve horizontal caret
        position.
        '''
        (obj, characterOffset) = self.getCaretContext()
        lineExtents = self.getExtents(obj, characterOffset, characterOffset + 1)
        
        try:
            characterExtents = self.targetCharacterExtents
        except:
            characterExtents = lineExtents

        crossedLineBoundary = False
        lastObj = obj
        lastCharacterOffset = characterOffset
        while obj:
            extents = self.getExtents(obj, characterOffset, characterOffset + 1)
            if obj.text:
                if characterOffset > 0:
                    previousChar = obj.text.getText(characterOffset - 1, characterOffset)
                else:
                    previousChar = None
                currentChar = obj.text.getText(characterOffset, characterOffset + 1)
            else:
                previousChar = None
                currentChar = None
            validExtents = True
            if extents[2] < 0 or extents[3] < 0:
                validExtents = False
            
            if validExtents and extents != (0, 0, 0, 0):
                if not self.onSameLine(extents, lineExtents):
                    if not crossedLineBoundary:
                        lineExtents = extents
                        if currentChar != '\n':
                            crossedLineBoundary = True
                        elif previousChar == '\n':
                            crossedLineBoundary = True
                        
                    else:
                        break
                elif crossedLineBoundary and extents[0] <= characterExtents[0]:
                    break
                else:
                    lineExtents = self.getBoundary(lineExtents, extents)
                lastObj = obj
                lastCharacterOffset = characterOffset
            
            (obj, characterOffset) = self.findPreviousCaretInOrder(obj, characterOffset)
        contents = self.getLineContentsAtOffset(lastObj, lastCharacterOffset)
        if not len(contents):
            return None
        
        if arrowToLineBeginning:
            (lastObj, lastCharacterOffset, endOffset) = contents[0]
        
        self.setCaretPosition(lastObj, lastCharacterOffset)
        self.updateBraille(lastObj)
        self.speakContents(contents)

    
    def goNextLine(self, inputEvent):
        '''Positions the caret offset at the next line in the document
        window, attempting to preserve horizontal caret position.
        '''
        (obj, characterOffset) = self.getCaretContext()
        lineExtents = self.getExtents(obj, characterOffset, characterOffset + 1)
        
        try:
            characterExtents = self.targetCharacterExtents
        except:
            characterExtents = lineExtents

        crossedLineBoundary = False
        lastObj = obj
        lastCharacterOffset = characterOffset
        while obj:
            extents = self.getExtents(obj, characterOffset, characterOffset + 1)
            if obj.text:
                if characterOffset > 0:
                    previousChar = obj.text.getText(characterOffset - 1, characterOffset)
                else:
                    previousChar = None
                currentChar = obj.text.getText(characterOffset, characterOffset + 1)
            else:
                previousChar = None
                currentChar = None
            validExtents = True
            if extents[2] < 0 or extents[3] < 0:
                validExtents = False
            
            if validExtents and extents != (0, 0, 0, 0):
                if not self.onSameLine(extents, lineExtents):
                    if not crossedLineBoundary:
                        lineExtents = extents
                        if currentChar != '\n':
                            crossedLineBoundary = True
                        elif previousChar == '\n':
                            crossedLineBoundary = True
                        
                        if crossedLineBoundary and arrowToLineBeginning:
                            lastObj = obj
                            lastCharacterOffset = characterOffset
                            break
                        
                    else:
                        break
                elif crossedLineBoundary and extents[0] >= characterExtents[0]:
                    break
                else:
                    lineExtents = self.getBoundary(extents, lineExtents)
                lastObj = obj
                lastCharacterOffset = characterOffset
            
            (obj, characterOffset) = self.findNextCaretInOrder(obj, characterOffset)
        self.setCaretPosition(lastObj, lastCharacterOffset)
        self.updateBraille(lastObj)
        self.speakContents(self.getLineContentsAtOffset(lastObj, lastCharacterOffset))

    
    def goPreviousHeading(self, inputEvent):
        (obj, characterOffset) = self.findPreviousRole([
            rolenames.ROLE_HEADING])
        if obj:
            (obj, characterOffset) = self.findFirstCaretContext(obj, 0)
            self.setCaretPosition(obj, characterOffset)
            self.speakContents(self.getLineContentsAtOffset(obj, characterOffset))
        else:
            speech.speak(_('No more headings.'))

    
    def goNextHeading(self, inputEvent):
        (obj, characterOffset) = self.findNextRole([
            rolenames.ROLE_HEADING])
        if obj:
            (obj, characterOffset) = self.findFirstCaretContext(obj, 0)
            self.setCaretPosition(obj, characterOffset)
            self.updateBraille(obj)
            self.speakContents(self.getLineContentsAtOffset(obj, characterOffset))
        else:
            speech.speak(_('No more headings.'))

    
    def goPreviousChunk(self, inputEvent):
        (obj, characterOffset) = self.findPreviousRole(OBJECT_ROLES)
        if obj:
            (obj, characterOffset) = self.findFirstCaretContext(obj, 0)
            self.setCaretPosition(obj, characterOffset)
            self.updateBraille(obj)
            self.speakContents(self.getObjectContentsAtOffset(obj, characterOffset))
        else:
            speech.speak(_('No more chunks.'))

    
    def goNextChunk(self, inputEvent):
        (obj, characterOffset) = self.findNextRole(OBJECT_ROLES)
        if obj:
            (obj, characterOffset) = self.findFirstCaretContext(obj, 0)
            self.setCaretPosition(obj, characterOffset)
            self.updateBraille(obj)
            self.speakContents(self.getObjectContentsAtOffset(obj, characterOffset))
        else:
            speech.speak(_('No more chunks.'))

    
    def toggleCaretNavigation(self, inputEvent):
        '''Toggles between Firefox native and Orca caret navigation.'''
        global controlCaretNavigation, controlCaretNavigation
        if controlCaretNavigation:
            for keyBinding in self._Script__getArrowBindings().keyBindings:
                self.keyBindings.removeByHandler(keyBinding.handler)
            
            controlCaretNavigation = False
            string = 'Gecko is controlling the caret.'
        else:
            controlCaretNavigation = True
            for keyBinding in self._Script__getArrowBindings().keyBindings:
                self.keyBindings.add(keyBinding)
            
            string = 'Orca is controlling the caret.'
        debug.println(debug.LEVEL_CONFIGURATION, string)
        speech.speak(string)
        braille.displayMessage(string)


