# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

__id__ = '$Id: J2SE-access-bridge.py 1543 2006-10-12 00:33:48Z wwalker $'
__version__ = '$Revision: 1543 $'
__date__ = '$Date: 2006-10-11 20:33:48 -0400 (Wed, 11 Oct 2006) $'
__copyright__ = 'Copyright (c) 2005-2006 Sun Microsystems Inc.'
__license__ = 'LGPL'
import atspi
import default
import debug
import orca
import orca_state
import keybindings
import settings
import speech
import util
import rolenames
import Accessibility
import speechgenerator
from orca_i18n import _

class SpeechGenerator(speechgenerator.SpeechGenerator):
    '''Overrides _getSpeechForLabel
    '''
    
    def __init__(self, script):
        speechgenerator.SpeechGenerator.__init__(self, script)

    
    def _getSpeechForLabel(self, obj, already_focused):
        '''Get the speech for a label.

        Arguments:
        - obj: the label
        - already_focused: False if object just received focus

        Returns a list of utterances to be spoken for the object.
        '''
        utterances = []
        if not already_focused:
            utterances = self._getDefaultSpeech(obj, already_focused)
        
        obj.was_selected = False
        if obj.state.count(Accessibility.STATE_EXPANDED) != 0:
            utterances.append(_('expanded'))
        elif obj.state.count(Accessibility.STATE_EXPANDED) == 0 and obj.state.count(Accessibility.STATE_EXPANDABLE) != 0:
            utterances.append(_('collapsed'))
        elif obj.state.count(Accessibility.STATE_SELECTED) != 0:
            utterances.append(_('selected'))
            obj.was_selected = True
        elif obj.state.count(Accessibility.STATE_SELECTED) == 0 and obj.state.count(Accessibility.STATE_SELECTABLE) != 0:
            utterances.append(_('unselected'))
        
        self._debugGenerator('_getSpeechForLabel', obj, already_focused, utterances)
        return utterances



class Script(default.Script):
    
    def __init__(self, app):
        '''Creates a new script for Java applications.

        Arguments:
        - app: the application to create a script for.
        '''
        default.Script.__init__(self, app)

    
    def getSpeechGenerator(self):
        '''Returns the speech generator for this script.
        '''
        return SpeechGenerator(self)

    
    def consumesKeyboardEvent(self, keyboardEvent):
        '''Called when a key is pressed on the keyboard.

        Arguments:
        - keyboardEvent: an instance of input_event.KeyboardEvent

        Returns True if the event is of interest.
        '''
        keysym = keyboardEvent.event_string
        keyboardEvent.hw_code = keybindings._getKeycode(keysym)
        return default.Script.consumesKeyboardEvent(self, keyboardEvent)

    
    def onFocus(self, event):
        '''Called whenever an object gets focus.

        Arguments:
        - event: the Event
        '''
        role = event.source.role
        if role == rolenames.ROLE_LIST:
            selectedItem = None
            selection = event.source.selection
            if selection and selection.nSelectedChildren > 0:
                selectedItem = atspi.Accessible.makeAccessible(selection.getSelectedChild(0))
            elif event.source.childCount > 0:
                selectedItem = event.source.child(0)
            
            if selectedItem:
                orca.setLocusOfFocus(event, selectedItem)
            else:
                orca.setLocusOfFocus(event, event.source)
        elif role == rolenames.ROLE_LABEL:
            if not event.source.state.count(Accessibility.STATE_SHOWING):
                return None
            
        elif role == rolenames.ROLE_MENU:
            orca.setLocusOfFocus(event, event.source)
        else:
            default.Script.onFocus(self, event)

    
    def onStateChanged(self, event):
        """Called whenever an object's state changes.  Currently, the
        state changes for non-focused objects are ignored.

        Arguments:
        - event: the Event
        """
        if event.source.role == rolenames.ROLE_ROOT_PANE and event.type == 'object:state-changed:focused' and event.detail1 == 1:
            for i in range(0, event.source.childCount):
                child = event.source.child(i)
                if child.role == rolenames.ROLE_LAYERED_PANE:
                    popup = util.findByRole(child, rolenames.ROLE_POPUP_MENU, False)
                    if len(popup) > 0:
                        item = util.findByRole(popup[0], rolenames.ROLE_MENU_ITEM, False)
                        for j in range(0, len(item)):
                            if item[j].state.count(Accessibility.STATE_ARMED):
                                orca.setLocusOfFocus(event, item[j])
                                return None
                                continue
                        
                    
                len(popup) > 0
            
        
        if event.type == 'object:state-changed:focused':
            return None
        
        if event.source.role == rolenames.ROLE_LABEL and event.type == 'object:state-changed:expanded':
            orca.visualAppearanceChanged(event, event.source)
            return None
        
        if event.type == 'object:state-changed:visible' and event.source.role == rolenames.ROLE_POPUP_MENU and event.source.parent.state.count(Accessibility.STATE_FOCUSED):
            orca.setLocusOfFocus(event, event.source.parent)
            return None
        
        default.Script.onStateChanged(self, event)

    
    def onSelectionChanged(self, event):
        """Called when an object's selection changes.

        Arguments:
        - event: the Event
        """
        if not event.source.state.count(atspi.Accessibility.STATE_FOCUSED):
            return None
        
        if event.source.role == rolenames.ROLE_TABLE:
            return None
        
        if event.source.role == rolenames.ROLE_TREE:
            return None
        
        if event.source.role == rolenames.ROLE_LIST:
            selection = event.source.selection
            if selection.nSelectedChildren <= 0:
                if event.source.childCount > 0:
                    child = event.source.child(0)
                    if child.state.count(atspi.Accessibility.STATE_ACTIVE):
                        return None
                    
                else:
                    orca.setLocusOfFocus(event, event.source)
                    return None
            else:
                selectedItem = atspi.Accessible.makeAccessible(selection.getSelectedChild(0))
                if util.isSameObject(selectedItem, orca_state.locusOfFocus):
                    if (orca_state.locusOfFocus.state.count(Accessibility.STATE_SELECTED) != 0 or not (orca_state.locusOfFocus.was_selected) or orca_state.locusOfFocus.state.count(Accessibility.STATE_SELECTED) == 0) and orca_state.locusOfFocus.state.count(Accessibility.STATE_SELECTABLE) != 0 and orca_state.locusOfFocus.was_selected:
                        orca.visualAppearanceChanged(event, selectedItem)
                    
                    return None
                
        
        default.Script.onSelectionChanged(self, event)

    
    def onValueChanged(self, event):
        """Called whenever an object's value changes.  Currently, the
        value changes for non-focused objects are ignored.
        
        Arguments:
        - event: the Event
        """
        if event.source.role == rolenames.ROLE_CHECK_BOX and event.type == 'object:property-change:accessible-value':
            return None
        

    
    def visualAppearanceChanged(self, event, obj):
        """Called when the visual appearance of an object changes.  This
        method should not be called for objects whose visual appearance
        changes solely because of focus -- setLocusOfFocus is used for that.
        Instead, it is intended mostly for objects whose notional 'value' has
        changed, such as a checkbox changing state, a progress bar advancing,
        a slider moving, text inserted, caret moved, etc.

        Arguments:
        - event: if not None, the Event that caused this to happen
        - obj: the Accessible whose visual appearance changed.
        """
        if util.isSameObject(obj, orca_state.locusOfFocus):
            if obj.role == rolenames.ROLE_LABEL:
                self.updateBraille(orca_state.locusOfFocus)
                speech.speakUtterances(self.speechGenerator.getSpeech(orca_state.locusOfFocus, True))
                return None
            
        
        default.Script.visualAppearanceChanged(self, event, obj)


