# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

'''Displays a GUI for the Orca Find window'''
__id__ = '$Id: orca_gui_find.py 1753 2006-11-30 16:38:58Z richb $'
__version__ = '$Revision: 1753 $'
__date__ = '$Date: 2006-11-30 11:38:58 -0500 (Thu, 30 Nov 2006) $'
__copyright__ = 'Copyright (c) 2005-2006 Sun Microsystems Inc.'
__license__ = 'LGPL'
import os
import sys
import debug
import gettext
import gtk
import gtk.glade as gtk
import locale
import default
import find
import orca
import orca_glade
import orca_state
import platform
from orca_i18n import _
OS = None

class orcaFindGUI(orca_glade.GladeWrapper):
    
    def _init(self):
        self.searchString = ''
        self.searchBackwards = False
        self.caseSensitive = False
        self.matchEntireWord = False
        self.windowWrap = True
        self.startAtTop = False
        self.activeScript = orca_state.activeScript

    
    def _showGUI(self):
        '''Show the Orca Find dialog. This assumes that the GUI has
        already been created.
        '''
        
        try:
            self.findDialog.realize()
            self.findDialog.window.set_user_time(orca_state.lastInputEventTimestamp)
        except AttributeError:
            debug.printException(debug.LEVEL_FINEST)

        self.findDialog.show()
        
        try:
            self.searchForEntry.set_text(orca_state.searchQuery.searchString)
            self.searchForEntry.select_region(0, len(self.searchForEntry.get_text()))
            if orca_state.searchQuery.startAtTop:
                self.topRadioButton.set_active(True)
            
            self.matchCaseCheckbox.set_active(orca_state.searchQuery.caseSensitive)
            self.matchEntireWordCheckbox.set_active(orca_state.searchQuery.matchEntireWord)
            self.wrapAroundCheckbox.set_active(orca_state.searchQuery.windowWrap)
            self.searchBackwardsCheckbox.set_active(orca_state.searchQuery.searchBackwards)
        except:
            pass


    
    def searchForEntryChanged(self, widget):
        '''Signal handler for the "changed" signal for the
           searchForEntry GtkEntry widget. The user has changed
           the string to be searched for.

        Arguments:
        - widget: the component that generated the signal.
        '''
        self.searchString = widget.get_text()
        if len(self.searchString) > 0:
            self.findButton.set_sensitive(True)
        else:
            self.findButton.set_sensitive(False)

    
    def startingPointChanged(self, widget):
        '''Signal handler for the "toggled" signal for the
           currentLocationRadioButton or topRadioButton GtkRadioButton
           widgets. The user has toggled the starting point for the search.

        Arguments:
        - widget: the component that generated the signal.
        '''
        if widget.get_active():
            if widget.get_label() == _('C_urrent location'):
                self.startAtTop = False
            else:
                self.startAtTop = True
        

    
    def matchCaseChecked(self, widget):
        '''Signal handler for the "toggled" signal for the
           matchCaseCheckbox GtkCheckButton widget. The user has
           [un]checked the "Match Case" checkbox.

        Arguments:
        - widget: the component that generated the signal.
        '''
        self.caseSensitive = widget.get_active()

    
    def matchEntireWordChecked(self, widget):
        '''Signal handler for the "toggled" signal for the
           matchEntireWordCheckbox GtkCheckButton widget.
           The user has [un]checked the "Match entire word"
           checkbox.

        Arguments:
        - widget: the component that generated the signal.
        '''
        self.matchEntireWord = widget.get_active()

    
    def searchBackwardsChecked(self, widget):
        '''Signal handler for the "toggled" signal for the
           searchBackwardsCheckbox GtkCheckButton widget.
           The user has [un]checked the "Search backwards"
           checkbox.

        Arguments:
        - widget: the component that generated the signal.
        '''
        self.searchBackwards = widget.get_active()

    
    def wrapAroundChecked(self, widget):
        '''Signal handler for the "toggled" signal for the
           wrapAroundCheckbox GtkCheckButton widget. The user has
           [un]checked the "Wrap around" checkbox.

        Arguments:
        - widget: the component that generated the signal.
        '''
        self.windowWrap = widget.get_active()

    
    def closeButtonClicked(self, widget):
        '''Signal handler for the "clicked" signal for the cancelButton
           GtkButton widget. The user has clicked the Cancel button.
           Hide the dialog.

        Arguments:
        - widget: the component that generated the signal.
        '''
        self.findDialog.hide()

    
    def findButtonClicked(self, widget):
        '''Signal handler for the "clicked" signal for the findButton
           GtkButton widget. The user has clicked the Find button.
           Call the method to begin the search.

        Arguments:
        - widget: the component that generated the signal.
        '''
        orca_state.searchQuery = find.SearchQuery()
        orca_state.searchQuery.searchString = self.searchString
        orca_state.searchQuery.searchBackwards = self.searchBackwards
        orca_state.searchQuery.caseSensitive = self.caseSensitive
        orca_state.searchQuery.matchEntireWord = self.matchEntireWord
        orca_state.searchQuery.startAtTop = self.startAtTop
        orca_state.searchQuery.windowWrap = self.windowWrap
        self.activeScript.findCommandRun = True
        self.findDialog.destroy()

    
    def findDialogDestroyed(self, widget):
        '''Signal handler for the "destroyed" signal for the findDialog
           GtkWindow widget. Reset OS to None.

        Arguments:
        - widget: the component that generated the signal.
        '''
        global OS
        OS = None



def showFindUI():
    global OS
    if not OS:
        gladeFile = os.path.join(platform.prefix, platform.datadirname, platform.package, 'glade', 'orca-find.glade')
        OS = orcaFindGUI(gladeFile, 'findDialog')
        OS._init()
    
    OS._showGUI()


def main():
    locale.setlocale(locale.LC_ALL, '')
    showFindUI()
    gtk.main()
    sys.exit(0)

if __name__ == '__main__':
    main()

