# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

'''Displays a GUI for the user to quit Orca.'''
__id__ = '$Id: orca_quit.py 1515 2006-10-02 19:28:57Z richb $'
__version__ = '$Revision: 1515 $'
__date__ = '$Date: 2006-10-02 15:28:57 -0400 (Mon, 02 Oct 2006) $'
__copyright__ = 'Copyright (c) 2005-2006 Sun Microsystems Inc.'
__license__ = 'LGPL'
import os
import sys
import debug
import gettext
import gtk
import gtk.glade as gtk
import locale
import orca
import orca_glade
import orca_state
import platform
import settings
from orca_i18n import _
OS = None

class orcaQuitGUI(orca_glade.GladeWrapper):
    
    def _init(self):
        pass

    
    def _showGUI(self):
        '''Show the Orca quit GUI dialog. This assumes that the GUI has 
        already been created.
        '''
        
        try:
            self.quitDialog.realize()
            self.quitDialog.window.set_user_time(orca_state.lastInputEventTimestamp)
        except AttributeError:
            debug.printException(debug.LEVEL_FINEST)

        self.quitDialog.show()

    
    def quitNoButtonClicked(self, widget):
        '''Signal handler for the "clicked" signal for the quitNoButton
           GtkButton widget. The user has clicked the No button.
           Don\'t quit Orca. Just hide the quit dialog and recreate the
           Orca main window.

        Arguments:
        - widget: the component that generated the signal.
        '''
        self.quitDialog.hide()
        if settings.showMainWindow:
            orca._showMainWindowGUI()
        

    
    def quitYesButtonClicked(self, widget):
        '''Signal handler for the "clicked" signal for the quitYesButton
           GtkButton widget. The user has clicked the Yes button.
           Call the orca.shutdown() method to gracefully terminate Orca.

        Arguments:
        - widget: the component that generated the signal.
        '''
        orca.shutdown()

    
    def quitDialogDestroyed(self, widget):
        '''Signal handler for the "destroyed" signal for the quitDialog
           GtkWindow widget. Reset OS to None, so that the GUI can be rebuilt
           from the Glade file the next time the user wants to display the
           quit dialog GUI.

        Arguments:
        - widget: the component that generated the signal.
        '''
        global OS
        OS = None



def showQuitUI():
    global OS
    if not OS:
        gladeFile = os.path.join(platform.prefix, platform.datadirname, platform.package, 'glade', 'orca-quit.glade')
        OS = orcaQuitGUI(gladeFile, 'quitDialog')
        OS._init()
    
    OS._showGUI()


def main():
    locale.setlocale(locale.LC_ALL, '')
    showQuitUI()
    gtk.main()
    sys.exit(0)

if __name__ == '__main__':
    main()

