# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

'''Provides the PresentationManager class for Orca.'''
__id__ = '$Id: presentation_manager.py 1533 2006-10-06 07:59:04Z richb $'
__version__ = '$Revision: 1533 $'
__date__ = '$Date: 2006-10-06 03:59:04 -0400 (Fri, 06 Oct 2006) $'
__copyright__ = 'Copyright (c) 2005-2006 Sun Microsystems Inc.'
__license__ = 'LGPL'

class PresentationManager:
    '''High level manager for reacting to user input events and
    presenting information to the user.'''
    
    def processKeyboardEvent(self, keyboardEvent):
        '''Called when a key is pressed on the keyboard.

        Arguments:
        - keyboardEvent: an instance of input_event.KeyboardEvent

        Returns True if the event should be consumed.
        '''
        return False

    
    def processBrailleEvent(self, brailleEvent):
        '''Called when keys or buttons are pressed on the Braille display.

        Arguments:
        - brailleEvent: an instance of input_event.BrailleEvent

        Returns True if the command was consumed; otherwise False
        '''
        return False

    
    def locusOfFocusChanged(self, event, oldLocusOfFocus, newLocusOfFocus):
        '''Called when the visual object with focus changes.

        Arguments:
        - event: if not None, the Event that caused the change
        - oldLocusOfFocus: Accessible that is the old locus of focus
        - newLocusOfFocus: Accessible that is the new locus of focus
        '''
        pass

    
    def visualAppearanceChanged(self, event, obj):
        """Called when the visual appearance of an object changes.
        This method should not be called for objects whose visual
        appearance changes solely because of focus -- locusOfFocusChanged
        is used for that.  Instead, it is intended mostly for objects
        whose notional 'value' has changed, such as a checkbox changing
        state, a progress bar advancing, a slider moving, text inserted,
        caret moved, etc.

        Arguments:
        - event: if not None, the Event that caused this to happen
        - obj: the Accessible whose visual appearance changed.
        """
        pass

    
    def activate(self):
        '''Called when this presentation manager is activated.'''
        pass

    
    def deactivate(self):
        '''Called when this presentation manager is deactivated.'''
        pass


