# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

'''Punctuation Verbosity settings.
The Orca punctuation settings are broken up into 4 modes.

These modes are None, Some, Most and All.

They are defined by a group of radio buttons on the speech
page of the configuration user interface.

Each mode is defined below. The 4 bits of information listed here are:

  - The actual printed symbol.

  - How the symbol should be pronounced (in the chnames dictionary in
    chnames.py keyed by symbol).

  - The level at which the symbol should be spoken. Note that this
    denotes the level containing all lower levels.

  - Whether or not the spoken name for the symbol should replace the
    actual symbol or be inserted before the symbol.
'''
__id__ = '$Id: punctuation_settings.py 2073 2007-03-01 17:20:32Z wwalker $'
__version__ = '$Revision: 2073 $'
__date__ = '$Date: 2007-03-01 12:20:32 -0500 (Thu, 01 Mar 2007) $'
__copyright__ = 'Copyright (c) 2005-2006 Sun Microsystems Inc.'
__license__ = 'LGPL'
import settings
PUNCTUATION_REPLACE = 0
PUNCTUATION_INSERT = 1
__punctuation = { }
__punctuation['!'] = [
    settings.PUNCTUATION_STYLE_ALL,
    PUNCTUATION_INSERT]
__punctuation["'"] = [
    settings.PUNCTUATION_STYLE_ALL,
    PUNCTUATION_REPLACE]
__punctuation[','] = [
    settings.PUNCTUATION_STYLE_ALL,
    PUNCTUATION_INSERT]
__punctuation['.'] = [
    settings.PUNCTUATION_STYLE_ALL,
    PUNCTUATION_INSERT]
__punctuation['?'] = [
    settings.PUNCTUATION_STYLE_ALL,
    PUNCTUATION_INSERT]
__punctuation['"'] = [
    settings.PUNCTUATION_STYLE_MOST,
    PUNCTUATION_REPLACE]
__punctuation['('] = [
    settings.PUNCTUATION_STYLE_MOST,
    PUNCTUATION_REPLACE]
__punctuation[')'] = [
    settings.PUNCTUATION_STYLE_MOST,
    PUNCTUATION_REPLACE]
__punctuation['-'] = [
    settings.PUNCTUATION_STYLE_MOST,
    PUNCTUATION_REPLACE]
__punctuation['_'] = [
    settings.PUNCTUATION_STYLE_MOST,
    PUNCTUATION_REPLACE]
__punctuation[':'] = [
    settings.PUNCTUATION_STYLE_MOST,
    PUNCTUATION_INSERT]
__punctuation[';'] = [
    settings.PUNCTUATION_STYLE_MOST,
    PUNCTUATION_INSERT]
__punctuation['<'] = [
    settings.PUNCTUATION_STYLE_MOST,
    PUNCTUATION_REPLACE]
__punctuation['>'] = [
    settings.PUNCTUATION_STYLE_MOST,
    PUNCTUATION_REPLACE]
__punctuation['['] = [
    settings.PUNCTUATION_STYLE_MOST,
    PUNCTUATION_REPLACE]
__punctuation[']'] = [
    settings.PUNCTUATION_STYLE_MOST,
    PUNCTUATION_REPLACE]
__punctuation['\\'] = [
    settings.PUNCTUATION_STYLE_MOST,
    PUNCTUATION_REPLACE]
__punctuation['|'] = [
    settings.PUNCTUATION_STYLE_MOST,
    PUNCTUATION_REPLACE]
__punctuation['`'] = [
    settings.PUNCTUATION_STYLE_MOST,
    PUNCTUATION_REPLACE]
__punctuation['~'] = [
    settings.PUNCTUATION_STYLE_MOST,
    PUNCTUATION_REPLACE]
__punctuation['{'] = [
    settings.PUNCTUATION_STYLE_MOST,
    PUNCTUATION_REPLACE]
__punctuation['}'] = [
    settings.PUNCTUATION_STYLE_MOST,
    PUNCTUATION_REPLACE]
__punctuation['#'] = [
    settings.PUNCTUATION_STYLE_SOME,
    PUNCTUATION_REPLACE]
__punctuation['$'] = [
    settings.PUNCTUATION_STYLE_SOME,
    PUNCTUATION_REPLACE]
__punctuation['%'] = [
    settings.PUNCTUATION_STYLE_SOME,
    PUNCTUATION_REPLACE]
__punctuation['&'] = [
    settings.PUNCTUATION_STYLE_SOME,
    PUNCTUATION_REPLACE]
__punctuation['*'] = [
    settings.PUNCTUATION_STYLE_SOME,
    PUNCTUATION_REPLACE]
__punctuation['+'] = [
    settings.PUNCTUATION_STYLE_SOME,
    PUNCTUATION_REPLACE]
__punctuation['/'] = [
    settings.PUNCTUATION_STYLE_SOME,
    PUNCTUATION_REPLACE]
__punctuation['='] = [
    settings.PUNCTUATION_STYLE_SOME,
    PUNCTUATION_REPLACE]
__punctuation['@'] = [
    settings.PUNCTUATION_STYLE_SOME,
    PUNCTUATION_REPLACE]
__punctuation['^'] = [
    settings.PUNCTUATION_STYLE_SOME,
    PUNCTUATION_REPLACE]

def getPunctuationInfo(character):
    '''Given a punctuation character, return the value
    [punctuation_style, punctuation_action] or None

    Arguments:
    - character: the punctuation character to get the information for

    Returns return the value [punctuation_style, punctuation_action]
    or None
    '''
    if isinstance(character, unicode):
        character = character.encode('UTF-8')
    
    
    try:
        return __punctuation[character]
    except:
        return None


