# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

'''Provides a custom script for gcalctool.'''
__id__ = '$Id: gcalctool.py 1658 2006-11-03 21:18:21Z richb $'
__version__ = '$Revision: 1658 $'
__date__ = '$Date: 2006-11-03 16:18:21 -0500 (Fri, 03 Nov 2006) $'
__copyright__ = 'Copyright (c) 2005-2006 Sun Microsystems Inc.'
__license__ = 'LGPL'
import orca.atspi as atspi
import orca.braille as braille
import orca.default as default
import orca.input_event as input_event
import orca.orca_state as orca_state
import orca.rolenames as rolenames
import orca.speech as speech
import orca.speechgenerator as speechgenerator
import orca.util as util

class SpeechGenerator(speechgenerator.SpeechGenerator):
    """Overrides _getSpeechForPushButton to handle 'unspeakable'
    button labels displayed on the screen.
    """
    
    def __init__(self, script):
        speechgenerator.SpeechGenerator.__init__(self, script)

    
    def _getSpeechForObjectName(self, obj):
        """Gives preference to the object name versus what is being
        displayed on the screen.  This helps accomodate the naming
        hints being given to us by gcalctool for it's mathematical
        operator buttons."""
        if obj.role != rolenames.ROLE_PUSH_BUTTON:
            return speechgenerator.SpeechGenerator._getSpeechForObjectName(self, obj)
        
        if obj.name:
            name = obj.name
        else:
            name = util.getDisplayedText(obj)
        if name:
            return [
                name]
        elif obj.description:
            return [
                obj.description]
        else:
            return []



class Script(default.Script):
    
    def __init__(self, app):
        '''Creates a new script for the given application.  Callers
        should use the getScript factory method instead of calling
        this constructor directly.

        Arguments:
        - app: the application to create a script for.
        '''
        default.Script.__init__(self, app)
        self._display = None

    
    def getSpeechGenerator(self):
        '''Returns the speech generator for this script.
        '''
        return SpeechGenerator(self)

    
    def onWindowActivated(self, event):
        """Called whenever one of gcalctool's toplevel windows is activated.

        Arguments:
        - event: the window activated Event
        """
        if self._display is None and event.source.role == rolenames.ROLE_FRAME:
            d = util.findByRole(event.source, rolenames.ROLE_TEXT)
            if len(d) == 0:
                d = util.findByRole(event.source, rolenames.ROLE_EDITBAR)
            
            if len(d) == 0:
                contents = 'Unable to get calculator display'
                speech.speak(contents)
                braille.displayMessage(contents)
            else:
                self._display = d[0]
                contents = self.getText(self._display, 0, -1)
                braille.displayMessage(contents)
            default.Script.onWindowActivated(self, event)
        

    
    def onTextInserted(self, event):
        """Called whenever text is inserted into gcalctool's text display.
        If the object is an instant message or chat, speak the text If we're
        not watching anything, do the default behavior.

        Arguments:
        - event: the text inserted Event
        """
        if event.source == self._display:
            contents = self.getText(self._display, 0, -1)
            braille.displayMessage(contents)
            if orca_state.lastInputEvent is None or not isinstance(orca_state.lastInputEvent, input_event.KeyboardEvent):
                return None
            
            if orca_state.lastInputEvent.event_string == 'space' and orca_state.lastInputEvent.event_string == 'Return' or orca_state.lastInputEvent.event_string == '=':
                speech.speak(contents)
            
        


