# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

''' Custom script for Gnome Power Manager.
'''
__id__ = ''
__version__ = ''
__date__ = ''
__copyright__ = 'Copyright (c) 2005-2007 Sun Microsystems Inc.'
__license__ = 'LGPL'
import orca.orca as orca
import orca.default as default
import orca.debug as debug
import orca.settings as settings
import orca.speech as speech
import orca.util as util
from orca.orca_i18n import _

class Script(default.Script):
    
    def __init__(self, app):
        '''Creates a new script for the given application.

        Arguments:
        - app: the application to create a script for.
        '''
        self.debugLevel = debug.LEVEL_FINEST
        self._lastInfo = ''
        settings.cacheDescriptions = False
        default.Script.__init__(self, app)

    
    def getListeners(self):
        '''Sets up the AT-SPI event listeners for this script.
        '''
        listeners = default.Script.getListeners(self)
        listeners['object:bounds-changed'] = self.onBoundsChanged
        return listeners

    
    def _debug(self, msg):
        ''' Convenience method for printing debug messages
        '''
        debug.println(self.debugLevel, 'gnome-power-manager.py: ' + msg)

    
    def onBoundsChanged(self, event):
        """ Called whenever an object's bounds change. This happens
        when the Gnome Power Manager balloon is displayed on the
        desktop.

        Arguments:
        - event: the Event
        """
        info = event.source.description
        self._debug("onBoundsChanged: '%s'" % info)
        if info != self._lastInfo:
            self._lastInfo = info
            if len(info) > 0:
                speech.speak(info, None, True)
            
        


