# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

'''Custom script for gnome-search-tool'''
__id__ = '$Id: gnome-search-tool.py 1568 2006-10-17 21:38:58Z richb $'
__version__ = '$Revision: 1568 $'
__date__ = '$Date: 2006-10-17 17:38:58 -0400 (Tue, 17 Oct 2006) $'
__copyright__ = 'Copyright (c) 2005-2006 Sun Microsystems Inc.'
__license__ = 'LGPL'
import orca.debug as debug
import orca.default as default
import orca.atspi as atspi
import orca.rolenames as rolenames
import orca.orca as orca
import orca.braille as braille
import orca.speech as speech
import orca.settings as settings
import orca.util as util
from orca.orca_i18n import _
import time
import gobject
gobject.threads_init()

class Script(default.Script):
    
    def __init__(self, app):
        '''Creates a new script for the given application.

        Arguments:
        - app: the application to create a script for.
        '''
        default.Script.__init__(self, app)
        self.debugLevel = debug.LEVEL_FINEST
        self.fileTable = None
        self.searching = False
        self.startTime = None
        self.searchInterval = 5.0

    
    def _speakSearching(self):
        '''If we are still searching, let the user know. Then start another
        timer to go off again and repeat this process.
        '''
        if self.searching == False:
            return False
        
        currentTime = time.time()
        if not (self.startTime) or currentTime > self.startTime + self.searchInterval:
            speech.speak(_('Searching.'))
            self.startTime = time.time()
        
        return True

    
    def onStateChanged(self, event):
        """Called whenever an object's state changes.

        Arguments:
        - event: the Event
        """
        debug.printObjectEvent(self.debugLevel, event, event.source.toString())
        rolesList = [
            rolenames.ROLE_PUSH_BUTTON,
            rolenames.ROLE_FILLER,
            rolenames.ROLE_FILLER,
            rolenames.ROLE_FILLER,
            rolenames.ROLE_FRAME,
            rolenames.ROLE_APPLICATION]
        visible = event.source.state.count(atspi.Accessibility.STATE_VISIBLE)
        if util.isDesiredFocusedItem(event.source, rolesList) and event.source.name == _('Stop') and visible:
            debug.println(self.debugLevel, 'gnome-search-tool.onNameChanged - ' + 'search started.')
            self.searching = True
            if not self.fileTable:
                frame = util.getTopLevel(event.source)
                allTables = util.findByRole(frame, rolenames.ROLE_TABLE)
                self.fileTable = allTables[0]
            
            gobject.idle_add(self._speakSearching)
        
        if util.isDesiredFocusedItem(event.source, rolesList) and event.source.name == _('Find') and visible and self.searching:
            debug.println(self.debugLevel, 'gnome-search-tool.onNameChanged - ' + 'search completed.')
            self.searching = False
            speech.speak(_('Search complete.'))
            sensitive = self.fileTable.state.count(atspi.Accessibility.STATE_SENSITIVE)
            if sensitive:
                fileCount = self.fileTable.table.nRows
                speech.speak(str(fileCount) + _(' files found'))
            else:
                speech.speak(_('No files found.'))
        
        default.Script.onStateChanged(self, event)


