# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

'''Custom script for gnome-window-properties.'''
__id__ = '$Id: gnome-window-properties.py 1543 2006-10-12 00:33:48Z wwalker $'
__version__ = '$Revision: 1543 $'
__date__ = '$Date: 2006-10-11 20:33:48 -0400 (Wed, 11 Oct 2006) $'
__copyright__ = 'Copyright (c) 2005-2006 Sun Microsystems Inc.'
__license__ = 'LGPL'
import orca.default as default
import orca.speechgenerator as speechgenerator

class SpeechGenerator(speechgenerator.SpeechGenerator):
    '''Overrides _getSpeechForFrame so as to avoid digging into the
    gedit hierarchy and tickling a bug in gedit.
    '''
    
    def __init__(self, script):
        speechgenerator.SpeechGenerator.__init__(self, script)

    
    def _getSpeechForAlert(self, obj, already_focused):
        '''Gets the title of the dialog.  Do NOT get the contents
        of labels inside the dialog that are not associated with any
        other objects.

        Arguments:
        - obj: the Accessible dialog
        - already_focused: False if object just received focus

        Returns a list of utterances be spoken.
        '''
        utterances = []
        utterances.extend(self._getSpeechForObjectLabel(obj))
        utterances.extend(self._getSpeechForObjectName(obj))
        utterances.extend(self._getSpeechForObjectRole(obj))
        self._debugGenerator('gnome-window-properties._getSpeechForAlert', obj, already_focused, utterances)
        return utterances



class Script(default.Script):
    
    def __init__(self, app):
        '''Creates a new script for the given application.

        Arguments:
        - app: the application to create a script for.
        '''
        default.Script.__init__(self, app)

    
    def getSpeechGenerator(self):
        '''Returns the speech generator for this script.
        '''
        return SpeechGenerator(self)


