# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

import orca.debug as debug
import orca.default as default
import orca.atspi as atspi
import orca.input_event as input_event
import orca.rolenames as rolenames
import orca.braille as braille
import orca.orca_state as orca_state
import orca.speech as speech
import orca.settings as settings
import orca.util as util
import orca.speechgenerator as speechgenerator
import orca.braillegenerator as braillegenerator
import orca.eventsynthesizer as eventsynthesizer
from orca.orca_i18n import _
__id__ = '$Id:$'
__version__ = '$Revision:$'
__date__ = '$Date:$'
__copyright__ = 'Copyright (c) 2005-2006 Sun Microsystems Inc.'
__license__ = 'LGPL'

class Script(default.Script):
    
    def __init__(self, app):
        '''Creates a new script for the given application.

        Arguments:
        - app: the application to create a script for.
        '''
        default.Script.__init__(self, app)
        self.debugLevel = debug.LEVEL_FINEST

    
    def onNameChanged(self, event):
        if event.source.role != rolenames.ROLE_STATUSBAR:
            default.Script.onNameChanged(self, event)
            return None
        
        rolesList = [
            rolenames.ROLE_PUSH_BUTTON,
            rolenames.ROLE_FILLER,
            rolenames.ROLE_FILLER,
            rolenames.ROLE_FRAME]
        if util.isDesiredFocusedItem(orca_state.locusOfFocus, rolesList):
            speech.stop()
            speech.speak(event.source.name)
            braille.displayMessage(event.source.name)
        

    
    def locusOfFocusChanged(self, event, oldLocusOfFocus, newLocusOfFocus):
        '''Called when the visual object with focus changes.

        Arguments:
        - event: if not None, the Event that caused the change
        - oldLocusOfFocus: Accessible that is the old locus of focus
        - newLocusOfFocus: Accessible that is the new locus of focus
        '''
        brailleGen = self.brailleGenerator
        speechGen = self.speechGenerator
        debug.printObjectEvent(self.debugLevel, event, event.source.toString())
        rolesList = [
            rolenames.ROLE_PUSH_BUTTON,
            rolenames.ROLE_FILLER,
            rolenames.ROLE_FILLER,
            rolenames.ROLE_FRAME]
        if util.isDesiredFocusedItem(event.source, rolesList):
            utterances = []
            utterances.append(_('Work online / offline'))
            utterances.extend(speechGen.getSpeech(event.source, False))
            speech.speakUtterances(utterances)
            regions = brailleGen.getBrailleRegions(event.source)
            regions[0].insert(0, braille.Region(utterances[0] + ' '))
            braille.displayRegions(regions)
            return None
        
        if orca_state.locusOfFocus.role == rolenames.ROLE_TABLE_COLUMN_HEADER:
            table = event.source.parent
            cells = util.findByRole(table, rolenames.ROLE_TABLE_CELL)
            eventsynthesizer.clickObject(cells[1], 1)
        
        default.Script.locusOfFocusChanged(self, event, oldLocusOfFocus, newLocusOfFocus)


