# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

'''Custom script for metacity.'''
__id__ = '$Id: metacity.py 1584 2006-10-19 18:16:54Z richb $'
__version__ = '$Revision: 1584 $'
__date__ = '$Date: 2006-10-19 14:16:54 -0400 (Thu, 19 Oct 2006) $'
__copyright__ = 'Copyright (c) 2005-2006 Sun Microsystems Inc.'
__license__ = 'LGPL'
import orca.braille as braille
import orca.default as default
import orca.rolenames as rolenames
import orca.orca as orca
import orca.speech as speech
import orca.util as util
from orca.orca_i18n import _

class Script(default.Script):
    
    def __init__(self, app):
        '''Creates a new script for the given application.

        Arguments:
        - app: the application to create a script for.
        '''
        default.Script.__init__(self, app)

    
    def onNameChanged(self, event):
        '''The status bar in metacity tells us what toplevel window will be
        activated when tab is released.  We will key off the name changed
        event to determine when to say something, as it seems to be the
        more reliable event.

        Arguments:
        - event: the name changed Event
        '''
        if event.source.role != rolenames.ROLE_STATUSBAR:
            default.Script.onNameChanged(self, event)
        

    
    def onStateChanged(self, event):
        '''The status bar in metacity tells us what toplevel window will be
        activated when tab is released.

        Arguments:
        - event: the object:state-changed: Event
        '''
        if event.source.role != rolenames.ROLE_STATUSBAR:
            default.Script.onStateChanged(self, event)
        

    
    def onTextInserted(self, event):
        '''Called whenever text is inserted into an object.

        Arguments:
        - event: the Event
        '''
        if event.source.role != rolenames.ROLE_STATUSBAR:
            default.Script.onTextInserted(self, event)
        
        speech.stop()
        found = False
        for app in util.getKnownApplications():
            i = 0
            while i < app.childCount:
                win = app.child(i)
                if win is None:
                    print 'app error ' + app.name
                elif win.name == event.source.name:
                    found = True
                
                i = i + 1
        
        text = event.source.name
        if text.startswith(_('Workspace ')) or text.startswith(_('Desk ')):
            pass
        elif not found:
            text += '. ' + _('inaccessible')
        
        braille.displayMessage(text)
        speech.speak(text)

    
    def onTextDeleted(self, event):
        '''Called whenever text is deleted from an object.

        Arguments:
        - event: the Event
        '''
        if event.source.role != rolenames.ROLE_STATUSBAR:
            default.Script.onTextDeleted(self, event)
        

    
    def onCaretMoved(self, event):
        '''Called whenever the caret moves.

        Arguments:
        - event: the Event
        '''
        if event.source.role != rolenames.ROLE_STATUSBAR:
            default.Script.onCaretMoved(self, event)
        


