# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

import zipfile
import gnomevfs
from xml.dom import minidom
from xml.xpath import Evaluate
from serpentine.mastering import HintsFilter
from serpentine import urlutil
from xml.parsers.expat import ExpatError
import traceback

def safe_method(func):
    
    def wrapper(self, *args, **kwargs):
        
        try:
            return func(self, *args, **kwargs)
        except:
            traceback.print_exc()


    return wrapper


class K3BFilter(HintsFilter):
    
    def filter_location(self, location):
        url = urlutil.UrlParse(location)
        if not url.is_local:
            fd = gnomevfs.open(url.unparse())
            
            def read_all():
                buff = ''
                
                try:
                    while None:
                        buff += fd.read(1024)
                except gnomevfs.EOFError:
                    pass

                return buff

            fd.read = read_all
        else:
            
            try:
                fd = open(url.path)
            except IOError:
                return None

        
        try:
            zfile = zipfile.ZipFile(fd)
        except zipfile.BadZipfile:
            return None
        except IOError:
            return None

        
        try:
            buff = zfile.read('maindata.xml')
        except KeyError:
            fd.close()
            return None

        fd.close()
        
        try:
            root = minidom.parseString(buff)
        except ExpatError:
            return None

        hints_list = []
        for node in Evaluate('/k3b_audio_project/contents/track', root):
            
            try:
                hints_list.append({
                    'location': node.attributes['url'].value })
            continue
            except KeyError:
                continue
            

        
        for node in Evaluate('/k3b_audio_project/contents/track/sources/file', root):
            
            try:
                hints_list.append({
                    'location': node.attributes['url'].value })
            continue
            except KeyError:
                None<EXCEPTION MATCH>KeyError
                None<EXCEPTION MATCH>KeyError
                continue
            

        
        return hints_list

    filter_location = safe_method(filter_location)


def create_plugin(app):
    app.add_hints_filter(K3BFilter())
    app.register_playlist_file_pattern('K3B Audio Project', '*.k3b')
    app.register_music_file_pattern('K3B Audio Project', '*.k3b')

