# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

'''Loads XSPF filters.'''
from os import path
from serpentine import urlutil
from serpentine.mastering import HintsFilter
from serpentine import xspf

class XspfFilter(HintsFilter):
    
    def filter_location(self, location):
        url = urlutil.UrlParse(location)
        if not url.is_local:
            return None
        
        hints_list = []
        p = xspf.Playlist()
        
        try:
            p.parse(url.path)
        except Exception:
            return None

        basename = path.basename(url.path)
        for t in p.tracks:
            if t.location is None:
                continue
            
            r = {
                'location': urlutil.normalize(t.location, basename) }
            if t.title is not None:
                r['title'] = t.title
            
            if t.creator is not None:
                r['artist'] = t.creator
            
            hints_list.append(r)
        
        return hints_list



def create_plugin(serpentine_object):
    serpentine_object.register_playlist_file_pattern('XML Shareable Playlist Format', '*.xspf')
    serpentine_object.register_music_file_pattern('XML Shareable Playlist Format', '*.xspf')
    serpentine_object.add_hints_filter(XspfFilter())

