# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

'''Maintain a cache of stat() information on files.

There are functions to reset the cache or to selectively remove items.
'''
import warnings
warnings.warn('The statcache module is obsolete.  Use os.stat() instead.', DeprecationWarning)
del warnings
import os as _os
from stat import *
__all__ = [
    'stat',
    'reset',
    'forget',
    'forget_prefix',
    'forget_dir',
    'forget_except_prefix',
    'isdir']
cache = { }

def stat(path):
    '''Stat a file, possibly out of the cache.'''
    ret = cache.get(path, None)
    if ret is None:
        cache[path] = ret = _os.stat(path)
    
    return ret


def reset():
    '''Clear the cache.'''
    cache.clear()


def forget(path):
    '''Remove a given item from the cache, if it exists.'''
    
    try:
        del cache[path]
    except KeyError:
        pass



def forget_prefix(prefix):
    '''Remove all pathnames with a given prefix.'''
    for path in cache.keys():
        if path.startswith(prefix):
            forget(path)
            continue
    


def forget_dir(prefix):
    '''Forget a directory and all entries except for entries in subdirs.'''
    split = split
    join = join
    import os.path
    prefix = split(join(prefix, 'xxx'))[0]
    forget(prefix)
    for path in cache.keys():
        if path.startswith(prefix) and split(path)[0] == prefix:
            forget(path)
            continue
    


def forget_except_prefix(prefix):
    """Remove all pathnames except with a given prefix.

    Normally used with prefix = '/' after a chdir().
    """
    for path in cache.keys():
        if not path.startswith(prefix):
            forget(path)
            continue
    


def isdir(path):
    '''Return True if directory, else False.'''
    
    try:
        st = stat(path)
    except _os.error:
        return False

    return S_ISDIR(st.st_mode)

