# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

'''Library that exposes various tables found in the StringPrep RFC 3454.

There are two kinds of tables: sets, for which a member test is provided,
and mappings, for which a mapping function is provided.
'''
import unicodedata
if not unicodedata.unidata_version == '3.2.0':
    raise AssertionError

def in_table_a1(code):
    if unicodedata.category(code) != 'Cn':
        return False
    
    c = ord(code)
    if c <= c:
        pass
    elif c < 65008:
        return False
    
    return c & 65535 not in (65534, 65535)

b1_set = set([
    173,
    847,
    6150,
    6155,
    6156,
    6157,
    8203,
    8204,
    8205,
    8288,
    65279] + range(65024, 65040))

def in_table_b1(code):
    return ord(code) in b1_set

b3_exceptions = {
    181: u'μ',
    223: u'ss',
    304: u'i̇',
    329: u'ʼn',
    383: u's',
    496: u'ǰ',
    837: u'ι',
    890: u' ι',
    912: u'ΐ',
    944: u'ΰ',
    962: u'σ',
    976: u'β',
    977: u'θ',
    978: u'υ',
    979: u'ύ',
    980: u'ϋ',
    981: u'φ',
    982: u'π',
    1008: u'κ',
    1009: u'ρ',
    1010: u'σ',
    1013: u'ε',
    1415: u'եւ',
    7830: u'ẖ',
    7831: u'ẗ',
    7832: u'ẘ',
    7833: u'ẙ',
    7834: u'aʾ',
    7835: u'ṡ',
    8016: u'ὐ',
    8018: u'ὒ',
    8020: u'ὔ',
    8022: u'ὖ',
    8064: u'ἀι',
    8065: u'ἁι',
    8066: u'ἂι',
    8067: u'ἃι',
    8068: u'ἄι',
    8069: u'ἅι',
    8070: u'ἆι',
    8071: u'ἇι',
    8072: u'ἀι',
    8073: u'ἁι',
    8074: u'ἂι',
    8075: u'ἃι',
    8076: u'ἄι',
    8077: u'ἅι',
    8078: u'ἆι',
    8079: u'ἇι',
    8080: u'ἠι',
    8081: u'ἡι',
    8082: u'ἢι',
    8083: u'ἣι',
    8084: u'ἤι',
    8085: u'ἥι',
    8086: u'ἦι',
    8087: u'ἧι',
    8088: u'ἠι',
    8089: u'ἡι',
    8090: u'ἢι',
    8091: u'ἣι',
    8092: u'ἤι',
    8093: u'ἥι',
    8094: u'ἦι',
    8095: u'ἧι',
    8096: u'ὠι',
    8097: u'ὡι',
    8098: u'ὢι',
    8099: u'ὣι',
    8100: u'ὤι',
    8101: u'ὥι',
    8102: u'ὦι',
    8103: u'ὧι',
    8104: u'ὠι',
    8105: u'ὡι',
    8106: u'ὢι',
    8107: u'ὣι',
    8108: u'ὤι',
    8109: u'ὥι',
    8110: u'ὦι',
    8111: u'ὧι',
    8114: u'ὰι',
    8115: u'αι',
    8116: u'άι',
    8118: u'ᾶ',
    8119: u'ᾶι',
    8124: u'αι',
    8126: u'ι',
    8130: u'ὴι',
    8131: u'ηι',
    8132: u'ήι',
    8134: u'ῆ',
    8135: u'ῆι',
    8140: u'ηι',
    8146: u'ῒ',
    8147: u'ΐ',
    8150: u'ῖ',
    8151: u'ῗ',
    8162: u'ῢ',
    8163: u'ΰ',
    8164: u'ῤ',
    8166: u'ῦ',
    8167: u'ῧ',
    8178: u'ὼι',
    8179: u'ωι',
    8180: u'ώι',
    8182: u'ῶ',
    8183: u'ῶι',
    8188: u'ωι',
    8360: u'rs',
    8450: u'c',
    8451: u'°c',
    8455: u'ɛ',
    8457: u'°f',
    8459: u'h',
    8460: u'h',
    8461: u'h',
    8464: u'i',
    8465: u'i',
    8466: u'l',
    8469: u'n',
    8470: u'no',
    8473: u'p',
    8474: u'q',
    8475: u'r',
    8476: u'r',
    8477: u'r',
    8480: u'sm',
    8481: u'tel',
    8482: u'tm',
    8484: u'z',
    8488: u'z',
    8492: u'b',
    8493: u'c',
    8496: u'e',
    8497: u'f',
    8499: u'm',
    8510: u'γ',
    8511: u'π',
    8517: u'd',
    13169: u'hpa',
    13171: u'au',
    13173: u'ov',
    13184: u'pa',
    13185: u'na',
    13186: u'μa',
    13187: u'ma',
    13188: u'ka',
    13189: u'kb',
    13190: u'mb',
    13191: u'gb',
    13194: u'pf',
    13195: u'nf',
    13196: u'μf',
    13200: u'hz',
    13201: u'khz',
    13202: u'mhz',
    13203: u'ghz',
    13204: u'thz',
    13225: u'pa',
    13226: u'kpa',
    13227: u'mpa',
    13228: u'gpa',
    13236: u'pv',
    13237: u'nv',
    13238: u'μv',
    13239: u'mv',
    13240: u'kv',
    13241: u'mv',
    13242: u'pw',
    13243: u'nw',
    13244: u'μw',
    13245: u'mw',
    13246: u'kw',
    13247: u'mw',
    13248: u'kω',
    13249: u'mω',
    13251: u'bq',
    13254: u'c∕kg',
    13255: u'co.',
    13256: u'db',
    13257: u'gy',
    13259: u'hp',
    13261: u'kk',
    13262: u'km',
    13271: u'ph',
    13273: u'ppm',
    13274: u'pr',
    13276: u'sv',
    13277: u'wb',
    64256: u'ff',
    64257: u'fi',
    64258: u'fl',
    64259: u'ffi',
    64260: u'ffl',
    64261: u'st',
    64262: u'st',
    64275: u'մն',
    64276: u'մե',
    64277: u'մի',
    64278: u'վն',
    64279: u'մխ',
    119808: u'a',
    119809: u'b',
    119810: u'c',
    119811: u'd',
    119812: u'e',
    119813: u'f',
    119814: u'g',
    119815: u'h',
    119816: u'i',
    119817: u'j',
    119818: u'k',
    119819: u'l',
    119820: u'm',
    119821: u'n',
    119822: u'o',
    119823: u'p',
    119824: u'q',
    119825: u'r',
    119826: u's',
    119827: u't',
    119828: u'u',
    119829: u'v',
    119830: u'w',
    119831: u'x',
    119832: u'y',
    119833: u'z',
    119860: u'a',
    119861: u'b',
    119862: u'c',
    119863: u'd',
    119864: u'e',
    119865: u'f',
    119866: u'g',
    119867: u'h',
    119868: u'i',
    119869: u'j',
    119870: u'k',
    119871: u'l',
    119872: u'm',
    119873: u'n',
    119874: u'o',
    119875: u'p',
    119876: u'q',
    119877: u'r',
    119878: u's',
    119879: u't',
    119880: u'u',
    119881: u'v',
    119882: u'w',
    119883: u'x',
    119884: u'y',
    119885: u'z',
    119912: u'a',
    119913: u'b',
    119914: u'c',
    119915: u'd',
    119916: u'e',
    119917: u'f',
    119918: u'g',
    119919: u'h',
    119920: u'i',
    119921: u'j',
    119922: u'k',
    119923: u'l',
    119924: u'm',
    119925: u'n',
    119926: u'o',
    119927: u'p',
    119928: u'q',
    119929: u'r',
    119930: u's',
    119931: u't',
    119932: u'u',
    119933: u'v',
    119934: u'w',
    119935: u'x',
    119936: u'y',
    119937: u'z',
    119964: u'a',
    119966: u'c',
    119967: u'd',
    119970: u'g',
    119973: u'j',
    119974: u'k',
    119977: u'n',
    119978: u'o',
    119979: u'p',
    119980: u'q',
    119982: u's',
    119983: u't',
    119984: u'u',
    119985: u'v',
    119986: u'w',
    119987: u'x',
    119988: u'y',
    119989: u'z',
    120016: u'a',
    120017: u'b',
    120018: u'c',
    120019: u'd',
    120020: u'e',
    120021: u'f',
    120022: u'g',
    120023: u'h',
    120024: u'i',
    120025: u'j',
    120026: u'k',
    120027: u'l',
    120028: u'm',
    120029: u'n',
    120030: u'o',
    120031: u'p',
    120032: u'q',
    120033: u'r',
    120034: u's',
    120035: u't',
    120036: u'u',
    120037: u'v',
    120038: u'w',
    120039: u'x',
    120040: u'y',
    120041: u'z',
    120068: u'a',
    120069: u'b',
    120071: u'd',
    120072: u'e',
    120073: u'f',
    120074: u'g',
    120077: u'j',
    120078: u'k',
    120079: u'l',
    120080: u'm',
    120081: u'n',
    120082: u'o',
    120083: u'p',
    120084: u'q',
    120086: u's',
    120087: u't',
    120088: u'u',
    120089: u'v',
    120090: u'w',
    120091: u'x',
    120092: u'y',
    120120: u'a',
    120121: u'b',
    120123: u'd',
    120124: u'e',
    120125: u'f',
    120126: u'g',
    120128: u'i',
    120129: u'j',
    120130: u'k',
    120131: u'l',
    120132: u'm',
    120134: u'o',
    120138: u's',
    120139: u't',
    120140: u'u',
    120141: u'v',
    120142: u'w',
    120143: u'x',
    120144: u'y',
    120172: u'a',
    120173: u'b',
    120174: u'c',
    120175: u'd',
    120176: u'e',
    120177: u'f',
    120178: u'g',
    120179: u'h',
    120180: u'i',
    120181: u'j',
    120182: u'k',
    120183: u'l',
    120184: u'm',
    120185: u'n',
    120186: u'o',
    120187: u'p',
    120188: u'q',
    120189: u'r',
    120190: u's',
    120191: u't',
    120192: u'u',
    120193: u'v',
    120194: u'w',
    120195: u'x',
    120196: u'y',
    120197: u'z',
    120224: u'a',
    120225: u'b',
    120226: u'c',
    120227: u'd',
    120228: u'e',
    120229: u'f',
    120230: u'g',
    120231: u'h',
    120232: u'i',
    120233: u'j',
    120234: u'k',
    120235: u'l',
    120236: u'm',
    120237: u'n',
    120238: u'o',
    120239: u'p',
    120240: u'q',
    120241: u'r',
    120242: u's',
    120243: u't',
    120244: u'u',
    120245: u'v',
    120246: u'w',
    120247: u'x',
    120248: u'y',
    120249: u'z',
    120276: u'a',
    120277: u'b',
    120278: u'c',
    120279: u'd',
    120280: u'e',
    120281: u'f',
    120282: u'g',
    120283: u'h',
    120284: u'i',
    120285: u'j',
    120286: u'k',
    120287: u'l',
    120288: u'm',
    120289: u'n',
    120290: u'o',
    120291: u'p',
    120292: u'q',
    120293: u'r',
    120294: u's',
    120295: u't',
    120296: u'u',
    120297: u'v',
    120298: u'w',
    120299: u'x',
    120300: u'y',
    120301: u'z',
    120328: u'a',
    120329: u'b',
    120330: u'c',
    120331: u'd',
    120332: u'e',
    120333: u'f',
    120334: u'g',
    120335: u'h',
    120336: u'i',
    120337: u'j',
    120338: u'k',
    120339: u'l',
    120340: u'm',
    120341: u'n',
    120342: u'o',
    120343: u'p',
    120344: u'q',
    120345: u'r',
    120346: u's',
    120347: u't',
    120348: u'u',
    120349: u'v',
    120350: u'w',
    120351: u'x',
    120352: u'y',
    120353: u'z',
    120380: u'a',
    120381: u'b',
    120382: u'c',
    120383: u'd',
    120384: u'e',
    120385: u'f',
    120386: u'g',
    120387: u'h',
    120388: u'i',
    120389: u'j',
    120390: u'k',
    120391: u'l',
    120392: u'm',
    120393: u'n',
    120394: u'o',
    120395: u'p',
    120396: u'q',
    120397: u'r',
    120398: u's',
    120399: u't',
    120400: u'u',
    120401: u'v',
    120402: u'w',
    120403: u'x',
    120404: u'y',
    120405: u'z',
    120432: u'a',
    120433: u'b',
    120434: u'c',
    120435: u'd',
    120436: u'e',
    120437: u'f',
    120438: u'g',
    120439: u'h',
    120440: u'i',
    120441: u'j',
    120442: u'k',
    120443: u'l',
    120444: u'm',
    120445: u'n',
    120446: u'o',
    120447: u'p',
    120448: u'q',
    120449: u'r',
    120450: u's',
    120451: u't',
    120452: u'u',
    120453: u'v',
    120454: u'w',
    120455: u'x',
    120456: u'y',
    120457: u'z',
    120488: u'α',
    120489: u'β',
    120490: u'γ',
    120491: u'δ',
    120492: u'ε',
    120493: u'ζ',
    120494: u'η',
    120495: u'θ',
    120496: u'ι',
    120497: u'κ',
    120498: u'λ',
    120499: u'μ',
    120500: u'ν',
    120501: u'ξ',
    120502: u'ο',
    120503: u'π',
    120504: u'ρ',
    120505: u'θ',
    120506: u'σ',
    120507: u'τ',
    120508: u'υ',
    120509: u'φ',
    120510: u'χ',
    120511: u'ψ',
    120512: u'ω',
    120531: u'σ',
    120546: u'α',
    120547: u'β',
    120548: u'γ',
    120549: u'δ',
    120550: u'ε',
    120551: u'ζ',
    120552: u'η',
    120553: u'θ',
    120554: u'ι',
    120555: u'κ',
    120556: u'λ',
    120557: u'μ',
    120558: u'ν',
    120559: u'ξ',
    120560: u'ο',
    120561: u'π',
    120562: u'ρ',
    120563: u'θ',
    120564: u'σ',
    120565: u'τ',
    120566: u'υ',
    120567: u'φ',
    120568: u'χ',
    120569: u'ψ',
    120570: u'ω',
    120589: u'σ',
    120604: u'α',
    120605: u'β',
    120606: u'γ',
    120607: u'δ',
    120608: u'ε',
    120609: u'ζ',
    120610: u'η',
    120611: u'θ',
    120612: u'ι',
    120613: u'κ',
    120614: u'λ',
    120615: u'μ',
    120616: u'ν',
    120617: u'ξ',
    120618: u'ο',
    120619: u'π',
    120620: u'ρ',
    120621: u'θ',
    120622: u'σ',
    120623: u'τ',
    120624: u'υ',
    120625: u'φ',
    120626: u'χ',
    120627: u'ψ',
    120628: u'ω',
    120647: u'σ',
    120662: u'α',
    120663: u'β',
    120664: u'γ',
    120665: u'δ',
    120666: u'ε',
    120667: u'ζ',
    120668: u'η',
    120669: u'θ',
    120670: u'ι',
    120671: u'κ',
    120672: u'λ',
    120673: u'μ',
    120674: u'ν',
    120675: u'ξ',
    120676: u'ο',
    120677: u'π',
    120678: u'ρ',
    120679: u'θ',
    120680: u'σ',
    120681: u'τ',
    120682: u'υ',
    120683: u'φ',
    120684: u'χ',
    120685: u'ψ',
    120686: u'ω',
    120705: u'σ',
    120720: u'α',
    120721: u'β',
    120722: u'γ',
    120723: u'δ',
    120724: u'ε',
    120725: u'ζ',
    120726: u'η',
    120727: u'θ',
    120728: u'ι',
    120729: u'κ',
    120730: u'λ',
    120731: u'μ',
    120732: u'ν',
    120733: u'ξ',
    120734: u'ο',
    120735: u'π',
    120736: u'ρ',
    120737: u'θ',
    120738: u'σ',
    120739: u'τ',
    120740: u'υ',
    120741: u'φ',
    120742: u'χ',
    120743: u'ψ',
    120744: u'ω',
    120763: u'σ' }

def map_table_b3(code):
    r = b3_exceptions.get(ord(code))
    if r is not None:
        return r
    
    return code.lower()


def map_table_b2(a):
    al = map_table_b3(a)
    b = unicodedata.normalize('NFKC', al)
    bl = []([ map_table_b3(ch) for ch in b ])
    c = unicodedata.normalize('NFKC', bl)


def in_table_c11(code):
    return code == u' '


def in_table_c12(code):
    if unicodedata.category(code) == 'Zs':
        pass
    return code != u' '


def in_table_c11_c12(code):
    return unicodedata.category(code) == 'Zs'


def in_table_c21(code):
    if ord(code) < 128:
        pass
    return unicodedata.category(code) == 'Cc'

c22_specials = set([
    1757,
    1807,
    6158,
    8204,
    8205,
    8232,
    8233,
    65279] + range(8288, 8292) + range(8298, 8304) + range(65529, 65533) + range(119155, 119163))

def in_table_c22(code):
    c = ord(code)
    if c < 128:
        return False
    
    if unicodedata.category(code) == 'Cc':
        return True
    
    return c in c22_specials


def in_table_c21_c22(code):
    if not unicodedata.category(code) == 'Cc':
        pass
    return ord(code) in c22_specials


def in_table_c3(code):
    return unicodedata.category(code) == 'Co'


def in_table_c4(code):
    c = ord(code)
    if c < 64976:
        return False
    
    if c < 65008:
        return True
    
    return ord(code) & 65535 in (65534, 65535)


def in_table_c5(code):
    return unicodedata.category(code) == 'Cs'

c6_set = set(range(65529, 65534))

def in_table_c6(code):
    return ord(code) in c6_set

c7_set = set(range(12272, 12284))

def in_table_c7(code):
    return ord(code) in c7_set

c8_set = set([
    832,
    833,
    8206,
    8207] + range(8234, 8239) + range(8298, 8304))

def in_table_c8(code):
    return ord(code) in c8_set

c9_set = set([
    917505] + range(917536, 917632))

def in_table_c9(code):
    return ord(code) in c9_set


def in_table_d1(code):
    return unicodedata.bidirectional(code) in ('R', 'AL')


def in_table_d2(code):
    return unicodedata.bidirectional(code) == 'L'

